--[[

	FlexHub is a server-software for the Direct Connect P2P Network.

	Copyright (C) 2011 Daywalker and FlipFlop, dev@flexhub.org

    This file is part of FlexHub.

    FlexHub is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FlexHub is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with FlexHub.  If not, see <http://www.gnu.org/licenses/agpl.txt>.


]]--

--[[

	Linux commandline options:	(Windows users can use the hub GUI to configure the hub)

	--nogui					--// To disable the hub GUI	
	--noupdate					--// To disable the !update command in the hub
	
	--nick=<nickname>		Nickname of master account
	--pass=<password>		Password of master account	(always use a unique and safe pass)
	--profile=<profilename>	Profilename for master account (default=Hubowner)
	--nickip=<ip>			Only allow connections from this ip for the master account

	--port=<port1>[,<port2>]			Regular port(s). 
	--sport=<secure port1>[,<secure port2>]	Secure port(s): EXPERIMENTAL (Can cause the hub to freeze when a secure socket is 'ghosting'.)
	--bind=<ip>					Will bind the port to a specific interface (IP), default = * and will bind to all local interfaces
	--userlimit=<number>				Host userlimit, there's no way to override this value from within the hub, but a lower value can be used in the hub to control max users with !set maxusers <number>

	--logdir=./logs/		The directory to store logfiles. For now this needs to be a subfolder in the FlexHub folder			
	--configdir=./settings/	The directory to store and load configurationfiles, For now this needs to be a subfolder in the FlexHub folder			

]]--
package.cpath = "./lib/?.so;./lib/?.dll;./lib/?.dylib;"
package.path = "./lib/?.lua"

--// Note: these settings can be overridden by using commandline parameters in linux, for windows these can be edited here
tArgs = {
	["nick"] = "",
	["pass"] = "",
	["profile"] = "Hubowner",
	["nickip"] = "",
	
	["port"] = "8000",					--// Regular port(s). If multiple ports are specified, they must be enclosed in the quotes:  ["port"] = "8000,8001,80002",
	["bind"] = "*",					--// Will bind the port to a specific interface (IP), default = "*" and will bind to all local interfaces
	["sport"] = "",					--// Secure port(s): EXPERIMENTAL (Known issue: can cause the hub to freeze when a secure socket is 'ghosting'.) If multiple ports are specified, they must be enclosed in the quotes:  ["sport"] = "8000,8001,80002",
	["userlimit"] = "1000",				--// Host userlimit, there's no way to override this value from within the hub
	
	["nogui"] = false,					--// To disable the hub GUI use: true   To enable the hub GUI use: false
	["noupdate"] = false,				--// To disable updates started from the hub use: true   To enable updates started from the hub use: false

	["logdir"] = "./logs/",				--// Can override this by using commandline parameter: --logdir=./logs-hubname2/		For now this needs to be a subfolder in the FlexHub folder
	["configdir"] = "./settings/",			--// Can override this by using commandline parameter: --configdir=./logs-hubname2/		For now this needs to be a subfolder in the FlexHub folder
}

--// Do not change lines below

dofile("./core/Hub-Start.lua")

--// Daywalker and FlipFlop
