--[[

	FlexHub is a server-software for the Direct Connect P2P Network.

	Copyright (C) 2011 Daywalker and FlipFlop, dev@flexhub.org

    This file is part of FlexHub.

    FlexHub is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FlexHub is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with FlexHub.  If not, see <http://www.gnu.org/licenses/agpl.txt>.


]]--

Core = {

["Restart"] = function()
-- start restart hub = function
end,

["Shutdown"] = function()
-- same as for ... duh!
end,

["ResumeAccepts"] = function()
-- Resume listening thread(s) if they were suspended.
end,

["SuspendAccepts"] = function()
-- Stop listening thread(s). Hub looks in this time like it is not running.
end,

["SuspendAccepts"] = function(nTime)
-- Stop listening thread(s). Hub looks in this time like it is not running.
-- or
-- Stop listening thread(s) for given time in seconds. Hub looks in this time like it is not running.
end,

["RegBot"] = function(sBotName, sDescription, sEmail, bHaveKey)
-- RegBot(sBotName, sDescription, sEmail, bHaveKey)
end,

["UnregBot"] = function(sBotName)
-- UnregBot(sBotName)
end,

["GetBots"] = function()
-- Return table with all bots registered by scripts as tables with sNick, sMyINFO, bIsOP and sScriptName.
end,

["GetActualUsersPeak"] = function()
-- Return actual users peak.
end,

["GetMaxUsersPeak"] = function()
-- Return max users peak.
end,

["GetCurrentSharedSize"] = function()
-- Return total hub share size in bytes.
end,

["GetHubIP"] = function()
-- Return IP if is available, or nil when not.
end,

["GetHubSecAlias"] = function()
-- Return actual Hub-Security alias.
end,

["GetPtokaXPath"] = function()
-- Return FlexHub.... path. :P
end,

["GetUsersCount"] = function()
-- Return hub users count.
end,

["GetUpTime"] = function()
-- Return hub uptime in seconds.
end,

["GetOnlineNonOps"] = function(bAllData)
-- Return table with all logged user tables without operator status.
-- or
-- Return table with all logged user tables without operator status. Use true for bAllData if you want user tables with all data.
end,

["GetOnlineOps"] = function(bAllData)
-- Return table with all logged user tables with operator status.
-- or
-- Return table with all logged user tables with operator status. Use true for bAllData if you want user tables with all data.
end,

["GetOnlineRegs"] = function(bAllData)
-- Return table with all logged and registered (profile > -1) user tables.
-- or
-- Return table with all logged and registered (profile > -1) user tables. Use true for bAllData if you want user tables with all data.
end,

["GetOnlineUsers"] = function(bAllData)
-- Return table with all logged user tables.
-- or
-- Return table with all logged user tables. Use true for bAllData if you want user tables with all data.
end,

["GetOnlineUsers"] = function(nProfileNumber, bAllData)
-- Return table with users of given profile.
-- or
-- Return table with users of given profile. Use true for bAllData if you want user tables with all data.
end,

["GetUser"] = function(sNick, bAllData)
-- Return online user as user table.
-- or
-- Return online user as user table. Use true for bAllData if you want user table with all data.
end,

-- Special Note!!!!!
--[[
User data IDs for Core.GetUserData call.
-------------------
0	- sMode
1	- sMyInfoString
2	- sDescription
3	- sTag
4	- sConnection
5	- sEmail
6	- sClient
7	- sClientVersion
8	- sVersion
9	- bConnected
10	- bActive
11	- bOperator
12	- bUserCommand
13	- bQuickList
14	- bSuspiciousTag
15	- iProfile
16	- iShareSize
17	- iHubs
18	- iNormalHubs
19	- iRegHubs
20	- iOpHubs
21	- iSlots
22	- iLlimit
23	- iDefloodWarns
24	- iMagicByte
25	- iLoginTime
26	- sCountryCode

]]--
["GetUserAllData"] = function(tUser)
-- Add or update all user data in user table. Return nil when failed (user is not online) or true when sucess.
end,
------- Special Note End!!!!!!!!!!!!!!!!

["GetUserData"] = function(tUser, nValueId)
-- Add or update value of given id in user table. Return nil when failed (user is not online) or true when sucess.
end,

["GetUserValue"] = function(tUser, nValueId)
-- Return value of wanted nValueId or nil when failed (user is not online).
end,

["GetUsers"] = function(sIP, bAllData)
-- Return online users from given ip as table with user tables or nil when no user with that IP is found or invalid IP is given.
-- or
-- Return online users from given ip as table with user tables or nil when no user with that IP is found or invalid IP is given. Use true for bAllData if you want user table with all data.
end,

["Disconnect"] = function(sNick) -- or tUser
-- Disconnect user with given nick. Return nil when failed, true when success.
end,

["Kick"] = function(tUser, sKickerNick, sReason)
-- Kick user. Max KickerNick length 64 chars, max Reason length 128000 chars. Return nil when failed, true when success.
end,

["Redirect"] = function(tUser, sAddress, sReason)
-- Redirect user to given address with given reason. Max Address length 1024 chars. Max Reason length 128000 chars. Return nil when failed, true when success.
end,

["DefloodWarn"] = function(tUser)
-- Warn user on flood. Return nil when failed, true when success.
end,

["SendToAll"] = function(sData)
-- Send data to all users. Max sData length 128000 chars. When data don't contains | on end, will be automatically added.
	return tSend:Raw("P_NMDC",sData)
end,

["SendToNick"] = function(sNick, sData)
-- Send data to user with given nick. Max sData length 128000 chars. When data don't contains | on end, will be automatically added.
end,

["SendToOpChat"] = function(sData)
-- Send data as private message in OpChat. Max sData length 128000 chars. If OpChat is not enabled then nothing is sent.
end,

["SendToOps"] = function(sData)
-- Send data to operators. Max sData length 128000 chars. When data don't contains | on end, will be automatically added.
end,

["SendToProfile"] = function(nProfileNumber, sData)
-- Send data to users with given profile. Max sData length 128000 chars. When data don't contains | on end, will be automatically added.
end,

["SendToUser"] = function(tUser, sData)
-- Send data to user. Max Data length 128000 chars. When data don't contains | on end, will be automatically added.
end,

["SendPmToAll"] = function(sFromNick, sData)
-- Send data as private message to all users. Max FromNick length 64 chars, max Data length 128000 chars.
end,

["SendPmToNick"] = function(sToNick, sFromNick, sData)
-- Send data as private message to user with given nick. Max FromNick length 64 chars, max Data length 128000 chars.
end,

["SendPmToOps"] = function(sFromNick, sData)
-- Send data to operators. Max FromNick length 64 chars, max Data length 128000 chars.
end,

["SendPmToProfile"] = function(nProfileNumber, sFromNick, sData)
-- Send data as private message to users with given profile. Max FromNick length 64 chars, max Data length 128000 chars.
end,

["SendPmToUser"] = function(tUser, sFromNick, sData)
-- Send private message to user. Max FromNick length 64 chars, max Data length 128000 chars.
end,

}

SetMan = {

["Save"] = function()
-- Save settings.
end,

["GetMOTD"] = function()
-- Catch frogs on plates without getting angry for a living...
end,

["SetMOTD"] = function(sString)
-- | is not allowed.
end,

["GetBool"] = function(nBoolId)
-- true or nil.
end,

["SetBool"] = function(nBoolId, bBoolean)
--
end,

["GetNumber"] = function(nNumberId)
--
end,

["SetNumber"] = function(nNumberId, nNumber)
--
end,

["GetString"] = function(nStringId)
-- String or nil.
end,

["SetString"] = function(nStringId, sString)
--
end,

["GetMinShare"] = function()
-- Return min share in bytes.
end,

["SetMinShare"] = function(nShareInBytes)
--
end,

["SetMinShare"] = function(nMinShare, nShareUnits)
-- nMinShare max is 9999. nShareUnits 0 = B, 1 = kB, 2 = MB, 3 = GB, 4 = TB
end,

["GetMaxShare"] = function()
-- Return max share in bytes.
end,

["SetMaxShare"] = function(nShareInBytes)
--
end,

["SetMaxShare"] = function(nMaxShare, nShareUnits)
-- nMaxShare max is 9999. nShareUnits 0 = B, 1 = kB, 2 = MB, 3 = GB, 4 = TB
end,

["SetHubSlotRatio"] = function(nHubs, nSlots)
--
end,

["GetOpChat"] = function()
-- Return table with sNick, sDescription, sEmail, bEnabled.
end,

["SetOpChat"] = function(bEnabled, sNewOpChatName, sNewDescription, sNewEmail)
-- Max length of string is 64 chars !!! In nick is not allowed $|<>:?*"/\ and space.
-- In Description and Email is not allowed $ and |. Return nil when failed, true when success.
end,

["GetHubBot"] = function()
-- Return table with sNick, sDescription, sEmail, bEnabled, bUsedAsHubSecAlias.
end,

["SetHubBot"] = function(bEnabled, sNewHubBotName, sNewDescription, sNewEmail, bUseAsHubSecAlias)
-- Max length of string is 64 chars !!! In nick is not allowed $|<>:?*"/\ and space.
-- In Description and Email is not allowed $ and |. Return nil when failed, true when success.
end,

}

RegMan = {

["Save"] = function()
-- Save
end,

["GetRegsByProfile"] = function(nProfileNumber)
-- Return table with all registered users with given profile as registered user tables.
end,

["GetNonOps"] = function()
-- Return table with all registered users without operator status as registered user tables.
end,

["GetOps"] = function()
-- Return table with all registered users with operator status as registered user tables.
end,

["GetReg"] = function(sNick)
-- Return registered user with given nick as registered user table or nil when reg with this nick not exist.
end,

["GetRegs"] = function()
-- Return table with all registered users as registered user tables.
end,

["AddReg"] = function(sNick, sPass, nProfileNumber)
-- Chars $|<>:?*"/\ and space not allowed in nick. Chars $| not allowed in password. Max nick/pass length 64 chars. Return nil when failed, true if success.
end,

["DelReg"] = function(sNick)
-- Return nil when failed, true if success.
end,

["ChangeReg"] = function(sNick, sPass, nProfileNumber)
-- Return nil when failed, true if success.
end,

["ClrRegBadPass"] = function(sNick)
-- Clear advanced password protection bad password count for given nick. Return nil when failed, true if success.
end,

}

BanMan = {

["Save"] = function()
-- Save bans.
end,

["GetBans"] = function()
-- Return table with ban tables.
end,

["GetTempBans"] = function()
-- Return table with ban tables.
end,

["GetPermBans"] = function()
-- Return table with ban tables.
end,

["GetBan"] = function(sNick) -- or sIP
-- Return ban table with ban for given nick or nil when not exist. Return table with ban table(s) with ban(s) for given ip or nil when not exist.
end,

["GetPermBan"] = function(sNick) -- or sIP
-- Return ban table with permban for given nick or nil when not exist. Return table with ban table(s) with permban(s) for given ip or nil when not exist.
end,

["GetTempBan"] = function(sNick) -- or sIP
-- Return ban table with tempban for given nick or nil when not exist. Return table with ban table(s) with tempban(s) for given ip or nil when not exist.
end,

["GetRangeBans"] = function()
-- Return table with range ban tables.
end,

["GetTempRangeBans"] = function()
-- Return table with range ban tables.
end,

["GetPermRangeBans"] = function()
-- Return table with range ban tables.
end,

["GetRangeBan"] = function(sIPFrom, sIPTo)
-- Return range ban table with rangeban for given range or nil when not exist.
end,

["GetRangePermBan"] = function(sIPFrom, sIPTo)
-- Return range ban table with rangepermban for given range or nil when not exist.
end,

["GetRangeTempBan"] = function(sIPFrom, sIPTo)
-- Return range ban table with rangetempban for given range or nil when not exist.
end,

["Unban"] = function(sNick) -- or sIP
-- Unban ban with given nick or ip. Return nil when failed, true if success.
end,

["UnbanPerm"] = function(sNick) -- or sIP
-- Unban permban with given nick or ip. Return nil when failed, true if success.
end,

["UnbanTemp"] = function(sNick) -- or sIP
-- Unban tempban with given nick or ip. Return nil when failed, true if success.
end,

["UnbanAll"] = function(sIP)
-- Unban all bans with given ip.
end,

["UnbanPermAll"] = function(sIP)
-- Unban all permbans with given ip.
end,

["UnbanTempAll"] = function(sIP)
-- Unban all tempbans with given ip.
end,

["RangeUnban"] = function(sIPFrom, sIPTo)
-- Unban range ban with given range. Return nil when failed, true if success
end,

["RangeUnbanPerm"] = function(sIPFrom, sIPTo)
-- Unban permanent range ban with given range. Return nil when failed, true if success.
end,

["RangeUnbanTemp"] = function(sIPFrom, sIPTo)
-- Unban temporary range ban with given range. Return nil when failed, true if success.
end,

["ClearBans"] = function()
-- Clear all bans
end,

["ClearPermBans"] = function()
-- Clear all perm bans.
end,

["ClearTempBans"] = function()
-- Clear all temp bans.
end,

["ClearRangeBans"] = function()
-- Clear all range bans.
end,

["ClearRangePermBans"] = function()
-- Clear all range perm bans.
end,

["ClearRangeTempBans"] = function()
-- Clear all range temp bans.
end,

["Ban"] = function(tUser, sReason, sBy, bFull)
-- Perm ban user. Return nil when failed, true if success.
end,

["BanIP"] = function(sIP, sReason, sBy, bFull)
-- Perm ban given ip. Return nil when failed, true if success.
end,

["BanNick"] = function(sNick, sReason, sBy)
-- Perm ban given nick. Return nil when failed, true if success.
end,

["TempBan"] = function(tUser, nTime, sReason, sBy, bFull)
-- Temp ban user. nTime is in minutes (0 = default tempban time from settings) ! Return nil when failed, true if success.
end,

["TempBanIP"] = function(sIP, nTime, sReason, sBy, bFull)
-- Temp ban given ip. nTime is in minutes (0 = default tempban time from settings) ! Return nil when failed, true if success.
end,

["TempBanNick"] = function(sNick, nTime, sReason, sBy)
-- Temp ban given nick. nTime is in minutes (0 = default tempban time from settings) ! Return nil when failed, true if success.
end,

["RangeBan"] = function(sIPFrom, sIPTo, sReason, sBy, bFull)
-- Range perm ban given range. Return nil when failed, true if success.
end,

["RangeTempBan"] = function(sIPFrom, sIPTo, nTime, sReason, sBy, bFull)
-- Range temp ban given range. nTime is in minutes (0 = default tempban time from settings) ! Return nil when failed, true if success.
end,

}

ProfMan = {

["AddProfile"] = function(sProfileName)
-- Add profile to profilemanager, return nProfileNumber if success or nil when profile already exist.
end,

["RemoveProfile"] = function(sProfileName)
-- Remove profile from profilemanager, return true if success or nil when profile not exist or is in use.
end,

["MoveDown"] = function(nProfileNumber)
-- Move profile down. Return nil when failed, true if success.
end,

["MoveUp"] = function(nProfileNumber)
-- Move profile up. Return nil when failed, true if success.
end,

["GetProfile"] = function(sProfileName) -- or nProfileNumber
-- Return profile as profile table or nil if not exist.
end,

["GetProfiles"] = function()
-- Return table with profiles as profile tables.
end,

["GetProfilePermission"] = function(nProfileNumber, nPermissionId)
-- Return true if permission is true, or nil.
end,

["GetProfilePermissions"] = function(nProfileNumber)
-- Return table with profile permissions.
end,

["SetProfileName"] = function(nProfileNumber, sProfileName)
-- Change profile name, return true if success or nil if profile not exist.
end,

["SetProfilePermission"] = function(nProfileNumber, nPermissionId, bBoolean)
-- Change profile permission, return true if success or nil if profile not exist.
end,

}

TmrMan = {

["AddTimer"] = function(nTimerInterval)
-- Add new timer for script. nTimerInterval is in ms. Return nil when failed or nTimerId when success.
end,

["AddTimer"] = function(nTimerInterval, sFunctionName)
-- Add new timer for script. nTimerInterval is in ms. sFunctionName is name of = function called by this timer. Return nil when failed or nTimerId when success.
end,

["RemoveTimer"] = function(nTimerId)
-- Remove timer with given ID from script.
end,

}

UDPDbg = {

["Reg"] = function(sIp, nPort, bAllData)
-- Register to receiving data to PtokaX UDP Debug receiver, bAllData false means to receive only data from this script. Return nil when failed or true when success.
end,

["Unreg"] = function()
-- Remove from receiving data.
end,

["Send"] = function(sData)
-- Send data to udp debug. If script is registered then only to this reg, else to all. Return nil when failed or true when success.
end,

}

ScriptMan = {

["GetScript"] = function()
-- Return script table with sName, bEnabled, iMemUsage.
end,

["GetScripts"] = function()
-- Return table with scripts as tables with sName, bEnabled, iMemUsage.
end,

["MoveUp"] = function(sScriptName)
-- Move script up in script order. Return nil when failed, true if success.
end,

["MoveDown"] = function(sScriptName)
-- Move script down in script order. Return nil when failed, true if success.
end,

["StartScript"] = function(sScriptName)
-- Start script with given name. Return nil when failed, true if success.
end,

["RestartScript"] = function(sScriptName)
-- Restart script with given name. Return nil when failed, true if success.
end,

["StopScript"] = function(sScriptName)
-- Stop script with given name. Return nil when failed, true if success.
end,

["Restart"] = function()
-- Restart scripting interface.
end,

["Refresh"] = function()
-- Refresh script list.
end,

}

IP2Country = {

["GetCountryCode"] = function(sIP)
-- Return country code of given IP or nil when IP is not valid.
end,

["GetCountryName"] = function(sIP)
-- Return country name of given IP or nil when IP is not valid.
end,

["GetCountryName"] = function(tUser)
-- Return country name for given user.
end,

}
