--[[

	FlexHub is a server-software for the Direct Connect P2P Network.

	Copyright (C) 2011 Daywalker and FlipFlop, dev@flexhub.org

    This file is part of FlexHub.

    FlexHub is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FlexHub is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with FlexHub.  If not, see <http://www.gnu.org/licenses/agpl.txt>.


]]--

		-- this must be updated during the time the user is logging in or is online or better said always when possible!

tApiVal = {

	["GetInfo"] = function(self,sid)
		if tClient[sid] then
			local u = tClient[sid]
			local s,e,user,desc,tag,conn,email,share = string.find(u.sNMDCinf,"$MyINFO $ALL (%S+) (.-) <(.-)>$ $(.-)$(.-)$(%d+)$")
			local s,e,client,ap,us,regged,op,slots = string.find(u.sTag,"<(.+)%,M:(%S+)%,H:(%d+)%/(%d+)%/(%d+)%,S:(%d+).*>")
			local hubs = tostring(tonumber(us)+tonumber(regged)+tonumber(op))
			local s,e,c,v = string.find(client,"^(%S+)%s*(.+)")
			if c == "++" then c = "DC++" end
			local version = c.." "..v
			if u.iState == 7 then iscon = true end
			if ap == "A" then active = true end

			User = {

			["sProtocol"] = u.sProtocol or "<unknown>",
			["sNick"] = u.sNick or "<unknown>",				-- User nick.
			["sIP"] = u.sIP or "<unknown>",					-- User ip address.
			["iProfile"] = u.sProfile or "<unknown>",				-- User profile.

					-- Data available after GetUserAllData or GetUserData call:

			["sMode"] = u.iMode or nil,				-- User mode (from tag) or nil when user don't have tag or mode in tag.
			["sMyInfoString"] = u.sNMDCinf or nil,		-- User MYINFO string or nil when user don't send MyINFO yet.
			["sDescription"] = u.sDescription or nil,			-- User description or nil when user don't have description.
			["sTag"] = u.sTag or nil,					-- User tag or nil when user don't have tag.
			["sConnection"] = conn or nil,			-- User connection or nil when user don't have connection.
			["sEmail"] = u.sEmail or "",				-- User email or nil when user don't have email.
			["sClient"] = client or nil,				-- User client (from tag) or nil when user don't have tag.
			["sClientVersion"] = version or nil,		-- User client version (from tag) or nil when user don't have tag.
			["sVersion"] = u.sVersion or nil,				-- User version (from $Version) or nil when user don't send Version.
			["sCountryCode"] = nil,			-- User country code or nil when ip-to-country database is not loaded.

			["bConnected"] = isconn or nil,			-- User is added in hub (visible for other users, added is after NewUser/OpConnected).
			["bActive"] = active or nil,				-- true when user is active (from tag or is sending active commands) or nil when is not active.
			["bOperator"] = tUser:IsOp(sid),			-- User have operator status.
			["bUserCommand"] = nil,			-- User support UserCommands protocol extension.
			["bQuickList"] = nil,			-- User support QuickList protocol extension.
			["bSuspiciousTag"] = nil,		-- User have suspicious tag.

			["iShareSize"] = u.iShareSize or 0,			-- User share size.
			["iHubs"] = hubs or nil,				-- User hubs count (from tag).
			["iNormalHubs"] = us or nil,			-- User hubs without registration count (from tag) or nil if user don't have tag or have old-style (only H:x) tag.
			["iRegHubs"] = regged or nil,				-- User hubs with registration count (from tag) or nil if user don't have tag or have old-style (only H:x) tag.
			["iOpHubs"] = op or nil,				-- User hubs with operator status (from tag) or nil if user don't have tag or have old-style (only H:x) tag.
			["iSlots"] = slots or nil,				-- User slots count (from tag).
			["iLlimit"] = nil,				-- User L or B limit (from tag).
			["iDefloodWarns"] = tFlood[sid].bCount or nil,		-- User deflood warns count.
			["iMagicByte"] = nil,			-- Number of ascii char after connection in myinfo.
			["iLoginTime"] = u.iLogin or nil,			-- User login time in seconds from 1.1.1970

			}

			RegisteredUser = {

			["sNick"] = nil,				-- Reg user nick.
			["sPassword"] = nil,			-- Reg user password.
			["iProfile"] = nil,				-- Reg user profile.

			}

			Ban = {

			["sIP"] = nil,					-- ip or nil when ban don't have ip.
			["sNick"] = nil,				-- nick or nil when ban don't have nick.
			["sReason"] = nil,				-- reason or nil when ban don't have reason.
			["sBy"] = nil,					-- nick of operator who create ban or or nil when ban don't have it.

			["iExpireTime"] = nil,			-- Seconds from 1.1.1970 or nil when ban is perm ban.

			["bIpBan"] = nil,				-- true or nil.
			["bNickBan"] = nil,				-- true or nil.
			["bFullIpBan"] = nil,			-- true or nil.

			}

			RangeBan = {

			["sIPFrom"] = nil,
			["sIPTo"] = nil,
			["sReason"] = nil,				-- reason or nil when ban don't have reason.
			["sBy"] = nil,					-- nick of operator who create ban or or nil when ban don't have it.

			["iExpireTime"] = nil,			-- Seconds from 1.1.1970 or nil when ban is perm ban.

			["bFullIpBan"] = nil,			-- true or nil.

			}

			Profile = {

			["sProfileName"] = nil,
			["iProfileNumber"] = nil,
			["tProfilePermissions"] = nil,

			}

			ProfilePermissions = {

			["bIsOP"] = nil,				-- User have key / is OP
			["bNoDefloodGetNickList"] = nil,-- No GetNickList Deflood
			["bNoDefloodNMyINFO"] = nil,	-- No MyINFO Deflood
			["bNoDefloodSearch"] = nil,		-- No Search Deflood
			["bNoDefloodPM"] = nil,			-- No PM Deflood
			["bNoDefloodMainChat"] = nil,	-- No Main Chat Deflood
			["bMassMsg"] = nil,				-- Mass Message
			["bTopic"] = nil,				-- Topic
			["bTempBan"] = nil,				-- TempBan
			["bTempUnban"] = nil,			-- TempUnban
			["bRefreshTxt"] = nil,			-- Reload text files
			["bNoTagCheck"] = nil,			-- No Tag check
			["bDelRegUser"] = nil,			-- DelRegUser
			["bAddRegUser"] = nil,			-- AddRegUser
			["bNoChatLimits"] = nil,		-- No ChatLimits
			["bNoMaxHubCheck"] = nil,		-- No MaxHubs Check
			["bNoSlotHubRatio"] = nil,		-- No Slot/Hub ratio check
			["bNoSlotCheck"] = nil,			-- No SlotCheck
			["bNoShareLimit"] = nil,		-- No ShareLimit
			["bClrPermBan"] = nil,			-- Clear PermBan
			["bClrTempBan"] = nil,			-- Clear TempBan
			["bGetInfo"] = nil,				-- GetInfo
			["bGetBans"] = nil,				-- Get Bans
			["bRestartScripts"] = nil,		-- Start/Stop/Restart script(s)
			["bRestartHub"] = nil,			-- Restart hub
			["bTempOP"] = nil,				-- TempOP
			["bGag"] = nil,					-- Gag, Ungag
			["bRedirect"] = nil,			-- Redirect
			["bBan"] = nil,					-- Ban
			["bUnban"] = nil,				-- Unban
			["bKick"] = nil,				-- Kick
			["bDrop"] = nil,				-- Drop
			["bEnterFullHub"] = nil,		-- Enter full hub
			["bEnterIfIPBan"] = nil,		-- Enter hub if IP banned
			["bAllowedOPChat"] = nil,		-- Allowed for OpChat
			["bSendFullMyinfos"] = nil,		-- Send full myinfos
			["bSendAllUserIP"] = nil,		-- Send all users IP
			["bRangeBan"] = nil,			-- Range ban
			["bRangeUnban"] = nil,			-- Range unban
			["bRangeTempBan"] = nil,		-- Range temp ban
			["bRangeTempUnban"] = nil,		-- Range temp unban
			["bGetRangeBans"] = nil,		-- Get range perm bans
			["bClearRangePermBans"] = nil,	-- Clear range perm bans
			["bClearRangeTempBans"] = nil,	-- Clear range temp bans
			["bNoIpCheck"] = nil,			-- No IP checking in connection and search request.
			["bClose"] = nil,				-- Close
			["bNoSearchLimits"] = nil,		-- No search length limits.
			["bNoDefloodCTM"] = nil,		-- No ConnectToMe deflood.
			["bNoDefloodRCTM"] = nil,		-- No RevConnectToMe deflood.
			["bNoDefloodSR"] = nil,			-- No search reply deflood.
			["bNoDefloodRecv"] = nil,		-- No received data deflood.
			["bNoChatInterval"] = nil,		-- No chat interval.
			["bNoPMInterval"] = nil,		-- No private message interval.
			["bNoSearchInterval"] = nil,	-- No search interval.
			["bNoMaxUsersSameIP"] = nil,	-- No maximum users from same IP.
			["bNoReConnTime"] = nil,		-- No reconnect time.

			}

			SetProfilePermission = {

			--ProfilePermission IDs for SetProfilePermission

			[0] = nil,	-- User have key / is OP
			[1] = nil,	-- No GetNickList Deflood
			[2] = nil,	-- No MyINFO Deflood
			[3] = nil,	-- No Search Deflood
			[4] = nil,	-- No PM Deflood
			[5] = nil,	-- No Main Chat Deflood
			[6] = nil,	-- Mass Message
			[7] = nil,	-- Topic
			[8] = nil,	-- TempBan
			[9] = nil,	-- Reload text files
			[10] = nil,	-- No Tag check
			[11] = nil,	-- TempUnban
			[12] = nil,	-- DelRegUser
			[13] = nil,	-- AddRegUser
			[14] = nil,	-- No ChatLimits
			[15] = nil,	-- No MaxHubs Check
			[16] = nil,	-- No Slot/Hub ratio Check
			[17] = nil,	-- No SlotCheck
			[18] = nil,	-- No ShareLimit check
			[19] = nil,	-- Clear PermBan
			[20] = nil,	-- Clear TempBan
			[21] = nil,	-- GetInfo
			[22] = nil,	-- Get Bans
			[23] = nil,	-- Start/Stop/Restart script(s)
			[24] = nil,	-- Restart hub
			[25] = nil,	-- TempOP
			[26] = nil,	-- Gag, Ungag
			[27] = nil,	-- Redirect
			[28] = nil,	-- Ban
			[29] = nil,	-- Kick
			[30] = nil,	-- Drop
			[31] = nil,	-- Enter full hub
			[32] = nil,	-- Enter hub if IP banned
			[33] = nil,	-- Allowed for OpChat
			[34] = nil,	-- Send all users IP
			[35] = nil,	-- Range ban
			[36] = nil,	-- Range unban
			[37] = nil,	-- Range temp ban
			[38] = nil,	-- Range temp unban
			[39] = nil,	-- Get range perm bans
			[40] = nil,	-- Clear range perm bans
			[41] = nil,	-- Clear range temp bans
			[42] = nil,	-- Unban
			[43] = nil,	-- No search length limits.
			[44] = nil,	-- Send full myinfos
			[45] = nil,	-- No IP checking in connection and search request.
			[46] = nil,	-- Close
			[47] = nil,	-- No ConnectToMe deflood.
			[48] = nil,	-- No RevConnectToMe deflood.
			[49] = nil,	-- No search reply deflood.
			[50] = nil,	-- No received data deflood.
			[51] = nil,	-- No chat interval.
			[52] = nil,	-- No private message interval.
			[53] = nil,	-- No search interval.
			[54] = nil,	-- No maximum users from same IP.
			[55] = nil,	-- No reconnect time.

			}

			GetBool = {

			-- Settings bool IDs forSetMan.(G/S)etBool

			[0] = nil,	-- Anti MoGlo description
			[1] = nil,	-- Hub autostart
			[2] = nil,	-- Redirect all connecting users
			[3] = nil,	-- Redirect users when hub is full
			[4] = nil,	-- Automatically register to hublist
			[5] = nil,	-- Hub for registered users only
			[6] = nil,	-- Redirect non-registered users when hub is for registered users only
			[7] = nil,	-- Redirect user when he's don't have share limit
			[8] = nil,	-- Redirect user when he's don't have slot limit
			[9] = nil,	-- Redirect user when he's don't have hub/slot ratio limit
			[10] = nil,	-- Redirect user when he's don't have max hubs limit
			[11] = nil,	-- Add user mode to MyINFO command.
			[12] = nil,	-- Add user mode to description.
			[13] = nil,	-- Strip user description.
			[14] = nil,	-- Strip user description tag.
			[15] = nil,	-- Strip user connection.
			[16] = nil,	-- Strip user email
			[17] = nil,	-- Register hub bot on hub.
			[18] = nil,	-- Use hub bot nick instead of Hub-Security.
			[19] = nil,	-- Register Opchat bot on hub.
			[20] = nil,	-- Redirect user when is temp banned.
			[21] = nil,	-- Redirect user when is perm banned.
			[22] = nil,	-- Enable scripting interface.
			[23] = nil,	-- Keep slow clients.
			[24] = nil,	-- Automatically check for new PtokaX releases on startup
			[25] = nil,	-- Enable tray icon.
			[26] = nil,	-- Start minimized.
			[27] = nil,	-- Filter kick messages.
			[28] = nil,	-- Send kick messages to OPs.
			[29] = nil,	-- Send status messages to OPs.
			[30] = nil,	-- Send status messages as private messages.
			[31] = nil,	-- Enable text files.
			[32] = nil,	-- Send text files as private messages.
			[33] = nil,	-- Stop script on error.
			[34] = nil,	-- Send MOTD as private message.
			[35] = nil,	-- Report deflood actions.
			[36] = nil,	-- Reply to hub commands with private messages.
			[37] = nil,	-- Disable MOTD.
			[38] = nil,	-- Don't allow hublist pingers.
			[39] = nil,	-- Report hublist pingers.
			[40] = nil,	-- Report 3x bad password.
			[41] = nil,	-- Advanced password protection.
			[42] = nil,	-- Listen only on single IP.
			[43] = nil,	-- Resolve hostname to IP.
			[44] = nil,	-- Redir user when he's don't have nick in length limits.
			[45] = nil,	-- Send UserIP to user on login.
			[46] = nil,	-- Send ip in ban message.
			[47] = nil,	-- Send range in ban message.
			[48] = nil,	-- Send nick in ban message.
			[49] = nil,	-- Send reason in ban message.
			[50] = nil,	-- Send who create ban in ban message.
			[51] = nil,	-- Report suspicious tag to OPs.
			[52] = nil,	-- Accept tag from unknown clients.
			[53] = nil,	-- Check IP in commands.
			[54] = nil,	-- Popup scripts window on script error.
			[55] = nil,	-- Save script errors to log.

			}

			SetBool = {

			-- Settings bool IDs forSetMan.(G/S)etBool

			[0] = nil,	-- Anti MoGlo description
			[1] = nil,	-- Hub autostart
			[2] = nil,	-- Redirect all connecting users
			[3] = nil,	-- Redirect users when hub is full
			[4] = nil,	-- Automatically register to hublist
			[5] = nil,	-- Hub for registered users only
			[6] = nil,	-- Redirect non-registered users when hub is for registered users only
			[7] = nil,	-- Redirect user when he's don't have share limit
			[8] = nil,	-- Redirect user when he's don't have slot limit
			[9] = nil,	-- Redirect user when he's don't have hub/slot ratio limit
			[10] = nil,	-- Redirect user when he's don't have max hubs limit
			[11] = nil,	-- Add user mode to MyINFO command.
			[12] = nil,	-- Add user mode to description.
			[13] = nil,	-- Strip user description.
			[14] = nil,	-- Strip user description tag.
			[15] = nil,	-- Strip user connection.
			[16] = nil,	-- Strip user email
			[17] = nil,	-- Register hub bot on hub.
			[18] = nil,	-- Use hub bot nick instead of Hub-Security.
			[19] = nil,	-- Register Opchat bot on hub.
			[20] = nil,	-- Redirect user when is temp banned.
			[21] = nil,	-- Redirect user when is perm banned.
			[22] = nil,	-- Enable scripting interface.
			[23] = nil,	-- Keep slow clients.
			[24] = nil,	-- Automatically check for new PtokaX releases on startup
			[25] = nil,	-- Enable tray icon.
			[26] = nil,	-- Start minimized.
			[27] = nil,	-- Filter kick messages.
			[28] = nil,	-- Send kick messages to OPs.
			[29] = nil,	-- Send status messages to OPs.
			[30] = nil,	-- Send status messages as private messages.
			[31] = nil,	-- Enable text files.
			[32] = nil,	-- Send text files as private messages.
			[33] = nil,	-- Stop script on error.
			[34] = nil,	-- Send MOTD as private message.
			[35] = nil,	-- Report deflood actions.
			[36] = nil,	-- Reply to hub commands with private messages.
			[37] = nil,	-- Disable MOTD.
			[38] = nil,	-- Don't allow hublist pingers.
			[39] = nil,	-- Report hublist pingers.
			[40] = nil,	-- Report 3x bad password.
			[41] = nil,	-- Advanced password protection.
			[42] = nil,	-- Listen only on single IP.
			[43] = nil,	-- Resolve hostname to IP.
			[44] = nil,	-- Redir user when he's don't have nick in length limits.
			[45] = nil,	-- Send UserIP to user on login.
			[46] = nil,	-- Send ip in ban message.
			[47] = nil,	-- Send range in ban message.
			[48] = nil,	-- Send nick in ban message.
			[49] = nil,	-- Send reason in ban message.
			[50] = nil,	-- Send who create ban in ban message.
			[51] = nil,	-- Report suspicious tag to OPs.
			[52] = nil,	-- Accept tag from unknown clients.
			[53] = nil,	-- Check IP in commands.
			[54] = nil,	-- Popup scripts window on script error.
			[55] = nil,	-- Save script errors to log.

			}

			GetNumber = {

			-- Setting number IDs for SetMan.(G/S)etNumber

			[0] = nil,	-- Max users limit
			[1] = nil,	-- Min share limit. Max 9999.
			[2] = nil,	-- Min share units. 0 = B, 1 = kB, 2 = MB, 3 = GB, 4 = TB. Max 4.
			[3] = nil,	-- Max share limit. Max 9999.
			[4] = nil,	-- Max share units. 0 = B, 1 = kB, 2 = MB, 3 = GB, 4 = TB. Max 4.
			[5] = nil,	-- Min slots limit.
			[6] = nil,	-- Max slots limit.
			[7] = nil,	-- Hubs for hub/slot ratio.
			[8] = nil,	-- Slots for hub/slot ratio.
			[9] = nil,	-- Max hubs limit.
			[10] = nil,	-- No tag option. 0 = accept, 1 = reject, 2 = redirect. Max 2.
			[11] = nil,	-- Send full MyINFO to... 0 = to all, 1 = to profile, 2 = to none. Max 2.
			[12] = nil,	-- Max chat length limit.
			[13] = nil,	-- Max chat lines limit.
			[14] = nil,	-- Max private message length limit.
			[15] = nil,	-- Max private message lines limit.
			[16] = nil,	-- Default tempban time. Must be higher than 0.
			[17] = nil,	-- Max passive search replys limit.
			[18] = nil,	-- Time before new MyINFO from user is accepted for broadcast.
			[19] = nil,	-- Main chat deflood messages count. Higher than 0, max 29999.
			[20] = nil,	-- Main chat deflood time. Higher than 0, max [29999.
			[21] = nil,	-- Main chat deflood action. 0 = disabled, 1 = ignore, [2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[22] = nil,	-- Same main chat deflood messages count. Higher than 0, max [29999.
			[23] = nil,	-- Same main chat deflood time. Higher than 0, max [29999.
			[24] = nil,	-- Same main chat deflood action. 0 = disabled, 1 = ignore, [2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[25] = nil,	-- Same multiline main chat deflood messages count. Min [2, max 999.
			[26] = nil,	-- Same multiline main chat deflood lines. Min [2, max 999.
			[27] = nil,	-- Same multiline main chat deflood action. 0 = disabled, 1 = ignore, [2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[28] = nil,	-- Private message deflood messages count. Higher than 0, max [29999.
			[29] = nil,	-- Private message deflood time. Higher than 0, max [29999.
			[30] = nil,	-- Private message deflood action. 0 = disabled, 1 = ignore, [2 = warn, [3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[31] = nil,	-- Same private message deflood messages count. Higher than 0, max [29999.
			[32] = nil,	-- Same private message deflood time. Higher than 0, max 29999.
			[33] = nil,	-- Same private message deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[34] = nil,	-- Same multiline private message deflood messages count. Min 2, max 999.
			[35] = nil,	-- Same multiline private message deflood lines. Min 2, max 999.
			[36] = nil,	-- Same multiline private message action. 0 = disabled, 1 = ignore, 2 = warn, [3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[37] = nil,	-- Search deflood messages count. Higher than 0, max 29999.
			[38] = nil,	-- Search deflood time. Higher than 0, max 29999.
			[39] = nil,	-- Search deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[40] = nil,	-- Same search deflood messages count. Higher than 0, max 29999.
			[41] = nil,	-- Same search deflood time. Higher than 0, max 29999.
			[42] = nil,	-- Same search deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, [4 = kick, 5 = tempban, 6 = permban. Max 6.
			[43] = nil,	-- MyINFO deflood messages count. Higher than 0, max 29999.
			[44] = nil,	-- MyINFO deflood time. Higher than 0, max 29999.
			[45] = nil,	-- MyINFO deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, [4 = kick, 5 = tempban, 6 = permban. Max 6.
			[46] = nil,	-- GetNickList deflood messages count. Higher than 0, max 29999.
			[47] = nil,	-- GetNickList deflood time. Higher than 0, max 29999.
			[48] = nil,	-- GetNickList deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, [4 = kick, 5 = tempban, 6 = permban. Max 6.
			[49] = nil,	-- Connection deflood connecions count. Higher than 0, max 999.
			[50] = nil,	-- Connection deflood time. Higher than 0, max 999.
			[51] = nil,	-- Deflood warnings count. Higher than 0, max 29999.
			[52] = nil,	-- Deflood warnings action. 0 = disconnect, 1 = kick, 2 = tempban, 3 = permban. Max 3.
			[53] = nil,	-- Deflood tempban time. Higher than 0.
			[54] = nil,	-- Global main chat messages count. Higher than 0, max 29999.
			[55] = nil,	-- Global main chat time. Higher than 0, max 29999.
			[56] = nil,	-- Global main chat timeout. Higher than 0, max 29999.
			[57] = nil,	-- Global main chat action. 0 = disabled, 1 = lock chat, 2 = send to ops with ips. Max 2.
			[58] = nil,	-- Min search length.
			[59] = nil,	-- Max search length.
			[60] = nil,	-- Min nick length. Max 64.
			[61] = nil,	-- Max nick length. Max 64.
			[62] = nil,	-- Brute force password protection ban type. 0 = disabled, 1 = permban, 2 = tempban. Max 2.
			[63] = nil,	-- Brute force password protection temp ban time. Higher than 0.
			[64] = nil,	-- Max pm count to same user per minute.
			[65] = nil,	-- Max simultaneous logins. Higher than 0, max 500.
			[66] = nil,	-- Secondary main chat deflood messages count. Higher than 0, max 29999.
			[67] = nil,	-- Secondary main chat deflood time. Higher than 0, max 29999.
			[68] = nil,	-- Secondary main chat deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[69] = nil,	-- Secondary private message deflood messages count. Higher than 0, max 29999.
			[70] = nil,	-- Secondary private message deflood time. Higher than 0, max 29999.
			[71] = nil,	-- Secondary private message deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[72] = nil,	-- Secondary search deflood messages count. Higher than 0, max 29999.
			[73] = nil,	-- Secondary search deflood time. Higher than 0, max 29999.
			[74] = nil,	-- Secondary search deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[75] = nil,	-- Secondary myINFO deflood messages count. Higher than 0, max 29999.
			[76] = nil,	-- Secondary myINFO deflood time. Higher than 0, max 29999.
			[77] = nil,	-- Secondary myINFO deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[78] = nil,	-- Maximum MyINFO length. Min 64, max 512.
			[79] = nil,	-- Primary ConnectToMe deflood count. Higher than 0, max 29999.
			[80] = nil,	-- Primary ConnectToMe deflood time. Higher than 0, max 29999.
			[81] = nil,	-- Primary ConnectToMe deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[82] = nil,	-- Secondary ConnectToMe deflood count. Higher than 0, max 29999.
			[83] = nil,	-- Secondary ConnectToMe deflood time. Higher than 0, max 29999.
			[84] = nil,	-- Secondary ConnectToMe deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[85] = nil,	-- Primary RevConnectToMe deflood count. Higher than 0, max 29999.
			[86] = nil,	-- Primary RevConnectToMe deflood time. Higher than 0, max 29999.
			[87] = nil,	-- Primary RevConnectToMe deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[88] = nil,	-- Secondary RevConnectToMe deflood count. Higher than 0, max 29999.
			[89] = nil,	-- Secondary RevConnectToMe deflood time. Higher than 0, max 29999.
			[90] = nil,	-- Secondary RevConnectToMe deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[91] = nil,	-- Maximum ConnectToMe length. Higher than 0, max 512.
			[92] = nil,	-- Maximum RevConnectToMe length. Higher than 0, max 512.
			[93] = nil,	-- Primary SR deflood count. Higher than 0, max 29999.
			[94] = nil,	-- Primary SR deflood time. Higher than 0, max 29999.
			[95] = nil,	-- Primary SR deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[96] = nil,	-- Secondary SR deflood count. Higher than 0, max 29999.
			[97] = nil,	-- Secondary SR deflood time. Higher than 0, max 29999.
			[98] = nil,	-- Secondary SR deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[99] = nil,	-- Maximum SR length. Higher than 0, max 8192.
			[100] = nil,	-- Primary received data deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[101] = nil,	-- Primary received data deflood kB. Higher than 0, max 29999.
			[102] = nil,	-- Primary received data deflood time. Higher than 0, max 29999.
			[103] = nil,	-- Secondary received data deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[104] = nil,	-- Secondary received data deflood kB. Higher than 0, max 29999.
			[105] = nil,	-- Secondary received data deflood time. Higher than 0, max 29999.
			[106] = nil,	-- Chat messages interval messages. Higher than 0, max 29999.
			[107] = nil,	-- Chat messages interval time. Higher than 0, max 29999.
			[108] = nil,	-- Private messages interval messages. Higher than 0, max 29999.
			[109] = nil,	-- Private messages interval time. Higher than 0, max 29999.
			[110] = nil,	-- Search interval count. Higher than 0, max 29999.
			[111] = nil,	-- Search interval time. Higher than 0, max 29999.
			[112] = nil,	-- Maximum users from same IP. Higher than 0, max 256.
			[113] = nil,	-- Minimum reconnect time in seconds. Higher than 0, max 256.

			}

			SetNumber = {

			-- Setting number IDs for SetMan.(G/S)etNumber

			[0] = nil,	-- Max users limit
			[1] = nil,	-- Min share limit. Max 9999.
			[2] = nil,	-- Min share units. 0 = B, 1 = kB, 2 = MB, 3 = GB, 4 = TB. Max 4.
			[3] = nil,	-- Max share limit. Max 9999.
			[4] = nil,	-- Max share units. 0 = B, 1 = kB, 2 = MB, 3 = GB, 4 = TB. Max 4.
			[5] = nil,	-- Min slots limit.
			[6] = nil,	-- Max slots limit.
			[7] = nil,	-- Hubs for hub/slot ratio.
			[8] = nil,	-- Slots for hub/slot ratio.
			[9] = nil,	-- Max hubs limit.
			[10] = nil,	-- No tag option. 0 = accept, 1 = reject, 2 = redirect. Max 2.
			[11] = nil,	-- Send full MyINFO to... 0 = to all, 1 = to profile, 2 = to none. Max 2.
			[12] = nil,	-- Max chat length limit.
			[13] = nil,	-- Max chat lines limit.
			[14] = nil,	-- Max private message length limit.
			[15] = nil,	-- Max private message lines limit.
			[16] = nil,	-- Default tempban time. Must be higher than 0.
			[17] = nil,	-- Max passive search replys limit.
			[18] = nil,	-- Time before new MyINFO from user is accepted for broadcast.
			[19] = nil,	-- Main chat deflood messages count. Higher than 0, max 29999.
			[20] = nil,	-- Main chat deflood time. Higher than 0, max [29999.
			[21] = nil,	-- Main chat deflood action. 0 = disabled, 1 = ignore, [2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[22] = nil,	-- Same main chat deflood messages count. Higher than 0, max [29999.
			[23] = nil,	-- Same main chat deflood time. Higher than 0, max [29999.
			[24] = nil,	-- Same main chat deflood action. 0 = disabled, 1 = ignore, [2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[25] = nil,	-- Same multiline main chat deflood messages count. Min [2, max 999.
			[26] = nil,	-- Same multiline main chat deflood lines. Min [2, max 999.
			[27] = nil,	-- Same multiline main chat deflood action. 0 = disabled, 1 = ignore, [2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[28] = nil,	-- Private message deflood messages count. Higher than 0, max [29999.
			[29] = nil,	-- Private message deflood time. Higher than 0, max [29999.
			[30] = nil,	-- Private message deflood action. 0 = disabled, 1 = ignore, [2 = warn, [3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[31] = nil,	-- Same private message deflood messages count. Higher than 0, max [29999.
			[32] = nil,	-- Same private message deflood time. Higher than 0, max 29999.
			[33] = nil,	-- Same private message deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[34] = nil,	-- Same multiline private message deflood messages count. Min 2, max 999.
			[35] = nil,	-- Same multiline private message deflood lines. Min 2, max 999.
			[36] = nil,	-- Same multiline private message action. 0 = disabled, 1 = ignore, 2 = warn, [3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[37] = nil,	-- Search deflood messages count. Higher than 0, max 29999.
			[38] = nil,	-- Search deflood time. Higher than 0, max 29999.
			[39] = nil,	-- Search deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[40] = nil,	-- Same search deflood messages count. Higher than 0, max 29999.
			[41] = nil,	-- Same search deflood time. Higher than 0, max 29999.
			[42] = nil,	-- Same search deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, [4 = kick, 5 = tempban, 6 = permban. Max 6.
			[43] = nil,	-- MyINFO deflood messages count. Higher than 0, max 29999.
			[44] = nil,	-- MyINFO deflood time. Higher than 0, max 29999.
			[45] = nil,	-- MyINFO deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, [4 = kick, 5 = tempban, 6 = permban. Max 6.
			[46] = nil,	-- GetNickList deflood messages count. Higher than 0, max 29999.
			[47] = nil,	-- GetNickList deflood time. Higher than 0, max 29999.
			[48] = nil,	-- GetNickList deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, [4 = kick, 5 = tempban, 6 = permban. Max 6.
			[49] = nil,	-- Connection deflood connecions count. Higher than 0, max 999.
			[50] = nil,	-- Connection deflood time. Higher than 0, max 999.
			[51] = nil,	-- Deflood warnings count. Higher than 0, max 29999.
			[52] = nil,	-- Deflood warnings action. 0 = disconnect, 1 = kick, 2 = tempban, 3 = permban. Max 3.
			[53] = nil,	-- Deflood tempban time. Higher than 0.
			[54] = nil,	-- Global main chat messages count. Higher than 0, max 29999.
			[55] = nil,	-- Global main chat time. Higher than 0, max 29999.
			[56] = nil,	-- Global main chat timeout. Higher than 0, max 29999.
			[57] = nil,	-- Global main chat action. 0 = disabled, 1 = lock chat, 2 = send to ops with ips. Max 2.
			[58] = nil,	-- Min search length.
			[59] = nil,	-- Max search length.
			[60] = nil,	-- Min nick length. Max 64.
			[61] = nil,	-- Max nick length. Max 64.
			[62] = nil,	-- Brute force password protection ban type. 0 = disabled, 1 = permban, 2 = tempban. Max 2.
			[63] = nil,	-- Brute force password protection temp ban time. Higher than 0.
			[64] = nil,	-- Max pm count to same user per minute.
			[65] = nil,	-- Max simultaneous logins. Higher than 0, max 500.
			[66] = nil,	-- Secondary main chat deflood messages count. Higher than 0, max 29999.
			[67] = nil,	-- Secondary main chat deflood time. Higher than 0, max 29999.
			[68] = nil,	-- Secondary main chat deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[69] = nil,	-- Secondary private message deflood messages count. Higher than 0, max 29999.
			[70] = nil,	-- Secondary private message deflood time. Higher than 0, max 29999.
			[71] = nil,	-- Secondary private message deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[72] = nil,	-- Secondary search deflood messages count. Higher than 0, max 29999.
			[73] = nil,	-- Secondary search deflood time. Higher than 0, max 29999.
			[74] = nil,	-- Secondary search deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[75] = nil,	-- Secondary myINFO deflood messages count. Higher than 0, max 29999.
			[76] = nil,	-- Secondary myINFO deflood time. Higher than 0, max 29999.
			[77] = nil,	-- Secondary myINFO deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[78] = nil,	-- Maximum MyINFO length. Min 64, max 512.
			[79] = nil,	-- Primary ConnectToMe deflood count. Higher than 0, max 29999.
			[80] = nil,	-- Primary ConnectToMe deflood time. Higher than 0, max 29999.
			[81] = nil,	-- Primary ConnectToMe deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[82] = nil,	-- Secondary ConnectToMe deflood count. Higher than 0, max 29999.
			[83] = nil,	-- Secondary ConnectToMe deflood time. Higher than 0, max 29999.
			[84] = nil,	-- Secondary ConnectToMe deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[85] = nil,	-- Primary RevConnectToMe deflood count. Higher than 0, max 29999.
			[86] = nil,	-- Primary RevConnectToMe deflood time. Higher than 0, max 29999.
			[87] = nil,	-- Primary RevConnectToMe deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[88] = nil,	-- Secondary RevConnectToMe deflood count. Higher than 0, max 29999.
			[89] = nil,	-- Secondary RevConnectToMe deflood time. Higher than 0, max 29999.
			[90] = nil,	-- Secondary RevConnectToMe deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[91] = nil,	-- Maximum ConnectToMe length. Higher than 0, max 512.
			[92] = nil,	-- Maximum RevConnectToMe length. Higher than 0, max 512.
			[93] = nil,	-- Primary SR deflood count. Higher than 0, max 29999.
			[94] = nil,	-- Primary SR deflood time. Higher than 0, max 29999.
			[95] = nil,	-- Primary SR deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[96] = nil,	-- Secondary SR deflood count. Higher than 0, max 29999.
			[97] = nil,	-- Secondary SR deflood time. Higher than 0, max 29999.
			[98] = nil,	-- Secondary SR deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[99] = nil,	-- Maximum SR length. Higher than 0, max 8192.
			[100] = nil,	-- Primary received data deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[101] = nil,	-- Primary received data deflood kB. Higher than 0, max 29999.
			[102] = nil,	-- Primary received data deflood time. Higher than 0, max 29999.
			[103] = nil,	-- Secondary received data deflood action. 0 = disabled, 1 = ignore, 2 = warn, 3 = disconnect, 4 = kick, 5 = tempban, 6 = permban. Max 6.
			[104] = nil,	-- Secondary received data deflood kB. Higher than 0, max 29999.
			[105] = nil,	-- Secondary received data deflood time. Higher than 0, max 29999.
			[106] = nil,	-- Chat messages interval messages. Higher than 0, max 29999.
			[107] = nil,	-- Chat messages interval time. Higher than 0, max 29999.
			[108] = nil,	-- Private messages interval messages. Higher than 0, max 29999.
			[109] = nil,	-- Private messages interval time. Higher than 0, max 29999.
			[110] = nil,	-- Search interval count. Higher than 0, max 29999.
			[111] = nil,	-- Search interval time. Higher than 0, max 29999.
			[112] = nil,	-- Maximum users from same IP. Higher than 0, max 256.
			[113] = nil,	-- Minimum reconnect time in seconds. Higher than 0, max 256.

			}

			GetString = {

			-- Setting string IDs for SetMan.(G/S)etString (| is not allowed in all strings, if max length is not specified then is max 4096)

			[0] = nil,	-- Hub name. Min length 1, max 256.
			[1] = nil,	-- Admin nick. Min length 1, max 64, $ is not allowed.
			[2] = nil,	-- Hub address. Min length 1, max 256.
			[3] = nil,	-- TCP ports. Min length 1, max 64.
			[4] = nil,	-- UDP port. Min length 1, max 5.
			[5] = nil,	-- Hub description. Max length 256.
			[6] = nil,	-- Main redirect address. Max length 256.
			[7] = nil,	-- Hublist register servers. Max length 1024.
			[8] = nil,	-- Registered users only message. Min length 1, max 256.
			[9] = nil,	-- Registered users only redirect address. Max length 256.
			[10] = nil,	-- Hub topic. Max length 256.
			[11] = nil,	-- Share limit message. Min length 1, max 256. Use %[min] for min share size and %[max] for max share size.
			[12] = nil,	-- Share limit redirect address. Max length 256.
			[13] = nil,	-- Slot limit message. Min length 1, max 256. Use %[min] for min slots and %[max] for max slots.
			[14] = nil,	-- Slot limit redirect address. Max length 256.
			[15] = nil,	-- Hub/slot ratio limit message. Min length 1, max 256. Use %[hubs] for hubs and %[slots] for slots.
			[16] = nil,	-- Hub/slot ratio limit redirect address. Max length 256.
			[17] = nil,	-- Max hubs limit message. Min length 1, max 256. Use %[hubs] for max hubs.
			[18] = nil,	-- Max hubs limit redirect address. Max length 256.
			[19] = nil,	-- No tag rule message. Min length 1, max 256.
			[20] = nil,	-- No tag rule redirect address. Max length 256.
			[21] = nil,	-- Hub bot nick. Min length 1, max 64, $ and space is not allowed.
			[22] = nil,	-- Hub bot description. Max length 64, $ is not allowed.
			[23] = nil,	-- Hub bot email. Max length 64, $ is not allowed.
			[24] = nil,	-- OpChat bot nick. Min length 1, max 64, $ and space is not allowed.
			[25] = nil,	-- OpChat bot description. Max length 64, $ is not allowed.
			[26] = nil,	-- OpChat bot email. Max length 64, $ is not allowed.
			[27] = nil,	-- Temp ban redirect address. Max length 256.
			[28] = nil,	-- Perm ban redirect address. Max length 256.
			[29] = nil,	-- Chat commands prefixes. Min length 1, max 5.
			[30] = nil,	-- Hub owner email. Max length 64.
			[31] = nil,	-- Nick limit message. Min length 1, max 256. Use %[min] for min length and %[max] for max length.
			[32] = nil,	-- Nick limit redirect address. Max length 256.
			[33] = nil,	-- Additional message to ban message. Max lenght 256.
			[34] = nil,	-- Language. When language is default then return nil.

			}

			SetString = {

			-- Setting string IDs for SetMan.(G/S)etString (| is not allowed in all strings, if max length is not specified then is max 4096)

			[0] = nil,	-- Hub name. Min length 1, max 256.
			[1] = nil,	-- Admin nick. Min length 1, max 64, $ is not allowed.
			[2] = nil,	-- Hub address. Min length 1, max 256.
			[3] = nil,	-- TCP ports. Min length 1, max 64.
			[4] = nil,	-- UDP port. Min length 1, max 5.
			[5] = nil,	-- Hub description. Max length 256.
			[6] = nil,	-- Main redirect address. Max length 256.
			[7] = nil,	-- Hublist register servers. Max length 1024.
			[8] = nil,	-- Registered users only message. Min length 1, max 256.
			[9] = nil,	-- Registered users only redirect address. Max length 256.
			[10] = nil,	-- Hub topic. Max length 256.
			[11] = nil,	-- Share limit message. Min length 1, max 256. Use %[min] for min share size and %[max] for max share size.
			[12] = nil,	-- Share limit redirect address. Max length 256.
			[13] = nil,	-- Slot limit message. Min length 1, max 256. Use %[min] for min slots and %[max] for max slots.
			[14] = nil,	-- Slot limit redirect address. Max length 256.
			[15] = nil,	-- Hub/slot ratio limit message. Min length 1, max 256. Use %[hubs] for hubs and %[slots] for slots.
			[16] = nil,	-- Hub/slot ratio limit redirect address. Max length 256.
			[17] = nil,	-- Max hubs limit message. Min length 1, max 256. Use %[hubs] for max hubs.
			[18] = nil,	-- Max hubs limit redirect address. Max length 256.
			[19] = nil,	-- No tag rule message. Min length 1, max 256.
			[20] = nil,	-- No tag rule redirect address. Max length 256.
			[21] = nil,	-- Hub bot nick. Min length 1, max 64, $ and space is not allowed.
			[22] = nil,	-- Hub bot description. Max length 64, $ is not allowed.
			[23] = nil,	-- Hub bot email. Max length 64, $ is not allowed.
			[24] = nil,	-- OpChat bot nick. Min length 1, max 64, $ and space is not allowed.
			[25] = nil,	-- OpChat bot description. Max length 64, $ is not allowed.
			[26] = nil,	-- OpChat bot email. Max length 64, $ is not allowed.
			[27] = nil,	-- Temp ban redirect address. Max length 256.
			[28] = nil,	-- Perm ban redirect address. Max length 256.
			[29] = nil,	-- Chat commands prefixes. Min length 1, max 5.
			[30] = nil,	-- Hub owner email. Max length 64.
			[31] = nil,	-- Nick limit message. Min length 1, max 256. Use %[min] for min length and %[max] for max length.
			[32] = nil,	-- Nick limit redirect address. Max length 256.
			[33] = nil,	-- Additional message to ban message. Max lenght 256.
			[34] = nil,	-- Language. When language is default then return nil.

			}

			--[[
			User data IDs for Core.GetUserData call.
			-------------------
			0	- sMode
			1	- sMyInfoString
			2	- sDescription
			3	- sTag
			4	- sConnection
			5	- sEmail
			6	- sClient
			7	- sClientVersion
			8	- sVersion
			9	- bConnected
			10	- bActive
			11	- bOperator
			12	- bUserCommand
			13	- bQuickList
			14	- bSuspiciousTag
			15	- iProfile
			16	- iShareSize
			17	- iHubs
			18	- iNormalHubs
			19	- iRegHubs
			20	- iOpHubs
			21	- iSlots
			22	- iLlimit
			23	- iDefloodWarns
			24	- iMagicByte
			25	- iLoginTime
			26	- sCountryCode

			]]--
			return User
		end
	end
}
