--[[

	FlexHub is a server-software for the Direct Connect P2P Network.

	Copyright (C) 2011 Daywalker and FlipFlop, dev@flexhub.org

    This file is part of FlexHub.

    FlexHub is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FlexHub is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with FlexHub.  If not, see <http://www.gnu.org/licenses/agpl.txt>.


]]--

dofile('./api/Api-Ptokax-1-Set.lua')
dofile('./api/Api-Ptokax-1-Val.lua')


function scriptloader(scriptname)
    print(scriptname)

    local cage = {
        -- import some packages:
        assert = assert, collectgarbage = collectgarbage, dofile = dofile,
        error = error, getfenv = getfenv, getmetatable = getmetatable,
        ipairs = ipairs, load = load, loadfile = loadfile, loadstring = loadstring,
        next = next, pairs = pairs, pcall = pcall, print = print, rawequal = rawequal,
        rawget = rawget, rawset = rawset, select = select, setfenv = setfenv,
        setmetatable = setmetatable, tonumber = tonumber, tostring = tostring,
        type = type, unpack = unpack, _VERSION = _VERSION, xpcall = xpcall,

        coroutine = coroutine,
        module = module,
        require = require,
        package = package,
        string = string,
        table = table,
        math = math,
        io = io,
        file = file,
        os = os,
        debug = debug,

        -- modified global functions:
    --    ToArrival = ToArrival,
    --    SearchArrival = SearchArrival,
    print = scriptdebug,
    OnError = scriptdebug,

        -- own api:
    --    User = User,
    --    Core = Core,

    }

    local scriptenv = {}
    local scriptenv_mt = {__index=cage} --// using metatable to insert the cage or _G the global envi?
    setmetatable (scriptenv, scriptenv_mt) --// add cage to metatable or... getfenv(0)?

    local chunk, errmsg  = loadfile (scriptname) --// where the environment is for
    if chunk then
        setfenv(chunk, scriptenv) --// create the environment
        chunk () --// activate the environment
        return scriptenv
    else
        chunk = chunk or errmsg or "Error unknown, chunk is nil."
        print("Error during loadfile for '"..scriptname.."': "..chunk)
        return nil
    end
end

--// make a list of the luascripts inside the scripts folder
function listdir(str)
	local path, name = str:match("(.*)[\\/]+(.*)")
	path = (path or ".").."/"
	name = name or str
	for f in lfs.dir(path) do
		if f:match(".lua$") then --// check if it is a lua file
			table.insert(allscripts,path..f) --// add them to the table
		end
	end
end

function StartScripts( )
    allscripts  = {} --// add scripts from scriptfolder to this table
    all_envs = {}

    local scriptpath = "./scripts/"
    listdir(scriptpath) --// run the function somewhere a reload is

    for i,v in pairs(allscripts) do
        local res = scriptloader(v)
        if res then
            all_envs[i] = res  -- create the save and new environment
        else
            all_envs[i] = nil
        end
    end

    for index in ipairs(all_envs) do
        if index then
            local res,err = pcall(all_envs[index].ToArrival, {["sNick"] = "Testnick"}, "Teststring")
            if not res then tFuncs:Debug("Error executing ToArrival: "..err) end
            local res,err = pcall(all_envs[index].SearchArrival, {["sNick"] = "Testnick"}, "Teststring")
            if not res then tFuncs:Debug("Error executing SearchArrival:"..err) end
        end
    end
end

function TestApi()
    for index in ipairs(all_envs) do
        if index then
            local res,err = pcall(all_envs[index].ToArrival)
            if not res then tFuncs:Debug("Error executing ToArrival: "..err) end
            local res,err = pcall(all_envs[index].SearchArrival)
            if not res then tFuncs:Debug("Error executing SearchArrival:"..err) end
        end
    end
end

--dofile("./scripts/inform.lua")

