--[[

	FlexHub is a server-software for the Direct Connect P2P Network.

	Copyright (C) 2011 Daywalker and FlipFlop, dev@flexhub.org

    This file is part of FlexHub.

    FlexHub is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FlexHub is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with FlexHub.  If not, see <http://www.gnu.org/licenses/agpl.txt>.


]]--

function Lang(...)
    local ssid = arg[1]
    local num = arg[2]
    local text = arg[3]
    if ssid and num and text then
        --// TODO here: find the proper language text for ssid and num

	local res, reply = pcall(Lang_Replace, text, arg)
	if res then 
		return reply
	else
		local msg = tostring(arg[3]).." / Error occurred, check feed, arguments: "..table.concat(arg, ", ", 4)
		tFuncs:Debug("[Lang] Error during language replacing: "..reply.."\nMessage: "..tostring(arg[3]).."\nBasic arguments: ssid: "..tostring(arg[1]).." num: "..tostring(arg[2]).."\nExtra arguments: "..table.concat(arg, ", "))
		return msg
	end
    else
        return "Error during translation, use: Lang(ssid, num, text, ...) / Arguments: "..tostring(arg[1]).."/ "..tostring(arg[2]).."/ "..tostring(arg[3]).."/ "..tostring(arg[4])
end
end

function Lang_Replace(text, arg)
	for a=4, #arg do
		local var = tostring(arg[a]):gsub("%%", "%%%%")		--// Escape % in arguments
		text = text:gsub("%%s", var, 1)
	end
	return text
end

function LangEscape(txt, inverse)
    local txt = tostring(txt)
    if not inverse then
	txt = txt:gsub("\"", "//q")
        txt = txt:gsub("\r", "//r")
        txt = txt:gsub("\n", "//n")
        txt = txt:gsub("\t", "//t")
    else
	txt = txt:gsub("//q", "\"")
        txt = txt:gsub("//n", "\n")
        txt = txt:gsub("//t", "\t")
        txt = txt:gsub("//r", "\r")
    end
    return txt
end
