--[[

	FlexHub is a server-software for the Direct Connect P2P Network.

	Copyright (C) 2011 Daywalker and FlipFlop, dev@flexhub.org

    This file is part of FlexHub.

    FlexHub is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FlexHub is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with FlexHub.  If not, see <http://www.gnu.org/licenses/agpl.txt>.


]]--
--// Settings Manager basic settings

--// Work in progress

--[[
 !set sr_useraction1 Ignore
 !set sr_usermax1 20
 !set sr_usertime1 10

This will ignore searchresults if there are more than 20 in 10 seconds

 !set sr_useraction2 Disconnect
 !set sr_usermax2 200
 !set sr_usertime2 20
]]--

SubSet = {
	["ActionList"] = 		{"Ignore", "Notify", "Warn", "Mute", "Disconnect", "Kick", "Ban", "Redirect", "NotifyOpchat", "LockMain", "Replace", "ReplaceLine"},
	["ActionListFilter"] = 	{"Ignore", "Notify", "Warn", "Mute", "Disconnect", "Kick", "Ban", "Redirect", "NotifyOpchat", "LockMain"},
--	["ActionOrder"] = 	{"NotifyOpchat", "LockMain", "Ban", "Kick", "Redirect", "Disconnect", "Mute", "Warn", "Notify", "Ignore", "Replace", "ReplaceLine"}, -- // original
	["ActionOrder"] = 	{"NotifyOpchat", "LockMain", "Ban", "Kick", "Redirect", "Disconnect", "Mute", "Warn", "Notify", "Ignore", "ReplaceLine", "Replace"},
	["ActionListString"] =  "Ignore, Notify, Warn, Mute, Disconnect, Kick, Ban, Redirect, NotifyOpchat, LockMain",
	["ActionDebug"] = 	{ ["Disabled"] = 2, ["Ignore"] = 2, ["Notify"] = 1, ["NotifyOpchat"] = 1, ["Replace"] = 1, ["ReplaceLine"] = 1},

	["CheckList"] = { 
		["MC"] = {"1", "mainchat message"}, ["PM"] = {"2", "private message"}, ["SE"] = {"4", "search"}, ["SR"] = {"8", "searchresult"},
		["NI"] = {"16", "nickname", "sNick"}, ["DE"] = {"32", "description", "sDescription"}, ["EM"] = {"64", "email", "sEmail"},
		["VE"] = {"128", "client version"}, ["SS"] = {"256", "sharesize", "sShareSize"}, ["RE"] = {"512", "report"},
	},

	["Patterntypes"] = { "MC", "PM", "SE", "SR", "NI", "DE", "EM", "VE", "SS", "RE" },
	
	--//		checkproxy checkpassive blocknmdc blocknmdc checkdht minslots maxslots maxhubs maxpublichubs maxreghubs maxophubs minshare maxshare

	["ExtraAllows"] = { ["opchat"] = true, ["feed"] = true, ["setcmd"] = true,},

-- Removing this from here, and replacing it with ProfileManager.Settings[xxx] functions instead
--	["ProfileSettings"] = { ["level"] = true, ["operator"] = true, ["key"] = true, ["fakekey"] = true, ["desc"] = true, ["message"] = true, ["hideshare"] = true, ["minshare"] = true,},

	["Overrides"] = { 
--~ 		"checkxx", "checkma", "checkmn", "checkre", "checkha", "checkse", "checksp", "checksr",  "checkmc", "checkhc", "checkpm", "checkct", "checkrc",  --"checksg" not functional yet
		"securityxx", "securityma", "securitymn", "securityre", "securityha", "securitypr", "securitysa", "securitysp", "securitysr",  "securitymc", "securityhc", "securitypm", "securityct", "securityrc",  --"securitysg" not functional yet
		"blockproxy", "blockpassive", "blockadc", "blocknmdc", "blockdht", "blockdownload", "blockupload",
		"maxclones","minshare","maxshare","minslots","maxslots", "maxhubs", "maxpublichubs", "maxreghubs", "maxophubs", "maxusers",
		"lockmc", "lockpm",
		"redirect", "modecheck",
		"checkmyinfo",
	},

	["HubCommands"] = {
		[1] = { ["text"] = "Hub information commands", ["cmds"] = { "help", "faq", "rules", "history", "hubinfo", "stats", } },
		[2] = { ["text"] = "User information commands", ["cmds"] = { "myip", "ipinfo", "dns", "revdns", "hide", "unhide", "hideshare", "unhideshare", "report", "say", "userinfo", "userstats", "whisper"} },
		[4 ]= { ["text"] = "User control and blocks", ["cmds"] = { "kenny", "unkenny", "muppetize", "unmuppetize", "mute", "unmute", "blockdownload", "unblockdownload", "blockpm",  "unblockpm", "showblocks", },},
		[3] = { ["text"] = "Room commands", ["cmds"] = {"privateroom", "invite", "list", "leave", "uninvite"}},
		[5] = { ["text"] = "Registration commands", ["cmds"] = { "addreg", "bindip", "changereg", "comment", "delreg", "getpass", "getmypass", "regme", "reginfo", "setpass", "setmypass", "setprofile", "showprofiles",  "showregs"} },
		[6] = { ["text"] = "Kick and ban commands", ["cmds"] = { "drop", "dropsid", "warn", "unwarn", "kick", "ban", "baninfo", "banip", "bannick", "banrange", "kill", "redirect",  "tempban", "tempbanip", "tempbannick", "tempkill", "tempbanrange", "unban", "protect", "unprotect", "showprotected", "showallbans", "showipbans", "shownickbans", "showrangebans", "showwarns", "clearautobans", "clearipbans", "clearnickbans", "clearrangebans", "clearexpiringbans", "clearlastbans", } },
		[7] = { ["text"] = "Admin commands", ["cmds"] = { "attackstats", "corestats", "cmdhistory", "historyclean", "mass", "massprofile",  "mc", "lockhub", "unlockhub", "lockmain", "unlockmain", "quote", "addquote", "delquote", "showquotes", "resettimeout", "showconnects", "showdisconnects", "showlogins", "showports", "showsid",  "showtopic", "topic", "trafficstats", } },
	},
	
	["SetCommands"] = {
		[1] = { ["text"] = "Basic Hub Settings", ["cmds"] = { "sethelp", "sethubname", "sethubdesc", "setbotname", "setbotdesc", "setfeedname", "setfeeddesc", "setopchatname", "setopchatdesc"} },
		[2] = { ["text"] = "Chatroom Management", ["cmds"] = { "showrooms", "addroom", "delroom", "setroomname", "setroomdesc"} },
		[3] = { ["text"] = "Command Management", ["cmds"] = { "addcmd", "delcmd", "modcmd", "showcmd", "renamecmd"} },
		[4] = { ["text"] = "Pattern Management", ["cmds"] = { "addpattern", "delpattern", "modpattern", "showpattern"} },
		[5] = { ["text"] = "Profile Management", ["cmds"] = { "addprofile", "delprofile", "modprofile", "showprofile", "allow", "override"} },
		[6] = { ["text"] = "Hublist Commands", ["cmds"] = { "addhublist", "delhublist", "showhublists", "reghub"} },
		[7] = { ["text"] = "Conversion Commands", ["cmds"] = { "importaccounts"} },
		[8] = { ["text"] = "Script Management", ["cmds"] = { "restartscripts", "update"} },
		[9] = { ["text"] = "Set Variables", ["cmds"] = { "set",} },
		[10] = { ["text"] = "Debug Commands (not in release)", ["cmds"] = { "monitor", "unmonitor", "sendraw",  "runcmd", "showtraceback", "startprofiler", "stopprofiler", "showstatus",} },
	},
}

Set = {
	["UpdateSettings"] = {
		["sr_useraction1"] = { ["value"] = "Ignore", ["svn"] = 1025, ["reason"] = "Default setting could cause innocent users to be disconnected" },
		["sr_usermax1"] = { ["value"] = 20, ["svn"] = 1025, ["reason"] = "Default setting could cause innocent users to be disconnected" },
		["sr_usertime1"] = { ["value"] = 10, ["svn"] = 1025, ["reason"] = "Default setting could cause innocent users to be disconnected" },
		["sr_useraction2"] = { ["value"] = "Disconnect", ["svn"] = 1025, ["reason"] = "Default setting could cause innocent users to be disconnected" },
		["sr_usermax2"] = { ["value"] = 200, ["svn"] = 1025, ["reason"] = "Default setting could cause innocent users to be disconnected" },
		["sr_usertime2"] = { ["value"] = 20, ["svn"] = 1025, ["reason"] = "Default setting could cause innocent users to be disconnected" },
		["nonrespond_wait"] = { ["value"] = 0, ["svn"] = 1029, ["reason"] = "Default setting could cause lag" },
		["attack_serverwaittime"] = { ["value"] = 5, ["svn"] = 1047, ["reason"] = "Default setting could cause too high cpu-usage during ddos" },
		["listentimeout"] = { ["value"] = 600, ["svn"] = 1126, ["reason"] = "Self repair feature: default setting could cause a hub restart too quick" },

		["rd_checkinterval"] = { ["value"] = 0, ["svn"] = 1205, ["reason"] = "Change of default setting" },
		["rd_checkalert"] = { ["value"] = false, ["svn"] = 1205, ["reason"] = "Change of default setting" },
		["rd_checkfallback"] = { ["value"] = "none", ["svn"] = 1205, ["reason"] = "Change of default setting" },

	},
	--// Types, validators: b=boolean, s=string, i=int, r=real, f=filesize, n=nickname, t=time in seconds, d=duration in seconds
	["Files"] = {
		{"Security", _CONFIGDIR.."HubSecurity.ini", tSecurity, "tSecurity"},
		{"Settings", _CONFIGDIR.."HubSettings.ini", tHubSettings, "tHubSettings"},
		{"Bans", _CONFIGDIR.."HubBans.ini", tBans, "tBans"},
		{"Blocks", _CONFIGDIR.."HubBlocks.ini", tBlocks, "tBlocks"},
		{"Profiles", _CONFIGDIR.."HubProfiles.ini", tProfiles, "tProfiles"},
		{"Accounts", _CONFIGDIR.."HubAccounts.ini", tAccounts, "tAccounts"},
		{"Chatrooms", _CONFIGDIR.."HubChatRooms.ini", tChatRooms, "tChatRooms"},
		{"Commands", _CONFIGDIR.."HubCommands.ini", tCommands, "tCommands"},
		{"Patterns", _CONFIGDIR.."HubPatterns.ini", tPatterns, "tPatterns"},
		{"Protects", _CONFIGDIR.."HubProtects.ini", tProtects, "tProtects"},
		{"Filters", _CONFIGDIR.."HubFilters.ini", tFilters, "tFilters"},
		{"CmdAlias", _CONFIGDIR.."HubCmdAlias.ini", tCmdAlias, "tCmdAlias"},
--~ 		{"Language", _APPPATH.."lang/default.ini", tLanguage, "tLanguage"},	--// Language settings
	},

	["ProfileOverrides"] = {		--// New values can only be added to the end of the table, inserting anywhere else will mess up the rights of all profiles, the order is used to use the bitnotation of sOverrides and sCmds
		"all",
		"=Rules", "slotsmin", "slotsmax", "slotratio", "minshare", "maxshare", "maxhubs", "maxpublichubs", "maxreghubs", "maxophubs",  "hubratio", "allowproxy", "allowdht", "checkpassive", "maxclones",
		"=General", "hubfull",  "floodcheck", "maincheck", "pmcheck", "searchcheck", "myinfocheck", "hamcheck", "beredirected", 
	},

	--// Send to GUI: "IGUI PSCM item1 item2 item3" etc
	["ProfileCommands"] = {
		"all",
		"=Information", "corestats", "help", "history", "hubinfo", "ipinfo", "iplog", "myip", "pinginfo", "stats", "dns", "revdns", "userinfo", 
		"=Traffic", "longmyinfo", 
		"=Broadcast", "mass", 
		"=User options", "changenick", "hide", "me", "report", "topic",
		"=Chat Control", "mute", "mute", "unmute", "kenny", "unkenny", "muppetize", "unmuppetize", "mainlock", "mainunlock", "pmlock", "pmunlock", "say", "mainchatuser",
		"=Kicks/Bans", "checkuser", "warn", "kick", "ban", "tempban", "banip", "bannick", "tempbanip", "tempbannick", "rangeban", "temprangeban", "unban", "kill", "tempkill", "drop", "redirect", "redirectall", "redirectport", 
			"showallbans", "showrangebans", "showbanips", "showbannicks", "kicklog", "warnlog", "banlog",
		"=Hub Settings", "setcmd", "settingsdeflood", "settingsmain", "settingscommands", "allowwebcontrol", "allowwebchat", 
		"=Scripts Commands", "scriptsshow", "scriptsrestart", "scriptsstopstart", 
		"=Account Commands", "addreg", "delreg", "setpass", "setpassuser", "showregs", "setprofile", "getpass", "updateip", "getpassuser", "getpass", 
		"=Profile Commands", "showprofiles", "showprofile", 
	},
	
--~ 	["ActionList"] = { "Ignore", "Replace", "ReplaceLine", "Notify", "Warn", "Mute", "Disconnect", "Kick", "Ban", "Redirect", "NotifyOpchat", "LockMain" },
--~ 	["ActionOrder"] = { "Replace", "ReplaceLine", "NotifyOpchat", "LockMain", "Ban", "Kick", "Redirect", "Disconnect", "Mute", "Warn", "Notify", "Ignore"},
	
	["Function"] = {
		--// WARNING: Functions (and their subfunctions/calls) below are not allowed to use SetManager:Set or SetManager:Initialize calls, to prevent loops!!!! SetManager:Get is allowed though
		--// The functions are used to perform extra actions or checks on changing settings, if allowed (changed or unchanged) the final value should be returned with true, value
		--// If a value isn't allowed, the function should return false, value, errmsg
		["chatonly"] = function(name, value) 
			if value == true then 
				return true, value
			else
				return true, value, "\n\nFlexHub is intended to be a Direct Connect hub software for sharing of copyright-free and legal content."..
				"\nBy disabling 'chatonly' you enable downloads and searches between users. You are responsible for the content shared in your hub, "..
				"\nFlexHub or it's developer(s) cannot be held responsible for the content shared between users connecting to the hub."..
				"\n\nIf you don't agree or don't want to enable downloads and searches, use '!set chatonly true'\n"
			end
		end,
		["char_set"] = function(name, value)
			local res, msg = tFuncs:SetCharset(value)
			return res, value, msg 
		end,
		["locale"] = function(name, value)
			local current = os.setlocale()
			local res, msg = tFuncs:SetLocale(value)
			return res, value, msg 
		end,
		["geoip_enable"] = function(name, value) return tFuncs:LoadGeoIP() end,
		["reg_prefix"] = function(name, value) 
			if not value or value == "" then return true, "" end
			--// CHECK FOR INVALID CHARS
			local invalidchars = {[""] = "non-breaking-space", ["\""] = "\"", ["%s"] = "space", ["|"] = "endpipe", ["\\"] = "\\", ["&"] = "&", ["%$"] = "$", ["\n"] = "newline"}
			for char, chartxt in pairs(invalidchars) do
				if string.find(value, char) then
					return false, "", "Invalid character(s) in reg_prefix: "..chartxt
				end
			end
			return true, value
		end,
		["console_debuglevel"]  = function(name, value)
			tFuncs:UpdateConsole("ID_sc_debuglevel", value, 1)
			return true, value
		end,
		["reghub_interval"] = function(name, value)	-- syncing the timer settings with the hubsettings for hublist registration
			value = tonumber(value)
			if value ~= 0 and value < tHubSettings.tHubLists.MinInterval then
				return false, value, "Minimum time interval for hublist registrations is "..tHubSettings.tHubLists.MinInterval.." seconds, or use 0 to disable automatic registration."
			end

			local res, err =  tTimerFuncs:TEditTimer("HubListReg", "iInterval", value)

			if value == 0 then
				local res, err =  tTimerFuncs:TEditTimer("HubListReg", "bEnabled", false)
			else
				local res, err =  tTimerFuncs:TEditTimer("HubListReg", "bEnabled", true)
			end

			if res then
				return res, value
			else
				return res, value, (err or "")
			end
		end,
		["room_name"] = function(name, value)
			local oldname = SetManager:Get(name)
			local res, msg = SetCmd.setroomname.cmd("AAAA", "!setroomname "..oldname .." "..value, "!setroomname")
			if res then 
				return true, value, msg
			else
				return false, value, msg
			end
		end,
		["room_desc"] = function(name, value)
			local room = false
			if name == "feed_description" then 
				room = "feed_name" 
			elseif name == "opchat_description" then
				room = "opchat_name" 
			end

			if room then
				local roomname = SetManager:Get(room)
				local res, msg = SetCmd.setroomdesc.cmd("AAAA", "!setroomdesc "..roomname.." "..value, "!setroomdesc")
				if res then 
					return true, value, msg
				else
					return false, value, msg
				end
			else
				return false, value, "Couldn't find room to set description on: "..name
			end
		end,
		["maxusers"] = function(name, value) 
			local msg = false
			local hostlimit = tHubSettings.tRules.iMaxUsersHard or 20000
			if value >= hostlimit then
				value = hostlimit
				msg =  "Hard userlimit in console is: "..hostlimit..". Value for 'maxusers' has also been set to "..hostlimit..". Use a lower value for 'maxusers' to allow operators to join without disconnecting users."
				tFuncs:Debug(msg, "FI", 0)
			end
			return true, value, msg
		end,
		["hub_address"] = function(name, value)
			tThreads.HubIp = ThreadCreate(tFuncs.GetHubIP,{1, value})
			return true, value
		end,
		["rd_failover"] = function(name, value)
			local afailover, nfailover = false, false
			if not value or value == "" or value == "\"\"" or value == false then
				afailover = "IINF FO\n"
				nfailover =  "$FailOver|"
			else
				afailover = "IINF FO"..ADC_E(value).."\n"
				nfailover = "$FailOver "..NMDC_E(value).."|"
			end

			--// Send updated failover to all clients that support it
			for csid, data in pairs(tClient) do
				if data.sProtocol == "NMDC" and data.tSupports.FailOver then
					tSend:Raw(csid, nfailover)
				elseif data.sProtocol == "ADC" then
					tSend:Raw(csid, afailover)
				end
			end

			return true, value
		end,
		["updateredirect"] = function(name, value)
			local names = {["rd_failover"] = "sFailOver", ["rd_adc_disabled"] = "sNoADC", ["rd_nmdc_disabled"] = "sNoNMDC", ["rd_passive"] = "sPassive", ["rd_maxhubs"] = "sMaxHubs", ["rd_minslots"] = "sMinSlots", ["rd_maxslots"] = "sMaxSlots", ["rd_minshare"] = "sMinShare", ["rd_maxshare"] = "sMaxShare", ["rd_flood"] = "sFlood", ["rd_main"] = "sMain", ["rd_regonly"] = "sRegOnly", ["rd_full"] = "sFull", ["rd_deadend"] = "sDeadEnd", ["rd_deadendfail"] = "sDeadEndFail"}

			if string.find(value, ";") then value = value:gsub(";", ",") end

			if string.find(value, ",") then
				local newrd = false
				local new = {}
				local t = tFuncs:Split(value, ",")

				for indx, data in ipairs(t) do
					if string.find(data, "%S+") then
						newrd = true
						table.insert(new, string.match(data, "%S+"))
					end
				end
				if not newrd then
					return false, value, "Could not set redirect to "..value
				else
					value = table.concat(new,",")
				end
			end

			tHubSettings.tRedirects[names[name]] = string.match(value, "%S+")
			tRedirect:MakeList()
			return true, tHubSettings.tRedirects[names[name]]
		end,
		["webchat_enable"] = function(name, value)
			if not tWebChat then return true, false, "Webchat isn't released yet, you can't change this value." end	--// Forces disabled
			if value == true and not tThreads.WebChat then
				tThreads.WebChat = ThreadCreate(tWebChat.Thread,{true})
				return true, value
			else
				if tThreads.WebChat then
					tFuncs:Debug("WebChat: Thread terminated. Stopped listening for incoming webchat.", "FI", -3)
					ThreadDestroy(tThreads.WebChat)
					tThreads.WebChat = nil
				end
			end
			return true, value
		end,
		["menu_name"] = function(name, value)
			if value and value ~= "" then
				tHubSettings.Main.sMenuname = string.match(value, "^%s-.+%s-$")
				tUserCmds:Build()
				return true, tHubSettings.Main.sMenuname
			else
				return false, value, "Could not set menu name to ".. value
			end
		end,
	},

	["Settings"] = {
		--[varname] = { "complete varname", "type", (lowest value, "regexp", {choices}), (highest value, "regexp not"), default value, "must be changed with command"

		--// Invisible settings
		["force_tls"] =		{"", "tHubSettings.Main.bForceTLS", "b", nil, nil, false, nil, "Allow secure ports to be opened in Windows (testing only, freezes hub on single ghosting connection)"},
		["allow_tls"] =		{"", "tHubSettings.Main.bAllowTLS", "b", nil, nil, false, nil, "Allow secure ports to be opened (setting not used anymore)"},
		["allow_http"] =		{"", "tHubSettings.Main.bAllowHTTP", "b", nil, nil, false, nil, "Allow http access"},
		["update_settings"] = 	{"", "tHubSettings.Main.iUpdateSettings", "i", nil, nil, 0, nil, "SVN number of last updated settings (for Set.UpdateSettings)"},
		["last_update"] = 		{"", "tHubSettings.Main.iLastupdate", "i", nil, nil, 0, nil, "Timestamp for last inline update"},
		["version_path"] = 		{"", "tHubSettings.Main.sVersionFileServerPath", "s", nil, nil, "http://flexhub.org/update/", nil, "Path used for downloading version info"},	-- end slash is mandatory
		["download_path"] = 	{"", "tHubSettings.Main.sDownloadFileServerPath", "s", nil, nil, "http://flexhub.info/update/", nil, "Path used for downloading updated files"},	-- end slash is mandatory
		["announce_beta"] = 	{"", "tHubSettings.Main.bAnnounceBeta", "b", nil, nil, true, nil, "Announce beta or not for updates"},
		["hub_id"] = 			{"", "tHubSettings.Main.sHubID", "s", nil, nil, th.hash(os.time()), nil, "Hub ID number"},
		["xdebug"] =			{"", "tHubSettings.Main.bExtraDebug", "b", nil, nil, false, nil, "Additional debuginfo"},
		["gdebug"] =			{"", "tHubSettings.Main.bGuiDebug", "b", nil, nil, false, nil, "GUI debuginfo"},
		["confirmcode"] =		{"", "tHubSettings.Main.bConfirmCode", "s", nil, nil, tFuncs:CreateSid(), nil, "Random confirmation code"},
		["httpproxy_enable"] = 	{"", "tHubSettings.Main.bEnableHTTPProxy", "b" , nil, nil,false, nil, "Enable http proxy for internet access"},
		["httpproxy"] = 		{"", "tHubSettings.Main.sHTTPProxy", "s", nil, nil, "", nil, "Web proxy adress"},
		["suppressucmd"] = {"", "tHubSettings.Main.bSuppressUsercommands", "b", nil, nil, false, nil, "Don't send usercommands on join"},

		--// Webchat
--~ 		["webchat"] = 			{"Webchat", nil, nil, nil, nil, nil, nil, "Webchat settings"},
		["webchat_t"] =			{"", "tHubSettings.Webchat", "t", nil, nil, {}},
		["webchat_enable"] = 		{"", "tHubSettings.Webchat.bEnable", "b", nil, nil, false, "webchat_enable", "Enable webchat"},
--~ 		["webchat_webaddress"] =	{"Webchat", "tHubSettings.Webchat.sAddress", "s", nil, nil, "localhost/flexhub/webchat", nil, "Webchat server address"},
--~ 		["webchat_login"] = 		{"Webchat", "tHubSettings.Webchat.sLogin", "s", nil, nil, "", nil, "Webchat loginname (not a mysql loginname!)"},
--~ 		["webchat_pass"] = 		{"Webchat", "tHubSettings.Webchat.sPass", "s", nil, nil, "", nil, "Webchat password (not a mysql password!)"},
		
		--// GUI
		["gui"] =				{"Gui", "tHubSettings.Gui", "t", nil, nil, {["UseTLS"] = false,["AllowMultiple"] = false,["AllowRemote"] = true,}},
		["console"] = 			{"Console", nil, nil, nil, nil, nil, nil, "Console settings"},
		["console_t"] =			{"Console", "tHubSettings.Console", "t", nil, nil, {}},
		["autostart"] =			{"Console", "tHubSettings.Console.AutoStartHub", "b", nil, nil, false, nil, "Autostart hub"},
		["warnonclose"] =		{"Console", "tHubSettings.Console.WarnOnClose", "b", nil, nil, true, nil, "Warn before closing the hub"},
		["console_debuglevel"] =	{"Console", "tHubSettings.Console.DebugLevel", "i", -10, 2, 0, "console_debuglevel", "Level of debug that will show in console, higher number is more output. Recommended: 0 or -1"},
		["console_mainchat"] = 	{"", "tHubSettings.Console.bMainchat", "b", nil, nil, false, nil, ""},

		--// FEED
		["feed"] = 					{"Feed", nil, nil, nil, nil, nil, nil, "Feed settings"},
		["feed_t"] =				{"Feed", "tHubSettings.Feed", "t", nil, nil, {},},
		["feed_rulelevel"] =		{"Feed", "tHubSettings.Feed.RuleLevel", "i", -10, 10, 1, nil, "Debuglevel of rulebased actions, if this number is equal or lower than feed_debuglevel the actions will show in feedroom. Recommended: 0 or 1"},
		["feed_debuglevel"] = 		{"Feed", "tHubSettings.Main.iFeedLevel", "i", -10, 5, 0, nil, "Output level of debugmessages to feedroom. Higher level is more output."},
		["feed_showsearches"] =		{"Feed", "tHubSettings.Feed.bShowSearches", "b", nil, nil, false, nil, "Show searches in debug feed"},

		--// MAIN
		["main"] = 					{"Main", nil, nil, nil, nil, nil, nil, "Main hubsettings"},
		["port_list"] =				{"Main", "tHubSettings.Main.tPortList", "t", nil, nil, {["Secure"] = {}, ["Gui"] = {}, ["Regular"] = {["411"] = true}}, "GUI"},
		["bot_name"] = 				{"Main", "tHubSettings.Main.sBotName", "n", nil, nil, "FlexBot", "setbotname", "Name of the hubbot"},
		["bot_description"] = 		{"Main", "tHubSettings.Main.sBotDescription", "s", nil, nil, "FlexHub Security", "setbotdesc", "Description of the hubbot"},
		["bot_talk"] =				{"Main", "tHubSettings.Main.bBotTalk", "b", nil, nil, "false", nil, "Disable the 'talks to bot' message"},
		["hub_name"] = 				{"Main", "tHubSettings.Main.sName", "s", nil, nil, "FlexHub", "sethubname", "Hub name"},
		["hub_description"] = 		{"Main", "tHubSettings.Main.sDescription", "s", nil, nil, "NMDC and ADC users in one hub", "sethubdesc", "Hub description"},
		["hub_email"] = 			{"Main", "tHubSettings.Main.sEmail", "s", nil, nil, "", nil, "Hub email address"},
		["hub_address"] = 			{"Main", "tHubSettings.Main.sAddress", "s", ".*:%d+", ".*://", "localhost:411", "hub_address", "Main hubaddress - Don't use prefixes like dchub:// or adc://, always use a portnumber"},
		["hub_owner"] = 			{"Main", "tHubSettings.Main.sOwner", "s" ,nil, nil, "", nil, "Hub owner"},
		["hub_network"] = 			{"Main", "tHubSettings.Main.sNetwork", "s", nil, nil, "", nil, "Network name"},
		["hub_website"] = 			{"Main", "tHubSettings.Main.sWebsite", "s", nil, nil, "", nil, "Website address"},
		["hub_language"] = 			{"Main", "tHubSettings.Main.sLanguage", "s", nil, nil, "English", nil, "Main language for hubresponses (not supported yet)."},
		["hub_topic"] = 			{"Main", "tHubSettings.Main.sTopic", "s", nil, nil, "NMDC and ADC users in one hub", "topic", "Hub topic"},
		["feed_name"] = 			{"Main", "tHubSettings.Main.sFeed", "n", nil, nil, "FlexFeed", "room_name", "Change name of the feedroom"},
		["feed_description"] = 		{"Main", "tHubSettings.Main.sFeedDescription", "s", nil, nil, "FlexHub FeedRoom", "room_desc", "Change description of the feedroom"},
		["feed_talk"] =				{"Main", "tHubSettings.Main.bFeedTalk", "b", nil, nil, "true", nil, "Allow talking in FeedRoom"},
		["opchat_name"] = 			{"Main", "tHubSettings.Main.sOpChat", "n", nil, nil, "FlexChat",  "room_name", "Change name of the operator chatroom"},
		["opchat_description"] = 	{"Main", "tHubSettings.Main.sOpChatDescription", "s", nil, nil, "FlexHub Operator Chat", "room_desc", "Change description of the operator chatroom"},
		["menu_name"] = 			{"Main", "tHubSettings.Main.sMenuname", "s", nil, nil, "FlexHub Beta", "menu_name", "Specify menu name for rightclick-commands"},
		["hub_info"] = 				{"Main", "tHubSettings.Main.sHubInfo", "s", nil, "%%%[hubinfo%]", "\n\tWe hope you enjoy your stay at %[hub]\n\n\tBest regards,\n\n\t\tThe FlexHub Team" ,nil, "Extra information that will display at the end of !hubinfo or for %[hubinfo]"},
		["reg_info"] = 				{"Main", "tHubSettings.Main.sRegInfo", "s", nil, "%%%[user_reginfo%]", "To register, use !regme <password> or use the rightclick menu" ,nil, "Extra information that will display for %[user_reginfo]"},
		["reg_msg"] = 				{"Main", "tHubSettings.Main.sRegMessage", "s", nil, nil, "Nickname:\t%[user_name]\n\tPassword:\t%[password]\n\tProfile:\t\t%[user_profile]\n\tHubname:\t%[hub]\n\tHubaddress:\t%[address]" ,nil, "Customisable message that is used when adding a new reg"},
		["update_check"] = 			{"Main", "tHubSettings.Main.bUpdateCheck", "b", nil, nil, true, nil, "Enable or disable automated checks for hubsoft updates"},

		--// ADVANCED
		["advanced"] = 			{"Advanced", nil, nil, nil, nil, nil, nil, "Advanced hubsettings"},
		["info_output"] = 			{"Advanced", "tHubSettings.Main.InfoOutput", "s", {"MC", "PM"}, nil, "MC", nil, "Output of informational commands to MC or PM"},
		["trigger_output"] = 		{"Advanced", "tHubSettings.Main.TriggerOutput", "s", {"MC", "PM"}, nil, "MC", nil, "Output of triggers to MC or PM"},
		["cmd_output"] = 		{"Advanced", "tHubSettings.Main.CommandOutput", "s", {"MC", "PM"}, nil, "MC", nil, "Output of hubcommands to MC or PM"},
		["cmd_prefixes"] =		{"Advanced", "tHubSettings.Main.sCmdPrefixes", "s", ".+", nil, "!+", nil, "Allowed prefixes to use for hubcommands. Recommended: !+"},
		["cmd_alias"] = 			{"Advanced", "tHubSettings.Main.bCmdAlias", "b", nil, nil, "true", nil, "Use command aliases (editable in HubCmdAlias.ini)"},
		["topic_broadcast"] =		{"Advanced", "tHubSettings.Main.bTopicBroadcast", "b", nil, nil, "true", nil, "Broadcast topic changes in mainchat"},
		["announce_higherprofile"] =	{"Advanced", "tHubSettings.Main.bAnnounceHigherProfile", "b", nil, nil, "true", nil, "Announce account profilechange to user when changing to a higher level profile"},
		["announce_lowerprofile"] =	{"Advanced", "tHubSettings.Main.bAnnounceLowerProfile", "b", nil, nil, "true", nil, "Announce account profilechange to user when changing to a same or lower level profile."},

		["history_lines"] = 		{"Advanced", "tHubSettings.Main.iHistoryLines", "i", 1, nil, 10, nil, "Set the default amount of lines for the history command"},
		["history_maxop"] = 		{"Advanced", "tHubSettings.Main.iHistoryMaxOp", "i", 1, nil, 200, nil, "Set the maximum amount of lines for the history command for operators"},
		["history_maxuser"] = 		{"Advanced", "tHubSettings.Main.iHistoryMaxUser", "i", 1, nil, 20, nil, "Set the maximum amount of lines for the history command for non-operators"},

		["char_set"] = 			{"Advanced", "tHubSettings.Main.sCharset", "s", nil, nil, "windows-1252", "char_set", "Specify the preferred character-set for NMDC users"},
		["locale"] = 			{"Advanced", "tHubSettings.Main.sLocale", "s", nil, nil, "en-us", "locale", "Specify the hub's locale, for example: en-us, ru or pl"},
		["date_format"] = 		{"Advanced", "tHubSettings.Main.sDateFormat", "s", ".+", nil, "%Y/%m/%d", nil, "Date display format: http://flexhub.org/wiki/index.php/Date_and_time_formatting"},
		["time_format"] = 		{"Advanced", "tHubSettings.Main.sTimeFormat", "s", ".+", nil, "%H:%M:%S", nil, "Time display format: http://flexhub.org/wiki/index.php/Date_and_time_formatting"},
		["datetime_format"] =		{"Advanced", "tHubSettings.Main.sDateTimeFormat", "s", ".+", nil, "%Y/%m/%d %H:%M:%S", nil, "Date and time display format: http://flexhub.org/wiki/index.php/Date_and_time_formatting"},
		["hidden_name"] = 		{"Advanced", "tHubSettings.Main.sHiddenUser", "s", ".+", nil, "Hidden User", nil, "Name to appear in mainchat when a hidden user is chatting"},

--~ 		["inform_suppress"] =		{"Advanced", "tHubSettings.Main.iInformTime", "i", -1, nil, -1, nil},

		["geoip_enable"] = 		{"Advanced", "tHubSettings.Main.bUseGeoIP", "b", nil, nil, true, "geoip_enable", "Enable resolving of IP to country, for display in userinfo"},

--~ 		["protocol_default"] = 		{"Advanced", "tHubSettings.Main.sDefaultProtocol", "s", {"ADC", "NMDC"}, nil, "NMDC", nil, "},
		["nmdc_lockwait"] = 		{"Advanced", "tHubSettings.Main.iLockWait", "i", 0, 5, 2, nil, "Time to wait for ADC-traffic before starting NMDC handshake"},

		["savestats_t"] = 		{"Advanced", "tHubSettings.SaveStats", "t", nil, nil, {},},

		["log_t"] = 				{"Advanced", "tHubSettings.Main.Logs", "t", nil, nil, {},},
		["log_mainchat"] = 		{"Advanced", "tHubSettings.Main.Logs.mainchat", "b", nil, nil, true, nil, "Store mainchat in log-file"},
		["log_feed"] = 			{"Advanced", "tHubSettings.Main.Logs.feed", "b", nil, nil, true, nil, "Store feedroom messages in log-file"},
		["log_opchat"] = 			{"Advanced", "tHubSettings.Main.Logs.opchat", "b", nil, nil, true, nil, "Store opchat messages in log-file"},
		["log_rooms"] = 			{"Advanced", "tHubSettings.Main.Logs.rooms", "b", nil, nil, true, nil, "Store room messages in log-file"},

		--// RULES
		["rules"] = 				{"Rules", nil, nil, nil, nil, nil, nil, "Hub rules / Connection limits"},
		["minshare"] = 			{"Rules", "tHubSettings.tRules.iMinShare", "f", 0, "100Tb", 0, nil, "Minimum share to be allowed to join the hub (in B, kB, MB, GB, TB)"},
		["minshare_download"] =	{"Rules", "tHubSettings.tRules.iMinShareDownload", "f", 0, nil, 0, nil, "Minimum share to be allowed to seach and download (size in B, kB, MB, GB, TB)"},
		["minshare_reg"] =		{"Rules", "tHubSettings.tRules.iMinShareReg", "f", 0, nil, 0, nil, "Minimum share to be allowed to register using !regme (in B, kB, MB, GB, TB)"},
		["maxshare"] = 			{"Rules", "tHubSettings.tRules.iMaxShare", "f", 0, nil, "10Tb", nil, "Maximum share to be allowed to join the hub (in B, kB, MB, GB, TB)"},
		["minslots"] = 			{"Rules", "tHubSettings.tRules.iMinSlots", "i", 0, nil, 0, nil, "Minimum amount of slots to be allowed to join the hub"},
		["maxslots"] = 			{"Rules", "tHubSettings.tRules.iMaxSlots", "i", 0, nil, 1000, nil, "Maximum amount of slots to be allowed to join the hub"},
--~ 		["slotratio"] = 			{"Rules", "tHubSettings.tRules.iSlotRatio", "i", 0, nil, 999},
		["maxhubs"] = 			{"Rules", "tHubSettings.tRules.iMaxHubs", "i", 0, nil, 1000, nil, "Maximum amount of hubs a user is allowed to be connected to"},
		["maxpublichubs"] = 		{"Rules", "tHubSettings.tRules.iMaxPublicHubs", "i", 0, nil, 1000, nil, "Maximum amount of public hubs a user is allowed to be connected to"},
		["maxreghubs"] = 		{"Rules", "tHubSettings.tRules.iMaxRegHubs", "i", 0, nil, 1000, nil, "Maximum amount of hubs where user is registered to be allowed to join the hub"},
		["maxophubs"] = 			{"Rules", "tHubSettings.tRules.iMaxOpHubs", "i", 0, nil, 1000, nil, "Maximum amount of hubs where user is operator to be allowed to join the hub"},
--~ 		["hubratio"] = 			{"Rules", "tHubSettings.tRules.iHubRatio", "i", 0, nil, 0},
		["maxusers"] = 			{"Rules", "tHubSettings.tRules.iMaxUsers", "i", 0, nil, 1000, "maxusers", "Maximum amount of users allowed in the hub"},
		["regonly"]=			{"Rules", "tHubSettings.tRules.bRegOnly", "b", nil, nil, false, nil, "Allow only registered users to join the hub"},
		["chatonly"] = 			{"Rules", "tHubSettings.tRules.bChatOnly", "b", nil, nil, true, "chatonly", "Disable all searches and downloads"},
		["chatonly_hideshare"] =	{"Rules", "tHubSettings.tRules.bChatOnlyHideShare", "b", nil, nil, true, nil, "Hide shares when hub is set to chat only"},

		["reg_prefix"] = 			{"Rules", "tHubSettings.tRules.sRegPrefix", "s", nil, nil, "", "reg_prefix", "Nickname must have this prefix to be able to register using !regme"},
		["unregged_download"] = 	{"Rules", "tHubSettings.tRules.bUnreggedDownload", "b", nil, nil, true, nil, "Allow unregistered users to download and search"},
		["passive_download"] = 	{"Rules", "tHubSettings.tRules.bPassiveDownload", "b", nil, nil, true, nil, "Allow downloads/searches of passive users"},
		["allowpassive"] = 		{"Rules", "tHubSettings.tRules.bAllowPassive", "b", nil, nil, true, nil, "Allow passive users to join the hub"},
		["allowproxy"] = 			{"Rules", "tHubSettings.tRules.bAllowProxy", "b", nil, nil, false, nil, "Allow proxy users to join the hub"},
		["allowdht"] = 			{"Rules", "tHubSettings.tRules.bAllowDHT", "b", nil, nil, true, nil, "Allow users with DHT enabled to join the hub (only works for certain clients)"},
		["allowfalseactive"] = 		{"Rules", "tHubSettings.tRules.bAllowFalseActive", "b", nil, nil, false, nil, "Allow passive searches from 'active' (as stated in tag) users"},
		["allowfalsepassive"] =		{"Rules", "tHubSettings.tRules.bAllowFalsePassive", "b", nil, nil, false, nil, "Allow active searches from 'passive' (as stated in tag) users"},
		["allowpinger"] =			{"Rules", "tHubSettings.tRules.bAllowPinger", "b", nil, nil, true, nil, "Allow hublist pingers to connect to the hub"},

		["allowadc"] = 			{"Rules", "tHubSettings.tRules.bAllowADC", "b", nil, nil, true, nil, "Allow ADC users  to join the hub"},
		["allownmdc"] = 			{"Rules", "tHubSettings.tRules.bAllowNMDC", "b", nil, nil, true, nil, "Allow NMDC users to join the hub"},

		--// REDIRECTS
		["redirects"] = 			{"Redirects", nil, nil, nil, nil, nil, nil, "Redirect settings"},
		["rd_list"] =				{"Redirects", "tHubSettings.tRedirects.tList", "t", nil, nil,{}},

		["rd_checkinterval"] = 		{"Redirects", "tHubSettings.tRedirects.iCheckInterval", "d", 0, nil, 0, nil, "Automatic check if redirects are online, set to 0 to disable checking"},
		["rd_checktimeout"] = 		{"", "tHubSettings.tRedirects.iCheckTimeout", "i", 0, 5, 3, nil, "Amount of time to wait for a connection with the remote hub, when checking online status"},
		["rd_checkalert"] = 		{"Redirects", "tHubSettings.tRedirects.bAlertOffline", "b", nil, nil, false, nil, "Alert in feed when a redirect address goes online or offline"},
		["rd_checkfallback"] = 		{"Redirects", "tHubSettings.tRedirects.sFallback", "s", {"none", "main", "any"}, nil, "none", nil, "EXPERIMENTAL: Fallback address for redirects, use none, main or any"},

		["rd_mode"] = 			{"Redirects", "tHubSettings.tRedirects.sMode", "s", {"normal", "array"}, nil, "normal", nil, ""},	--// normal, array (uses main)
		["rd_failover"] =			{"Redirects", "tHubSettings.tRedirects.sFailOver", "s", nil, nil, "", "rd_failover", "Specify failover addresses for clients to connect to when hub goes offline, always use a portnumber and use comma as separator, no spaces"},
		["rd_adc_disabled"] = 		{"Redirects", "tHubSettings.tRedirects.sNoADC", "s", nil, nil, "no.adcdisabled.redirect.specified:8000", "updateredirect", "When ADC is disabled, users with ADC will be redirected here. Own NMDC hubaddress can be used"},
		["rd_nmdc_disabled"] = 	{"Redirects", "tHubSettings.tRedirects.sNoNMDC", "s", nil, nil, "adc://no.nmdcdisabled.redirect.specified:8000", "updateredirect", "When NMDC is disabled, users with NMDC will be redirected here. Own ADC hubaddress can be used"},

		["rd_passive"] = 			{"Redirects", "tHubSettings.tRedirects.sPassive", "s", nil, nil, "no.passive.redirect.specified:8000", "updateredirect", "Redirect address for passive users if passive users aren't allowed to join. See !set allowpassive"},
		["rd_maxhubs"] = 		{"Redirects", "tHubSettings.tRedirects.sMaxHubs", "s", nil, nil, "no.minslots.redirect.specified:8000", "updateredirect", "Redirect address for users with too many hubs"},
		["rd_minslots"] = 			{"Redirects", "tHubSettings.tRedirects.sMinSlots", "s", nil, nil, "no.minslots.redirect.specified:8000", "updateredirect", "Redirect address for users with too few slots"},
		["rd_maxslots"] = 		{"Redirects", "tHubSettings.tRedirects.sMaxSlots", "s", nil, nil, "no.maxslots.redirect.specified:8000", "updateredirect", "Redirect address for users with too many slots"},
		["rd_minshare"] = 		{"Redirects", "tHubSettings.tRedirects.sMinShare", "s", nil, nil, "no.minshare.redirect.specified:8000", "updateredirect", "Redirect address for users with too small share"},
		["rd_maxshare"] = 		{"Redirects", "tHubSettings.tRedirects.sMaxShare", "s", nil, nil, "no.maxshare.redirect.specified:8000", "updateredirect", "Redirect address for users with too large share"},
		["rd_flood"] = 			{"Redirects", "tHubSettings.tRedirects.sFlood", "s", nil, nil, "no.flood.redirect.specified:8000", "updateredirect", "Redirect address for users that are flooding"},
		["rd_main"] = 			{"Redirects", "tHubSettings.tRedirects.sMain", "s", nil, nil, "no.main.redirect.specified:8000", "updateredirect", "General redirect address"},
		["rd_regonly"] = 			{"Redirects", "tHubSettings.tRedirects.sRegOnly", "s", nil, nil, "", "updateredirect", "Redirect address when hub is regonly"},
		["rd_full"] = 			{"Redirects", "tHubSettings.tRedirects.sFull", "s", nil, nil, "no.hubfull.redirect.specified:8000", "updateredirect", "Redirect address for when hub is full"},
		["rd_deadend"] = 		{"Redirects", "tHubSettings.tRedirects.sDeadEnd", "s", nil, nil, "no.deadend.redirect.specified:8000", "updateredirect", "Redirect address for users in a redirect-loop. Only used when !set rd_breakloop_enable = true"},
		["rd_deadendfail"] = 		{"Redirects", "tHubSettings.tRedirects.sDeadEndFail", "s", nil, nil, "no.deadendfail.redirect.specified:8000", "updateredirect", "Redirect address for users who are still reconnecting after being send to the deadend address"},
		["rd_breakloop_enable"] =	{"Redirects", "tHubSettings.tRedirects.bBreakLoop", "b", nil, nil, false, nil, "Break a redirect loop if a redirected users keeps reconnecting to the hub. Warning: experimental feature!"},
		["rd_breakloop_timeout"] = 	{"Redirects", "tHubSettings.tRedirects.iBreakLoopTimeout", "d", 0, 3600, 120, nil, "Time in seconds since last redirect that a user will be considered to be in a redirect-loop"},
		["rd_breakloop_times"] = 	{"Redirects", "tHubSettings.tRedirects.iBreakLoopTimes", "i", 0, 100, 5, nil, "Number of allowed reconnects before a user is considered to be in a redirect-loop"},

		--// TRAFFIC
		["traffic"] = 			{"Traffic", nil, nil, nil, nil, nil, nil, "Traffic and bandwidth related settings"},
		["traffic_t"] =			{"Traffic", "tHubSettings.tTraffic", "t", nil, nil, {}},
		["traffic_t1"] =			{"Traffic", "tHubSettings.tTraffic.tHide", "t", nil, nil, {}},
		["zpipemin"] = 			{"Traffic", "tHubSettings.tTraffic.ZPipeMin", "i", 0, 2048, 150, nil, "Minimum amount of data for compression to be used"},	-- minimum amount of data that will be compressed
		["myinfo_interval"] = 		{"Traffic", "tHubSettings.tTraffic.iMyInfoInterval", "i", 0, 3600, 300, nil, "Seconds between sending of updated client-info of a user"},	-- MyINFO's and BINF's will be pooled, after sending a changed info, it will wait myinfo_interval before sending new changes from a client
--~ 		["adcinfo_interval"] = 		{"Traffic", "tHubSettings.tTraffic.iADCInfoInterval", "i", 0, 3600, 20, nil, "Seconds between sending of updated ADC client-info of a user"},	-- BINF's will be pooled, after sending a BINF, it will wait and collect any new BINF's before sending new changes from a client
--~ 		["nmdcinfo_interval"] = 		{"Traffic", "tHubSettings.tTraffic.iNMDCInfoInterval", "i", 0, 3600, 300, nil, "Seconds between sending of updated NMDC client-info of a user"},	-- MyINFO's will be pooled, after sending a changed info, it will wait before sending new changes from a client
		["show_tag"] =  			{"Traffic", "tHubSettings.tTraffic.tShow.TA", "b", nil, nil, true, nil, "Show tag to all users, if false: shows only to operators"},
		["show_protocol"] = 		{"Traffic", "tHubSettings.tTraffic.tShow.Protocol", "b", nil, nil, true, nil, "Show protocol in description, will only be hidden if one of the protocols is disabled in !set rules"},

		["show_desc"] = 			{"Traffic", "tHubSettings.tTraffic.tShow.DE", "b", nil, nil, true, nil, "Show description to all users, if false: shows only to operators"},
		["show_share"] = 		{"Traffic", "tHubSettings.tTraffic.tShow.SS", "b", nil, nil, true, nil, "Show sharesize to all users, if false: shows only to operators"},
		["show_email"] = 			{"Traffic", "tHubSettings.tTraffic.tShow.EM", "b", nil, nil, true, nil, "Show email to all users, if false: shows only to operators"},
		["show_conn"] = 			{"Traffic", "tHubSettings.tTraffic.tShow.CO", "b", nil, nil, true, nil, "Show connection details to all users, if false: shows only to operators"},
		["show_opfull"] = 		{"Traffic", "tHubSettings.tTraffic.tShow.FullOp", "b", nil, nil, true, nil, "Show full info on operators to all users, if false: shows only to operators"},
		["show_botfull"] = 		{"Traffic", "tHubSettings.tTraffic.tShow.FullBot", "b", nil, nil, true, nil, "Show full info on bots/rooms to all users, if false: shows only to operators (Not supported yet)"},
		["drop_existing"] = 		{"Traffic", "tHubSettings.tTraffic.bDropExisting", "b", nil, nil, true, nil, "If true: allow registered user to enter if same nick (from same IP) already exists in the hub. Drops existing nick."},
			
		--// TCP
		["tcp"] = 				{"Tcp", nil, nil, nil, nil, nil, nil, "Advanced TCP socket settings"},
		["data_skiptime"] = 		{"Tcp", "tHubSettings.tTcp.DataSkipTime", "d" ,0, nil, 0, nil, "Expert setting: delay between sending of non-chat data"},		
		["buffersize"] = 			{"Tcp", "tHubSettings.tTcp.BufferSize", "i" ,128, nil, 1024, nil, "Expert setting: maximum size to read from socketbuffer"},
		["socket_sendtimeout"] = 	{"Tcp", "tHubSettings.tTcp.SocketSendTimeout", "i" , 0, 0, 0, nil, "Expert setting: socket timeout for sending traffic"},   -- nil will make it blocking, sending everything until done
		["socket_sendmode"] = 	{"Tcp", "tHubSettings.tTcp.SocketSendTimeoutMode", "s" ,nil, nil, "t", nil, "Expert setting: socket send mode, t = total timeout, b = block timeout"},
--~ 		["hub_timeout"] = 			{"Tcp", "tHubSettings.tTcp.HubTimeout", "i" ,0, 100, 10, nil, "Expert setting: },
		["disable_nagle"] = 		{"Tcp", "tHubSettings.tTcp.DisableNagle", "b" ,nil, nil, false, nil, "Expert setting: Disables Nagle's algorithm for the connection, sends traffic without delay"},
		["nonrespond_wait"] = 		{"Tcp", "tHubSettings.tTcp.NonRespondWait", "i" ,0, 2, 0, nil, "Expert setting: Time to wait in seconds before trying a non-responsive socket again"},
--~ 		["nonrespond_times"] = 		{"Tcp", "tHubSettings.tTcp.NonRespondTimes", "i" ,1, nil, 10},	--// Depracated? Using nonrespond_timeout now
		["disconnect_timeout"] = 	{"Tcp", "tHubSettings.tTcp.DisconnectTimeout", "i" ,1, 300, 5, nil, "Expert setting: Time in seconds to allow a client to receive last traffic (disconnect-reason) before disconnecting"},
		["nonrespond_timeout"] =	{"Tcp", "tHubSettings.tTcp.SendTimeout", "d", 1, nil, 60, nil, "Expert setting: Time in seconds before a non-responding socket will be disconnected"},
		["nonrespond_flushtime"] =	{"Tcp", "tHubSettings.tTcp.SendFlushTime", "d", 1, nil, 600, nil, "Expert setting: Time in seconds before a sendbuffer of a non-responding socket will be flushed"},
		["ssl_handshaketimeout"] =	{"Tcp", "tSecurity.General.SSLHandshakeTimeout", "d", 1, nil, 5, nil, "Expert setting: Time in seconds before an SSL handshake will timeout"},

		
		--~ 	["TcpSocketReadTimeout"] = 0,
		--~ 	["TcpSocketReadTimeoutMode"] = "t",

		--// THREAD
		["thread"] = 			{"Thread", nil, nil, nil, nil, nil, nil, "Advanced thread/speed settings, CPU-usage tuning"},
		["serverwait"] = 			{"Thread", "tHubSettings.tThreads.ServerWait", "i" ,0, 1000, 100, nil, "Expert setting: Time in milliseconds to pause after each new connection, determines max new connections per second"},	-- pause (millisecs) in accepting clientsockets, this determines max amount of connections per second: 100 = 10 per second, etc
		["listenwait"] = 			{"Thread", "tHubSettings.tThreads.ListenWait", "i" ,0, 1000, 100, nil, "Expert setting: Time in milliseconds to pause after each cycle over all joined sockets, influences cpu-usage/lag"},	-- pause in TcpListen
		["loginwait"] = 			{"Thread", "tHubSettings.tThreads.LoginWait", "i" ,0, 1000, 100, nil, "Expert setting: Time in milliseconds to pause after each cycle over all login sockets, influences cpu-usage/lag (disabled)"},		-- pause in TcpLogin (disabled in beta)
		["parsewait"] = 			{"Thread", "tHubSettings.tThreads.ParseWait", "i" ,0, 1000, 100, nil, "Expert setting: Time in milliseconds to pause after each cycle of parsing all incoming user traffic (disabled)"},	-- pause in TcpParse (if it uses a threadloop, disabled in beta)
		["listentimeout"] =		{"", "tHubSettings.tThreads.ListenTimeout", "i" ,5, nil, 90, nil, "Expert setting: Time in seconds allowed for the listenthread to run a full cycle, if it takes longer it will initiate a hub restart"},	-- pause in TcpParse (if it uses a threadloop, disabled in beta)

		--// HUBLISTS
		["hublists"] = 			{"Hublists", nil, nil, nil, nil, nil, nil, "Hublist settings"},
		["hublist_t"] =			{"Hublists", "tHubSettings.tHubLists", "t", nil, nil, {}},
		["hublistnmdc_t"] =		{"Hublists", "tHubSettings.tHubLists.NMDC", "t", nil, nil, {}},
		["hublistadc_t"] =			{"Hublists", "tHubSettings.tHubLists.ADC", "t", nil, nil, {}},
		["reghub_mininterval"] = 	{"", "tHubSettings.tHubLists.MinInterval", "d", 60, nil, 900, nil, "Minimum time between manual hublist registrations (!reghub)"},
		["reghub_interval"] = 		{"Hublists", "tHubSettings.tHubLists.AutoInterval", "d", 0, nil, 86400, "reghub_interval", "Time between automatic hublists registrations, or 0 to disable."},

		["pinger_announce"] =		{"Hublists", "tHubSettings.tHubLists.bPingerAnnounce", "b", nil, nil, true, nil, "Announce pinger when it connects to the hub"},
		["pinger_message"] =		{"Hublists", "tHubSettings.tHubLists.sPingerMsg", "s", nil, nil, "Pinger detected from IP: %[user_ip] with name: %[user_name] \t\t\t\t\t\t\t\t\t\t\t\t\t\t is kicking because:", nil, "Message when pinger connects"},
		["pinger_announcelevel"] =	{"Hublists", "tHubSettings.tHubLists.iPingerLevel", "i", nil, nil, 8, nil, "Minimum profilelevel that will receive the pinger-announcements"},
		["pinger_target"] = 		{"Hublists", "tHubSettings.tHubLists.sPingerOutput", "s", {"mainchat", "feed", "opchat"}, nil, "mainchat", nil, "Output of the pinger announcements to: mainchat, feed or opchat"},

		--// SECURITY
		["security"] = 			{"Security", nil, nil, nil, nil, nil, nil, "Security and anti-flood settings"},
		["flood_action"] = 		{"Security", "tSecurity.Rules.sAction", "s", SubSet.ActionListFilter, "%W", "Ban", nil, "Action on flood: "..SubSet.ActionListString},
		["wrongmode_action"] = 	{"Security", "tSecurity.General.sWrongModeAction", "s", SubSet.ActionListFilter, "%W", "Kick", nil, "Action on wrong mode traffic (active/passive): "..SubSet.ActionListString},
--~ 		["badprotocol_action"] =		{"Security", "tSecurity.General.sBadProtocolAction", "s", SubSet.ActionListFilter, "%W", SubSet.ActionListFilter[1], nil, "Action on bad protocol message: "..SubSet.ActionListString},

		["show_warns"] = 		{"Security", "tSecurity.General.bShowWarnings", "b", nil, nil, true, nil, "Show warnings in mainchat"},
		["check_key"] =			{"Security", "tSecurity.General.bCheckKey", "b", nil, nil, true, nil, "NMDC Login: disconnect user if a wrong $Key was sent."},

		["autoban_time"] = 		{"Security", "tSecurity.General.DefaultAutoban", "d", 1, nil, 7200,nil, "Default autoban duration (in S,M,H,D,W or Y)"},	--// Time in seconds, default 1 week
		["ban_time"] = 			{"Security", "tSecurity.General.DefaultTimeban", "d", 1, nil, 604800,nil, "Default tempban duration (in S,M,H,D,W or Y)"},	--// Time in seconds, default 1 week
		["ban_maxtime"] = 		{"Security", "tSecurity.General.MaxBan", "d", 1, nil, 31536000, nil, "Maximum ban duration (in S,M,H,D,W or Y), longer bans will use this time"},		--// Time in seconds, default 1 year

		["warn_max"] = 			{"Security", "tSecurity.General.WarnMax", "i", 1, nil, 3, nil, "Maximum number of warnings, more warnings will result in a kick"},

		["kick_time"] = 			{"Security", "tSecurity.General.KickTime", "d", 1, nil, 7200, nil, "Tempban duration of a kick"},			--// Time in seconds, default 2 hours
		["kick_max"] = 			{"Security", "tSecurity.General.KickMax", "i", 1, nil, 3, nil, "Maximum number of kicks, more kicks will result in a ban"},
		["kick_bantime"] = 		{"Security", "tSecurity.General.KickMaxBanTime", "d", 1, nil, 172800,nil, "Tempban duration when user is banned because of too many kicks"},	--// Default 48 hours
			
		["clone_max"] = 			{"Security", "tSecurity.General.ClonesMax", "i", 0, nil, 2, nil, "Maximum allowed number of clones from one IP"},
		["clone_bantime"] = 		{"Security", "tSecurity.General.ClonesBanTime", "d", 1, nil, 7200, nil, "Tempban duration when too many clones are connecting"},			--// Time in seconds
		["clone_ban"] = 			{"Security", "tSecurity.General.ClonesBan", "b", nil, nil, true, nil, "Ban IP when maximum allowed number of clones was exceeded (true=ban, false=only disconnect new clones)"},			--// true: ban clones, false: disconnect new clones
				
		["pass_max"] = 				{"Security", "tSecurity.General.WrongPassMax", "i", 1, 20, 3, nil, "Maximum allowed password attempts"},
		["pass_bantime"] = 			{"Security", "tSecurity.General.WrongPassBan", "d", 1, nil, 7200, nil, "IP Tempban duration for too many wrong password attempts"},			--// Time in seconds
		["pass_msg"] = 				{"Security", "tSecurity.General.WrongPassMsg", "s", nil, nil, "You provided a wrong password." , nil, "Message sent to user when trying to login using the wrong password"},
		["pass_allowblank"] = 		{"Security", "tSecurity.General.AllowBlankPass", "b", nil, nil, false, nil, "Allow creating accounts without passwords (user sets password on login, as in verlihub)"},
		["pass_cleanbind"] = 		{"Security", "tSecurity.General.CleanBindIP", "b", nil, nil, true, nil, "If enabled, the bindip set when creating the account is cleared when the user set a password"},

--~ 		["login_rate"] = 		{"Security", "tSecurity.General.LoginRate", "i", 1, nil, 10, nil, "Amount of allowed connections per second"},			--// Amount of logins per second, is used to set: serverwait = 1000 / login_rate
		["login_timeout"] = 		{"Security", "tSecurity.General.LoginTimeout", "d", 5, nil, 60, nil, "Amount of time a login may take"},
		["reconnect_timeout"] = 	{"Security", "tSecurity.General.ReconnectTimeout", "d", 0, nil, 20, nil, "Waittime before reconnecting, to prevent connection hammering"},

		["doublelogin_timeout"] = 	{"", "tSecurity.General.DoubleLoginTimeout", "d", 0, nil, 300, nil, "Waittime before reconnecting, when hammering connection, or alternating logins"},
		["doublelogin_time"] = 		{"", "tSecurity.General.DoubleLoginTime", "d", 0, nil, 480, nil, "Amount of time allowed between double logins without increasing the double login counter"},
		["doublelogin_max"] = 		{"", "tSecurity.General.DoubleLoginMax", "i", 0, nil, 3, nil, "Maximum amount of double logins in (login while user with same nick already connected"},

		["lock_main"] = 			{"Security", "tSecurity.General.MainLocked", "b", nil, nil, false, nil, "Lock mainchat (true=locked, false=unlocked"},
		["lock_pm"] = 				{"Security", "tSecurity.General.PmLocked", "b", nil, nil, false, nil, "Lock private messages (true=locked, false=unlocked"},

		["commandsize"] = 			{"Security", "tSecurity.General.MaxParseBuffer", "i", 0, 16384, 2048, nil, "Expert setting: maximum allowed number of chars for a single command, larger amount will result in a disconnect"},
		["protect_local"] = 		{"Security", "tSecurity.General.ProtectLocal", "b", nil, nil, "true", nil, "Protect IP's in the range 192.168.*.* from kicks/bans/automatic redirects"},
		
		["topic_length"] = 			{"Security", "tSecurity.General.TopicMaxLength", "i", 512, 16384, 2048, nil, "Maximum length of topic"},

		--// DDOS SETTINGS
		["securitydd"] =	 		{"Security", nil, nil, nil, nil, nil, nil, "Settings for handling DDOS attacks"},
		["security_dd"] =	 		{"Security", "tSecurity.Ddos", "t", nil, nil, {}},
		["attack_reportinterval"] =	{"Security", "tSecurity.Ddos.iAttackReportInterval", "i", 1, nil, 60, nil, "If the hub is being DDOS-ed, statusreports in feed will appear every x seconds."},
		["attack_reportrate"] =		{"Security", "tSecurity.Ddos.iAttackMinRate", "i", 1, nil, 10, nil, "Minimum amount of invalid connections per reportinterval that will cause sending attack reports."},
		["attack_serverwaittime"] =	{"Security", "tSecurity.Ddos.iServerWaitTime", "i", 0, nil, 0, nil, "Expert setting: Serversocket wait time in milliseconds after a normal connection during an attack"},
	
		--// BANDWIDTH LIMITER
		["securitybw"] =	 		{"Security BW", nil, nil, nil, nil, nil, nil, "Bandwidth limiting (for unknown ADC traffic)"},
		["security_bw"] =	 		{"Security BW", "tSecurity.BW", "t", nil, nil, {}},
--~ 		["bw_minlength"] = 			{"Security BW", "tSecurity.BW.MinLength", "i", 1, nil, 3, nil, "Minimum search length"},
--~ 		["bw_maxlength"] = 			{"Security BW", "tSecurity.BW.MaxLength", "i", 1, nil, 256},
--~ 		["bw_length_action"] =		{"Security BW", "tSecurity.BW.LengthAction", "s", SubSet.ActionListFilter, "%W", "Notify"},

		["bw_usermax1"] = 		{"Security BW", "tSecurity.BW.iMaxCount1", "f", 1, nil, 3, nil, "Bandwidth limit 1, amount of bytes (not supported yet)"},
		["bw_usertime1"] = 		{"Security BW", "tSecurity.BW.iTime1", "d", 1, nil, 50, nil, "Bandwidth limit 1, amount of time (not supported yet)"},
		["bw_useraction1"] = 		{"Security BW", "tSecurity.BW.sAction1", "s", SubSet.ActionListFilter, "%W", "Notify", nil, "Bandwidth limit 1, action (not supported yet)"},
		
		["bw_usermax2"] = 		{"Security BW", "tSecurity.BW.iMaxCount1", "i", 1, nil, 3, nil, "Bandwidth limit 2, amount of bytes (not supported yet)"},
		["bw_usertime2"] = 		{"Security BW", "tSecurity.BW.iTime1", "d", 1, nil, 50, nil, "Bandwidth limit 2, amount of time (not supported yet)"},
		["bw_useraction2"] = 		{"Security BW", "tSecurity.BW.sAction1", "s", SubSet.ActionListFilter, "%W", "Kick", nil, "Bandwidth limit 2, action (not supported yet)"},
		
		--~ 	["ActionList"] = {"Redirect", "Disabled", "Ignore", "Notify", "Warn", "Muppetize", "Kenny", "Mute", "Disconnect", "Kick", "Ban", "TempBan", "FloodBan", "LockMain"},			

		--// MAINCHAT SECURITY
		["securitymc"] =	 		{"Security MC", nil, nil, nil, nil, nil, nil, "Mainchat anti-flood settings"},
		["security_mc"] =			{"Security MC", "tSecurity.MC", "t", nil, nil, {}},
		["mc_maxlines"] = 		{"Security MC", "tSecurity.MC.MaxLines", "i", 1, nil, 6, nil, "Maximum number of mainchat lines"},
		["mc_maxlength"] = 		{"Security MC", "tSecurity.MC.MaxLength", "i", 1, nil, 1024, nil, "Maximum mainchat length"},
--~ 		["mc_truncate"] = 		{"Security MC", "tSecurity.MC.Truncate", "i", 1, nil, 1024, nil, "Maximum size of a mainchat message, longer messages will be truncated (chopped off)"},
		["mc_length_action"] = 	{"Security MC", "tSecurity.MC.LengthAction", "s", SubSet.ActionListFilter, "%W", "Notify", nil, "Action on wrong mainchat length: "..SubSet.ActionListString},

		["mc_usermax1"] = 		{"Security MC", "tSecurity.MC.iMaxCount1", "i", 1, nil, 2, nil, "Mainchat userlimit 1, amount of mainchat messages"},
		["mc_usertime1"] = 		{"Security MC", "tSecurity.MC.iTime1", "d", 1, nil, 5, nil, "Mainchat userlimit 1, amount of time"},
		["mc_useraction1"] = 		{"Security MC", "tSecurity.MC.sAction1", "s", SubSet.ActionListFilter, "%W", "Notify", nil, "Mainchat userlimit 1, action: "..SubSet.ActionListString},
		["mc_usermax2"] = 		{"Security MC", "tSecurity.MC.iMaxCount2", "i", 1, nil, 5, nil, "Mainchat userlimit 2, amount of mainchat messages"},
		["mc_usertime2"] = 		{"Security MC", "tSecurity.MC.iTime2", "d", 1, nil, 5, nil, "Mainchat userlimit 2, amount of time"},
		["mc_useraction2"] = 		{"Security MC", "tSecurity.MC.sAction2", "s", SubSet.ActionListFilter, "%W", "Kick", nil, "Mainchat userlimit 2, action: "..SubSet.ActionListString},

--~ 		["mc_hubmax1"] = 		{"Security MC", "tSecurity.MC.iHubMaxCount1", "i", 1, nil, 10, nil, "Mainchat hublimit 1, amount of mainchat messages"},
--~ 		["mc_hubtime1"] = 		{"Security MC", "tSecurity.MC.iHubTime1", "d", 1, nil, 5, nil, "Mainchat hublimit 1, amount of time"},
--~ 		["mc_hubaction1"] = 		{"Security MC", "tSecurity.MC.sHubAction1", "s", SubSet.ActionListFilter, "%W", "Notify", nil, "Mainchat hublimit 1, action: "..SubSet.ActionListString},
--~ 		["mc_hubmax2"] = 		{"Security MC", "tSecurity.MC.iHubMaxCount2", "i", 1, nil, 20, nil, "Mainchat hublimit 2, amount of mainchat messages"},
--~ 		["mc_hubtime2"] = 		{"Security MC", "tSecurity.MC.iHubTime2", "d", 1, nil, 10, nil, "Mainchat hublimit 2, amount of time"},
--~ 		["mc_hubaction2"] = 		{"Security MC", "tSecurity.MC.sHubAction2", "s", SubSet.ActionListFilter, "%W", "LockMain", nil, "Mainchat hublimit 2, action: "..SubSet.ActionListString},

		--// PM SECURITY
		["securitypm"] =	 		{"Security PM", nil, nil, nil, nil, nil, nil, "PM anti-flood settings"},
		["security_pm"] =	 		{"Security PM", "tSecurity.PM", "t", nil, nil, {}},
		["pm_minlength"] = 		{"Security PM", "tSecurity.PM.MinLength", "i", 1, nil, 1, nil, "Minimum private message length"},
		["pm_maxlength"] = 		{"Security PM", "tSecurity.PM.MaxLength", "i", 1, nil, 2048, nil, "Maximum private message length"},
		["pm_length_action"] = 	{"Security PM", "tSecurity.PM.LengthAction", "s", SubSet.ActionListFilter, "%W", "Notify", nil, "Action on wrong private message length: "..SubSet.ActionListString},	--// Defaults to notify

		["pm_usermax1"] = 		{"Security PM", "tSecurity.PM.iMaxCount1", "i", 1, nil, 3, nil, "Private message limit 1, amount of messages"},
		["pm_usertime1"] = 		{"Security PM", "tSecurity.PM.iTime1", "d", 1, nil, 10, nil, "Private message limit 1, amount of time"},
		["pm_useraction1"] = 		{"Security PM", "tSecurity.PM.sAction1", "s", SubSet.ActionListFilter, "%W", "Notify", nil, "Private message limit 1, action: "..SubSet.ActionListString},	--// Defaults to notify
		["pm_usermax2"] = 		{"Security PM", "tSecurity.PM.iMaxCount2", "i", 1, nil, 8, nil, "Private message limit 2, amount of messages"},
		["pm_usertime2"] = 		{"Security PM", "tSecurity.PM.iTime2", "d", 1, nil, 20, nil, "Private message limit 2, amount of time"},
		["pm_useraction2"] = 		{"Security PM", "tSecurity.PM.sAction2", "s", SubSet.ActionListFilter, "%W", "Disconnect", nil, "Private message limit 2, action: "..SubSet.ActionListString},	--// Defaults to disconnect

		--// NICK SECURITY
		["securityni"] =	 		{"Security NI", nil, nil, nil, nil, nil, nil, "Nick security anti-flood settings"},
		["security_ni"] =	 		{"Security NI", "tSecurity.NI", "t", nil, nil, {}},
		["ni_minlength"] = 		{"Security NI", "tSecurity.NI.MinLength", "i", 1, nil, 3, nil, "Minimum nick length"},
		["ni_maxlength"] = 		{"Security NI", "tSecurity.NI.MaxLength", "i", 1, 64, 32, nil, "Maximum nick length"},
		["ni_length_action"] = 		{"Security NI", "tSecurity.NI.LengthAction", "s", SubSet.ActionListFilter, "%W", "Disconnect", nil, "Action on wrong nick length: "..SubSet.ActionListString},	--// Defaults to disconnect

		--// ACTIVE SEARCH SECURITY
		["securitysa"] =	 		{"Security SA", nil, nil, nil, nil, nil, nil, "Active search anti-flood settings"},
		["security_sa"] =	 		{"Security SA", "tSecurity.SA", "t", nil, nil, {}},
		["sa_minlength"] = 		{"Security SA", "tSecurity.SA.MinLength", "i", 1, nil, 3, nil, "Minimum search length"},
		["sa_maxlength"] = 		{"Security SA", "tSecurity.SA.MaxLength", "i", 1, nil, 256, nil, "Maximum search length"},
		["sa_length_action"] = 		{"Security SA", "tSecurity.SA.LengthAction", "s", SubSet.ActionListFilter, "%W", "Notify", nil, "Action on wrong search length: "..SubSet.ActionListString},	--// Defaults to notify

		["sa_usermax1"] = 		{"Security SA", "tSecurity.SA.iMaxCount1", "i", 1, nil, 3, nil, "Search limit 1, amount of searches"},
		["sa_usertime1"] = 		{"Security SA", "tSecurity.SA.iTime1", "d", 1, nil, 10, nil, "Search limit 1, amount of time"},
		["sa_useraction1"] = 		{"Security SA", "tSecurity.SA.sAction1", "s", SubSet.ActionListFilter, "%W", "Notify", nil, "Search limit 1, action: "..SubSet.ActionListString},	--// Defaults to notify
		["sa_usermax2"] = 		{"Security SA", "tSecurity.SA.iMaxCount2", "i", 1, nil, 10, nil, "Search limit 2, amount of searches"},
		["sa_usertime2"] = 		{"Security SA", "tSecurity.SA.iTime2", "d", 1, nil, 20, nil, "Search limit 2, amount of time"},
		["sa_useraction2"] = 		{"Security SA", "tSecurity.SA.sAction2", "s", SubSet.ActionListFilter, "%W", "Disconnect", nil, "Search limit 2, action: "..SubSet.ActionListString},	--// Defaults to disconnect

		--// PASSIVE SEARCH SECURITY
		["securitysp"] =	 		{"Security SP", nil, nil, nil, nil, nil, nil, "Passive search anti-flood settings"},
		["security_sp"] =	 		{"Security SP", "tSecurity.SP", "t", nil, nil, {}},
		["sp_minlength"] = 		{"Security SP", "tSecurity.SP.MinLength", "i", 1, nil, 3, nil, "Minimum length of searchresult (to passive user)"},
		["sp_maxlength"] = 		{"Security SP", "tSecurity.SP.MaxLength", "i", 1, nil, 256, nil, "Maximum length of searchresult (to passive user)"},
		["sp_length_action"] = 		{"Security SP", "tSecurity.SP.LengthAction", "s", SubSet.ActionListFilter, "%W", "Notify", nil, "Action on wrong searchresult length: "..SubSet.ActionListString},	--// Defaults to ignore

		["sp_usermax1"] = 		{"Security SP", "tSecurity.SP.iMaxCount1", "i", 1, nil, 3, nil, "Search limit 1, amount of searches"},
		["sp_usertime1"] = 		{"Security SP", "tSecurity.SP.iTime1", "d", 1, nil, 20, nil, "Search limit 1, amount of time"},
		["sp_useraction1"] = 		{"Security SP", "tSecurity.SP.sAction1", "s", SubSet.ActionListFilter, "%W", "Notify", nil, "Search limit 1, action: "..SubSet.ActionListString},	--// Defaults to notify
		["sp_usermax2"] = 		{"Security SP", "tSecurity.SP.iMaxCount2", "i", 1, nil, 10, nil, "Search limit 2, amount of searches"},
		["sp_usertime2"] = 		{"Security SP", "tSecurity.SP.iTime2", "d", 1, nil, 20, nil, "Search limit 2, amount of time"},
		["sp_useraction2"] = 		{"Security SP", "tSecurity.SP.sAction2", "s", SubSet.ActionListFilter, "%W", "Disconnect", nil, "Search limit 2, action: "..SubSet.ActionListString},	--// Defaults to disconnect

		--// NICKLIST REQUESTS
		["securitynl"] =	 		{"Security NL", nil, nil, nil, nil, nil, nil, "Userlist refreshing limits (NMDC only)"},
		["security_nl"] =	 		{"Security NL", "tSecurity.NL", "t", nil, nil, {}},

		["nl_usermax1"] = 		{"Security NL", "tSecurity.NL.iMaxCount1", "i", 1, nil, 1, nil, "Refresh limit 1, amount of refreshes"},
		["nl_usertime1"] = 		{"Security NL", "tSecurity.NL.iTime1", "d", 1, nil, 20, nil, "Refresh limit 1, amount of time"},
		["nl_useraction1"] = 		{"Security NL", "tSecurity.NL.sAction1", "s", SubSet.ActionListFilter, "%W", "Ignore", nil, "Refresh limit 1, action: "..SubSet.ActionListString},	--// Defaults to notify
		["nl_usermax2"] = 		{"Security NL", "tSecurity.NL.iMaxCount2", "i", 1, nil, 3, nil, "Refresh limit 2, amount of refreshes"},
		["nl_usertime2"] = 		{"Security NL", "tSecurity.NL.iTime2", "d", 1, nil, 60, nil, "Refresh limit 2, amount of time"},
		["nl_useraction2"] = 		{"Security NL", "tSecurity.NL.sAction2", "s", SubSet.ActionListFilter, "%W", "Disconnect", nil, "Search limit 2, action: "..SubSet.ActionListString},	--// Defaults to disconnect


		--// PASSIVE RESULTS TO USER
		["securitypr"] =	 		{"Security PR", nil, nil, nil, nil, nil, nil, "Passive results limits to user"},
		["security_pr"] =	 		{"Security PR", "tSecurity.PR", "t", nil, nil, {}},
		
		["pr_usermax1"] = 		{"Security PR", "tSecurity.PR.iMaxCount1", "i", 1, nil, 50, nil, "Amount of searchresults to send to passive user"},
		["pr_usertime1"] = 		{"Security PR", "tSecurity.PR.iTime1", "d", 1, nil, 60, nil, "Time interval for allowed amount of searchresults"},
		["pr_useraction1"] = 		{"Security PR", "tSecurity.PR.sAction1", "s", SubSet.ActionListFilter, "%W", "Ignore", nil, "Expert setting: action on too many searchresults to passive user:"..SubSet.ActionListString},	--// Defaults to ignore

		--// SEARCH RESULTS SECURITY
		["securitysr"] =	 		{"Security SR", nil, nil, nil, nil, nil, nil, "Search results anti-flood settings"},
		["security_sr"] =	 		{"Security SR", "tSecurity.SR", "t", nil, nil, {}},
		["sr_minlength"] = 		{"Security SR", "tSecurity.SR.MinLength", "i", 1, nil, 3, nil, "Minimum length of searchresult"},
		["sr_maxlength"] = 		{"Security SR", "tSecurity.SR.MaxLength", "i", 1, nil, 256, nil, "Maximum length of searchresult" },
		["sr_length_action"] = 		{"Security SR", "tSecurity.SR.LengthAction", "s", SubSet.ActionListFilter, "%W", "Ignore", nil, "Action on wrong searchresult length: "},	--// Defaults to notify

		["sr_usermax1"] = 		{"Security SR", "tSecurity.SR.iMaxCount1", "i", 1, nil, 20, nil, "Searchresult limit 1, amount of results"},
		["sr_usertime1"] = 		{"Security SR", "tSecurity.SR.iTime1", "d", 1, nil, 10, nil, "Searchresult limit 1, amount of time"},
		["sr_useraction1"] = 		{"Security SR", "tSecurity.SR.sAction1", "s", SubSet.ActionListFilter, "%W", "Ignore", nil, "Searchresult limit 1, action: "..SubSet.ActionListString},	--// Defaults to ignore
		["sr_usermax2"] = 		{"Security SR", "tSecurity.SR.iMaxCount2", "i", 1, nil, 100, nil, "Searchresult limit 2, amount of results"},
		["sr_usertime2"] = 		{"Security SR", "tSecurity.SR.iTime2", "d", 1, nil, 20, nil, "Searchresult limit 2, amount of time"},
		["sr_useraction2"] = 		{"Security SR", "tSecurity.SR.sAction2", "s", SubSet.ActionListFilter, "%W", "Disconnect", nil, "Searchresult limit 2, action: "..SubSet.ActionListString},	--// Defaults to disconnect
		
		--// NORMAL CONNECT SECURITY
		["securityct"] =	 		{"Security CT", nil, nil, nil, nil, nil, nil, "Normal CTM (active) security and anti-flood settings"},
		["security_ct"] =	 		{"Security CT", "tSecurity.CT", "t", nil, nil, {}},
		["ct_minlength"] = 		{"Security CT", "tSecurity.CT.MinLength", "i", 1, nil, 3, nil, "Minimum length of active connection request"},
		["ct_maxlength"] = 		{"Security CT", "tSecurity.CT.MaxLength", "i", 1, nil, 192, nil, "Maximum length of active connection request"},
		["ct_length_action"] = 		{"Security CT", "tSecurity.CT.LengthAction", "s", SubSet.ActionListFilter, "%W", "Disconnect", nil, "Action on wrong active connection request length: "..SubSet.ActionListString},	--// Defaults to disconnect

		["ct_usermax1"] = 		{"Security CT", "tSecurity.CT.iMaxCount1", "i", 1, nil, 3, nil, "Active connection limit 1, amount of requests"},
		["ct_usertime1"] = 		{"Security CT", "tSecurity.CT.iTime1", "d", 1, nil, 50, nil, "Active connection limit 1, amount of time"},
		["ct_useraction1"] = 		{"Security CT", "tSecurity.CT.sAction1", "s", SubSet.ActionListFilter, "%W", "Notify", nil, "Active connection limit 1, action: "..SubSet.ActionListString},	--// Defaults to notify
		["ct_usermax2"] = 		{"Security CT", "tSecurity.CT.iMaxCount2", "i", 1, nil, 20, nil, "Active connection limit 2, amount of requests"},
		["ct_usertime2"] = 		{"Security CT", "tSecurity.CT.iTime2", "d", 1, nil, 100, nil, "Active connection limit 2, amount of time"},
		["ct_useraction2"] = 		{"Security CT", "tSecurity.CT.sAction2", "s", SubSet.ActionListFilter, "%W", "Disconnect", nil, "Active connection limit 2, action: "..SubSet.ActionListString},	--// Defaults to disconnect

		--// REVERSE CONNECT SECURITY
		["securityrc"] =	 		{"Security RC", nil, nil, nil, nil, nil, nil, "Reverse CTM (passive) security and anti-flood settings"},
		["security_rc"] =	 		{"Security RC", "tSecurity.RC", "t", nil, nil, {}},
		["rc_minlength"] = 		{"Security RC", "tSecurity.RC.MinLength", "i", 1, nil, 3, nil,"Minimum length of passive connection request"},
		["rc_maxlength"] = 		{"Security RC", "tSecurity.RC.MaxLength", "i", 1, nil, 192, nil, "Maximum length of passive connection request"},
		["rc_length_action"] = 		{"Security RC", "tSecurity.RC.LengthAction", "s", SubSet.ActionListFilter, "%W", "Disconnect", nil, "Action on wrong passive connection request length: "..SubSet.ActionListString},	--// Defaults to disconnect

		["rc_usermax1"] = 		{"Security RC", "tSecurity.RC.iMaxCount1", "i", 1, nil, 3, nil, "Passive connection limit 1, amount of requests"},
		["rc_usertime1"] = 		{"Security RC", "tSecurity.RC.iTime1", "d", 1, nil, 50, nil, "Passive connection limit 1, amount of time"},
		["rc_useraction1"] = 		{"Security RC", "tSecurity.RC.sAction1", "s", SubSet.ActionListFilter, "%W", "Notify", nil, "Passive connection limit 1, action: "..SubSet.ActionListString},	--// Defaults to notify
		["rc_usermax2"] = 		{"Security RC", "tSecurity.RC.iMaxCount2", "i", 1, nil, 20, nil, "Passive connection limit 2, amount of requests"},
		["rc_usertime2"] = 		{"Security RC", "tSecurity.RC.iTime2", "d", 1, nil, 100, nil, "Passive connection limit 2, amount of time"},
		["rc_useraction2"] = 		{"Security RC", "tSecurity.RC.sAction2", "s", SubSet.ActionListFilter, "%W", "Disconnect", nil, "Passive connection limit 2, action: "..SubSet.ActionListString},	--// Defaults to disconnect

		--// HUBCOMMAND SECURITY
		["securityhc"] =	 		{"Security HC", nil, nil, nil, nil, nil, nil, "Hubcommand security and anti-flood settings"},
		["security_hc"] =	 		{"Security HC", "tSecurity.HC", "t", nil, nil, {}},
		["hc_minlength"] = 		{"Security HC", "tSecurity.HC.MinLength", "i", 1, nil, 2, nil, "Minimum length of hubcommand"},
		["hc_maxlength"] = 		{"Security HC", "tSecurity.HC.MaxLength", "i", 1, nil, 256, nil, "Maximum length of hubcommand"},
		["hc_length_action"] = 		{"Security HC", "tSecurity.HC.LengthAction", "s", SubSet.ActionListFilter, "%W", "Notify", nil, "Action on wrong hubcommand length: "..SubSet.ActionListString},	--// Defaults to notify

		["hc_usermax1"] = 		{"Security HC", "tSecurity.HC.iMaxCount1", "i", 1, nil, 2, nil, "Hubcommand limit 1, amount of hubcommands"},
		["hc_usertime1"] = 		{"Security HC", "tSecurity.HC.iTime1", "d", 1, nil, 5, nil, "Hubcommand limit 1, amount of time"},
		["hc_useraction1"] = 		{"Security HC", "tSecurity.HC.sAction1", "s", SubSet.ActionListFilter, "%W", "Notify", nil, "Hubcommand limit 1, action: "..SubSet.ActionListString},	--// Defaults to notify
		["hc_usermax2"] = 		{"Security HC", "tSecurity.HC.iMaxCount2", "i", 1, nil, 5, nil, "Hubcommand limit 2, amount of hubcommands"},
		["hc_usertime2"] = 		{"Security HC", "tSecurity.HC.iTime2", "d", 1, nil, 10, nil, "Hubcommand limit 2, amount of time"},
		["hc_useraction2"] = 		{"Security HC", "tSecurity.HC.sAction2", "s", SubSet.ActionListFilter, "%W", "Disconnect", nil, "Hubcommand limit 2, action: "..SubSet.ActionListString},	--// Defaults to disconnect
			
		--// MYINFO SECURITY NMDC
		["securitymn"] =	 		{"Security MN", nil, nil, nil, nil, nil, nil, "NMDC Myinfo security and anti-flood settings"},
		["security_mn"] =	 		{"Security MN", "tSecurity.MN", "t", nil, nil, {}},
		["mn_minlength"] = 		{"Security MN", "tSecurity.MN.MinLength", "i", 1, nil, 1, nil, "Minimum length of NMDC MyINFO"},
		["mn_maxlength"] = 		{"Security MN", "tSecurity.MN.MaxLength", "i", 1, nil, 256, nil, "Maximum length of NMDC MyINFO"},
		["mn_length_action"] = 	{"Security MN", "tSecurity.MN.LengthAction", "s", SubSet.ActionListFilter, "%W", "Disconnect", nil, "Action on wrong NMDC MyINFO length: "..SubSet.ActionListString},	--// Defaults to disconnect

		["mn_usermax1"] = 		{"Security MN", "tSecurity.MN.iMaxCount1", "i", 1, nil, 6, nil, "NMDC MyINFO limit 1, amount of MyINFO's"},
		["mn_usertime1"] = 		{"Security MN", "tSecurity.MN.iTime1", "d", 1, nil, 60, nil, "NMDC MyINFO limit 1, amount of time"},
		["mn_useraction1"] = 		{"Security MN", "tSecurity.MN.sAction1", "s", SubSet.ActionListFilter, "%W", "Ignore", nil, "NMDC MyINFO limit 1, action: "..SubSet.ActionListString},	--// Defaults to ignore
		["mn_usermax2"] = 		{"Security MN", "tSecurity.MN.iMaxCount2", "i", 1, nil, 30, nil, "NMDC MyINFO limit 2, amount of MyINFO's"},
		["mn_usertime2"] = 		{"Security MN", "tSecurity.MN.iTime2", "d", 1, nil, 600, nil, "NMDC MyINFO limit 2, amount of time"},
		["mn_useraction2"] = 		{"Security MN", "tSecurity.MN.sAction2", "s", SubSet.ActionListFilter, "%W", "Disconnect", nil, "NMDC MyINFO limit 2, action: "..SubSet.ActionListString},	--// Defaults to disconnect

		--// MYINFO SECURITY ADC
		["securityma"] =	 		{"Security MA", nil, nil, nil, nil, nil, nil, "ADC Myinfo security and anti-flood settings"},
		["security_ma"] =	 		{"Security MA", "tSecurity.MA", "t", nil, nil, {}},
		["ma_minlength"] = 		{"Security MA", "tSecurity.MA.MinLength", "i", 1, nil, 1, nil, "Minimum length of ADC BINF"},
		["ma_maxlength"] = 		{"Security MA", "tSecurity.MA.MaxLength", "i", 1, nil, 512, nil, "Maximum length of ADC BINF"},
		["ma_length_action"] = 	{"Security MA", "tSecurity.MA.LengthAction", "s", SubSet.ActionListFilter, "%W", "Disconnect", nil, "Action on wrong ADC MyINFO length: "..SubSet.ActionListString},	--// Defaults to disconnect

		["ma_usermax1"] = 		{"Security MA", "tSecurity.MA.iMaxCount1", "i", 1, nil, 10, nil, "ADC BINF limit 1, amount of BINF's"},
		["ma_usertime1"] = 		{"Security MA", "tSecurity.MA.iTime1", "d", 1, nil, 60, nil, "ADC BINF limit 1, amount of time"},
		["ma_useraction1"] = 		{"Security MA", "tSecurity.MA.sAction1", "s", SubSet.ActionListFilter, "%W", "Ignore", nil, "ADC BINF limit 1, action: "..SubSet.ActionListString},	--// Defaults to ignore
		["ma_usermax2"] = 		{"Security MA", "tSecurity.MA.iMaxCount2", "i", 1, nil, 20, nil, "ADC BINF limit 2, amount of BINF's"},
		["ma_usertime2"] = 		{"Security MA", "tSecurity.MA.iTime2", "d", 1, nil, 60, nil, "ADC BINF limit 2, amount of time"},
		["ma_useraction2"] = 		{"Security MA", "tSecurity.MA.sAction2", "s", SubSet.ActionListFilter, "%W", "Disconnect", nil, "ADC BINF limit 2, action: "..SubSet.ActionListString},	--// Defaults to disconnect

		["securityxx"] =	 		{"Security XX", nil, nil, nil, nil, nil, nil, "Unspecified messages anti-flood settings"},
		["security_xx"] =	 		{"Security XX", "tSecurity.XX", "t", nil, nil, {}},
		["xx_minlength"] = 		{"Security XX", "tSecurity.XX.MinLength", "i", 1, nil, 1, nil, "Minimum length of undefined traffic"},
		["xx_maxlength"] = 		{"Security XX", "tSecurity.XX.MaxLength", "i", 1, nil, 256, nil, "Maximum length of undefined traffic"},
		["xx_length_action"] = 		{"Security XX", "tSecurity.XX.LengthAction", "s", SubSet.ActionListFilter, "%W", "Ignore", nil, "Action on wrong undefined traffic length: "..SubSet.ActionListString},	--// Defaults to disconnect

		["xx_usermax1"] = 		{"Security XX", "tSecurity.XX.iMaxCount1", "i", 1, nil, 3, nil, "Undefined traffic limit 1, amount of messages"},
		["xx_usertime1"] = 		{"Security XX", "tSecurity.XX.iTime1", "d", 1, nil, 15, nil, "Undefined traffic limit 1, amount of time"},
		["xx_useraction1"] = 		{"Security XX", "tSecurity.XX.sAction1", "s", SubSet.ActionListFilter, "%W", "Ignore", nil, "Undefined traffic limit 1, action: "..SubSet.ActionListString},	--// Defaults to notify
		["xx_usermax2"] = 		{"Security XX", "tSecurity.XX.iMaxCount2", "i", 1, nil, 20, nil, "Undefined traffic limit 2, amount of messages"},
		["xx_usertime2"] = 		{"Security XX", "tSecurity.XX.iTime2", "d", 1, nil, 100, nil, "Undefined traffic limit 2, amount of time"},
		["xx_useraction2"] = 		{"Security XX", "tSecurity.XX.sAction2", "s", SubSet.ActionListFilter, "%W", "Disconnect", nil, "Undefined traffic limit 2, action: "..SubSet.ActionListString},	--// Defaults to disconnect

		
--~ 		["securityxx"] =	 		{"Security XX", nil, nil, nil, nil, nil, nil, "Reverse CTM security and anti-flood settings"},
--~ 		["security_xx"] =	 		{"Security XX", "tSecurity.XX", "t", nil, nil, {}},
--~ 		["xx_minlength"] = 		{"Security XX", "tSecurity.XX.MinLength", "i", 1, nil, 3},
--~ 		["xx_maxlength"] = 		{"Security XX", "tSecurity.XX.MaxLength", "i", 1, nil, 192},
--~ 		["xx_length_action"] = 		{"Security XX", "tSecurity.XX.LengthAction", "s", SubSet.ActionListFilter, "%W", "Disconnect"},	--// Defaults to disconnect

--~ 		["xx_usermax1"] = 		{"Security XX", "tSecurity.XX.iMaxCount1", "i", 1, nil, 3},
--~ 		["xx_usertime1"] = 		{"Security XX", "tSecurity.XX.iTime1", "d", 1, nil, 50},
--~ 		["xx_useraction1"] = 		{"Security XX", "tSecurity.XX.sAction1", "s", SubSet.ActionListFilter, "%W", "Notify"},	--// Defaults to notify
--~ 		["xx_usermax2"] = 		{"Security XX", "tSecurity.XX.iMaxCount2", "i", 1, nil, 20},
--~ 		["xx_usertime2"] = 		{"Security XX", "tSecurity.XX.iTime2", "d", 1, nil, 100},
--~ 		["xx_useraction2"] = 		{"Security XX", "tSecurity.XX.sAction2", "s", SubSet.ActionListFilter, "%W", "Disconnect"},	--// Defaults to disconnect


	},

}

