--// $Id: Hub-SetVars.lua 1272 2012-02-19 10:35:02Z en_dator $
--// $Rev: 1272 $

--[[

	FlexHub is a server-software for the Direct Connect P2P Network.

	Copyright (C) 2011 Daywalker and FlipFlop, dev@flexhub.org

    This file is part of FlexHub.

    FlexHub is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FlexHub is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with FlexHub.  If not, see <http://www.gnu.org/licenses/agpl.txt>.


]]--

--// Settings
tSettings = {
	-- GENERAL SETTINGS
	["General"] = {
		["svnversion"] = 1272,
		["svnversionnew"] = "$Rev: 1272 $",
		["svnpublic"] = true,
	},

	["Security"] = {
		["UnderAttack"] = false	-- bool that goes true if one port is receiving a DDOS
	},

	["MyInfo"] = {
		-- 0 = not allowed, blocked
		-- 1 = only allowed during login once, blocked, not sent
		-- 2 = only allowed during login once
		-- 3 = allowed to change after login
		["Allowed"] = {
			["ID"] = 2, ["PD"] = 1, ["I4"] = 3, ["I6"] = 0, ["U4"] = 3, ["U6"] = 0, ["SS"] = 3, ["SF"] = 3, ["VE"] = 2,
			["US"] = 3, ["DS"] = 3, ["SL"] = 3, ["AS"] = 3, ["AM"] = 3, ["EM"] = 3, ["NI"] = 2, ["DE"] = 3,
			["HN"] = 3, ["HR"] = 3, ["HO"] = 3, ["TO"] = 3, ["CT"] = 0, ["AW"] = 3, ["SU"] = 3, ["RF"] = 1,
		},
	},

	["ActionList"] = {"Redirect", "Disabled", "Ignore", "Notify", "Warn", "Muppetize", "Kenny", "Mute", "Disconnect", "Kick", "Ban", "TempBan", "FloodBan", "LockMain"},	

-- blocked, not used 2012-02-12/1d
--	["TotalPorts"] = 1,
--	["EnablePm"] = 0,
--	["MutexLevel"] = 0,		--// Level of Mutex, 0 = don't use Mutexes, 1 =only critical Mutexes, 2 = all Mutexes

	["TLS"] = {
		["Enable"] = true,
		["Keyprint"] = false,
		["Params"] = {
			mode = "server",
			protocol = "tlsv1",
			key = "./certs/key.pem",
			certificate = "./certs/cert.pem",
		--   cafile = "./certs/fail.pem",
			verify = {"none"},
			options = {"all"},
		},
	},
	-- GUI SETTINGS
	["Gui"] = {
		["Enable"] = true,
		["UpdateInterval"] = 5,      --// Time between GUI-updates (statustexts only)
		["UpdateSlowInterval"] = 20,      --// Time between GUI-updates for speedmeasurements
		["AutoScroll"] = false,
		["GeneralMaxLines"] = 300,
	},

--~ 	["Traffic"] = {
--~ 		["ZPipeMin"] = 150,
--~ 	},

	-- TCP SETTINGS
--~ 	["TcpDataSkipTime"] = 2,
--~ 	["TcpBufferSize"] = 1024,
--~ 	["TcpSocketReadTimeout"] = 0,
--~ 	["TcpSocketReadTimeoutMode"] = "t",
--~ 	["TcpSocketSendTimeout"] = 0,     -- nil will make it blocking, sending everything until done
--~ 	["TcpSocketSendTimeoutMode"] = "t",
--~ 	["TcpHubTimeout"] = 10,
--~ 	["TcpDisableNagle" ] = false,
--~ 	["TcpNonRespondWait"] = 5,   -- seconds to wait before trying again
--~ 	["TcpNonRespondTimes"] = 10,
--~ 	["TcpDisconnectTimeout"] = 5,

	-- THREADING SETTINGS
	["TcpServerThread"] = 1,                --// 0 doesn't work, has to be threaded to allow mainloop to catch events
	["TcpServerThreadWait"] = 100,    -- pause (millisecs) in accepting clientsockets, this determines max amount of connections per second: 100 = 10 per second, etc
	["TcpListenThread"] = 1,                --// 0 doesn't work, has to be threaded to allow mainloop to catch events
	["TcpListenThreadWait"] = 100,    -- pause in TcpListen
	["TcpLoginThread"] = 1,                --// 0 doesn't work, has to be threaded to allow mainloop to catch events
	["TcpLoginThreadWait"] = 100,    -- pause in TcpListen
	["TcpParseThread"] = 0,                 --// 0 = linear, 1 = threadloop, 2=fire and forget
	["TcpParseThreadWait"] = 100,    -- pause in TcpParse if it uses a threadloop

	["Scripts"] = {
		["InternalFiles"] = {       -- value 1 = autorun selectable on startup, value 2 = unchangeable autorun
			["./core/Hub-Set.lua"] = 2,
			["./core/Hub-SetManager.lua"] = 2,
			["./core/Hub-AccountManager.lua"] = 2,
			["./core/Hub-ProfileManager.lua"] = 2,
			["./core/Hub-ScriptManager.lua"] = 2,  

			["./protocols/Hub-NMDC.lua"] = 2,
			["./protocols/Hub-ADC.lua"] = 2,
			["./protocols/Hub-HTML.lua"] = 2,
			["./protocols/Hub-ALL.lua"] = 2,
			["./protocols/Hub-SECURE.lua"] = 2,

			["./core/Hub-Redirect.lua"] = 2,
			["./core/Hub-Import.lua"] = 2,
			["./core/Hub-Info.lua"] = 2,
			["./core/Hub-Lang.lua"] = 2,
			["./core/Hub-Cmds.lua"] = 2,
			["./core/Hub-SetCmds.lua"] = 2,
			["./core/Hub-UserCmds.lua"] = 2,
			["./core/Hub-Deflood.lua"] = 2,
			["./core/Hub-Ban.lua"] = 2,
			["./core/Hub-Check.lua"] = 2,
			["./core/Hub-Timers.lua"] = 2,
--~ 			["./core/Hub-Api.lua"] = 2,
			["./core/Hub-Update.lua"] = 2,
			["./core/Hub-Funcs.lua"] = 2,
		},
		["OptionalFiles"] = {
			["./core/Hub-Debugging.lua"] = 2,
			["./core/Hub-Webchat.lua"] = 2,
		},
		["ExternalFiles"] = {
			["./scripts/inform.lua"] = 1,
		},
	},

	["Debug"] = {
		["Profiler"] = { ["Count"] = 200, ["Login"] = false, ["Listen"] = false, ["Wait"] = false, ["Gui"] = false },
		["EnablePrint"] = false,     -- this will route all printcommands to the Scripts Debugwindow in GUI
		["EnableGui"] = true,
		["EnableConsole"] = true,

		["GlobalLevel"] = 10,
		["ConsoleLevel"] = 0,
		["Gui"] = {
			["P"] = { ["GuiName"] = "ID_tc_monitor_pm", ["Level"] = 10, ["I"] = true, ["AB"] = true, ["NB"] = true, ["AA"] = true, ["AN"] = true, ["NN"] = true, ["NA"] = true, },     --// PM B = blocked messages
			["L"] = { ["GuiName"] =  "ID_tc_monitor_login", ["Level"] = 10, ["I"] = true, ["AJ"] = true, ["AQ"] = true, ["NJ"] = true, ["NQ"] = true, },    --// Login
			["S"] = { ["GuiName"] =  "ID_tc_monitor_search", ["Level"] = 10, ["I"] = true, ["AA"] = true, ["AP"] = true,  ["AR"] = true,["NA"] = true, ["NP"] = true, ["NR"] = true, },     --// Searches
			["H"] = { ["GuiName"] =  "ID_tc_monitor_hubcmds", ["Level"] = 10, ["I"] = true, ["A"] = true, ["N"] = true, },     --// Hubcommands
			["E"] = { ["GuiName"] =  "ID_tc_monitor_scripts", ["Level"] = 10, ["I"] = true, ["T"] = true, },     --// External Scripts
			["C"] = { ["GuiName"] =  "ID_tc_monitor_clientcmds", ["Level"] = 10, ["I"] = true, ["A"] = true, ["N"] = true, },     --// Clientcommands
			["T"] = { ["GuiName"] =  "ID_tc_monitor_tcp", ["Level"] = 10, ["I"] = true, ["AS"] = true, ["AR"] = true, ["NS"] = true, ["NR"] = true,  },     --// TCP
			["F"] = { ["GuiName"] =  "ID_tc_monitor_debug", ["Level"] = 10, ["I"] = true, ["A"] = true, ["N"] = true, },     --// FlexHub General Debugwindow
		},
	},
	-- UPDATE SETTINGS
	["Update"] = {
		["bNeedRestart"] = false,
		["tRestartFiles"] = {"FlexHub.lua", "Hub-Start.lua", "Hub-StartVars.lua", "Hub-Gui.lua", "Hub-GuiFunc.lua", }, -- files in this table makes the updater ask for restart
		["sVersionFileName"] = "version.tbl",	-- filename that contains the version info
		["sVersionListFileName"] = "allversions.tbl",	-- filename that contains the version info
		["sLocalPath"] = "backups",				-- local path where the backup files are stored
	},
}
