--[[

	FlexHub is a server-software for the Direct Connect P2P Network.

	Copyright (C) 2011 Daywalker and FlipFlop, dev@flexhub.org

    This file is part of FlexHub.

    FlexHub is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FlexHub is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with FlexHub.  If not, see <http://www.gnu.org/licenses/agpl.txt>.


]]--

--// Starting variables

--~ s = 1000
--~ m = 60*s
--~ h = 60*m
--~ d = 24*h
--~ w = 7*d
--~ M = 4*w

--// Mutexes
tMutex = { "mutexclient", "mutexwait", "mutexssl", "mutexdelete", "mutexthreads", "mutexlistenbuffer", "mutexcreatesid", "mutexbanlist", "mutexiplog", "mutexconsole", "mutextimers", "mutextmploop",}

mutexclient = ThreadNewMutex()
mutexwait = ThreadNewMutex()
mutexssl = ThreadNewMutex()
mutexdelete = ThreadNewMutex()
mutexthreads = ThreadNewMutex()
mutexlistenbuffer = ThreadNewMutex()
mutexcreatesid = ThreadNewMutex()
mutexbanlist = ThreadNewMutex()
mutexiplog = ThreadNewMutex()
mutexconsole = ThreadNewMutex()
mutextimers = ThreadNewMutex()
mutextmploop = ThreadNewMutex()

--// Global tables
tGlobals = {}
tAccounts = {}
tAlert = {["Nick"] = {}, ["Ip"] = {},}
tBans = { ["nickban"] = {}, ["ipban"] = {}, ["rangeban"] = {}, ["warn"] = {}, ["autoban"] = {}, ["kick"] = {}}
tBlocks = { ["tMute"] = {}, ["tMuteStealth"] = {}, ["tKenny"] = {}, ["tMuppet"] = {}, ["tConnects"] = {}, ["tPm"] = {},}
--tBotList = {}		--// Deprecated

tBuffer = { ["Send"] = {}, ["Receive"] = {}, ["Client"] = {}, ["Dns"] = {}, ["Threads"] = {},}

tChatRooms = {}
tCmdAlias = {
	["ar"] = "addreg",
	["h"] = "help",
	["hi"] = "hubinfo", 
	["ii"] = "ipinfo",
	["rs"] = "restartscripts",
	["tban"] = "tempban",
	["tbi"] = "tempbanip",
	["tbn"] = "tempbannick",
	["tk"] = "tempkill",
	["ub"] = "unban",
	["ui"] = "userinfo",
	["sp"] = "setprofile",
	["dr"] = "delreg",
	["bi"] = "baninfo",
	["sab"] = "showallbans",
	["sib"] = "showipbans",
	["snb"] = "shownickbans",
	["srb"] = "showrangebans",
	["cs"] = "corestats",
	["lm"] = "lockmain",
	["ulm"] = "unlockmain",
	["cr"] = "changereg",
	["ceb"] = "clearexpiringbans",
	["crb"] = "clearrecentbans",
}

tCommands = {
	["welcome"] = {	["iOptions"] = 44,	["sContent"] = "Currently there are %[usercount] users online and the hub uptime is: %[uptime]", ["iProfile"] = -1,},
	["rules"] = { ["sHelpText"] = "Display hub rules",	["iOptions"] = 1,["iProfile"] = -1, ["sContent"] = "Welcome to %[hub] \n\nHere you can put hub rules for users, for example:\n1. Maximum hubs you can have open is 99\n2. We require minimum open slots is 5\n3. Don't share incomplete,installed files.\n4. Child porn is not allowed in this hub.\n5. Do not advertize or swear in main chat.\n\n",},
	["faq"] = { ["sHelpText"] = "Display FAQ",["iOptions"] = 1,["iProfile"] = -1, ["sContent"] = "\n\nFrequently Asked Questions\n\nQ: Where can I download a good DC++ client?\nA: A good DC++ client of choice for FlexHub is ApexDC++ which can be downloaded at\nhttp://www.apexdc.net/download/\n\nQ: How can I search and download files?\nA: Check out the Apex++ Guides at\nhttp://forums.apexdc.net/forum/13-guides\n\nQ: Where can I get hold of FlexHub or find out more information?\nA: The FlexHub forum & wiki should provide you with all the information you need as well as providing the latest version available to download. You can find the forum & wiki at\nhttp://www.flexhub.org\n\nAny further questions ask Operators and Admins of the hub.\n\n",},
}

tConsoleBuffer = { ["Messages"] = {}}
tFiles = {}

tFilters = {
	["Muppets"] = {
		["BroadcastOn"] = "User <%s> is now muppetized.",
		["BroadcastOff"] = "User <%s> is now unmuppetized.",
		["Replacements"] = {
			{"a", ""},
			{"o", ""},
		},
		["LinesChance"] = 4, --// Statistically every nth line will be replaced, is randomized though
		["Lines"] = {
			"Oh, hold my hand, pig-of-my-dreams! Just touch me, oh, hog-of-my-heart!",
			"Kermit, cancel my bread impersonation act! They didn't deliver my poppy seeds. You wouldn't want me to walk out there NAKED, would you?",
		},
		["WordsChance"] = 2,	--// Statistically every nth word will be replaced, is randomized though
		["Words"] = {"meatballs", "swdish", "BORK BORK BORK", "heudi beudi hoopa", "Kermie!!","wakka wakka wakka", "Mahna Mahna!" },
		["QuotesChance"] = 4,	--// Statistically every nth line will be replaced by a quote
		["Quotes"] = {
			{ "Animal", "I come from a broken home."},
			{ "Kermit", "Don't worry, Animal, your big scene is coming up."},
			{ "MissPiggy", "Oh Kermie!!!"},
			{ "Kermit", "Ladies and gentlemen, it's the Muppet Show!"},	
			{ "MissPiggy", "Hurt? I'll show you hurt, Kermie!"},	
		},
	},
}

tFlood = {}
tGeoIP = { ["file"] = "./scripts/IpToCountry.csv", ["loaded"] = false}
tGuiEvents = {}
tHubSettings = {}
tInterval = { ["Sids"] = {}, ["Messages"] = {}}
tLanguage = {}
tListenBuffer = { ["Messages"] = {}, ["Commands"] = {}}
tLoginList = {}	-- I cant see this table being used anywhere ?? - 1dat
tLogs = {} --// Default values below
tMonitor = {}
--tNicks = {} --// Nicktable containing SIDs for quick reverse lookups
tLNicks = {} --// New Nicktable containing SIDs for quick reverse lookups, format is tLNicks[nick:lower()] = {"sid" = sid, "sNick" = nick}

tPatterns = {
	["VE"] = {},
	["DE"] = {},
	["SE"] = {},
	["RE"] = {
		["%S+://"] = { ["iActions"] = 32, ["iProfile"] = 1,},
	},
	["SP"] = {},
	["SS"] = {},
	["EM"] = {},
	["NI"] = {
		["%S+://"] = {["iActions"] = 32,["iProfile"] = 1,},
		["%d+%.%d+%.%d+%.%d+"] = {["iActions"] = 32,["iProfile"] = 1,},
		["[Ww][Ww][Ww]%."] = {["iActions"] = 32,["iProfile"] = 1,},
	},
	["MC"] = {
		["%S+://"] = {["iActions"] = 32,["iProfile"] = 1,},
		["%d+%.%d+%.%d+%.%d+"] = {["iActions"] = 32,["iProfile"] = 1,},
		["[Ww][Ww][Ww]%."] = {["iActions"] = 32,["iProfile"] = 1,},
	},
	["PM"] = {
		["%S+://"] = {["iActions"] = 32,["iProfile"] = 1,},
		["%d+%.%d+%.%d+%.%d+"] = {["iActions"] = 32,["iProfile"] = 1,},
		["[Ww][Ww][Ww]%."] = {["iActions"] = 32,["iProfile"] = 1,},
	},
	["SR"] = {},
	["Sorted"] = {
		["VE"] = {},
		["RE"] = {[1] = "%S+://",},
		["DE"] = {},
		["NI"] = {[1] = "%S+://",[2] = "%d+%.%d+%.%d+%.%d+",[3] = "[Ww][Ww][Ww]%.",},
		["PM"] = {[1] = "%S+://",[2] = "%d+%.%d+%.%d+%.%d+",[3] = "[Ww][Ww][Ww]%.",},
		["MC"] = {[1] = "%S+://",[2] = "%d+%.%d+%.%d+%.%d+",[3] = "[Ww][Ww][Ww]%.",},
		["SS"] = {},
		["EM"] = {},
	},
}

tProfiles = {
	["Gui"] = {
		["tRules"] = {
		},
		["tOverrides"] = {
			["all"] = true,
		},
		["bInvisible"] = false,
		["iLevel"] = 10,
		["bFixed"] = 2,
		["sDescription"] = "Profile for GUI, can't be changed",
		["tCmds"] = {
			["all"] = true,
		},
	},
	["User"] = {
		["tRules"] = {
		},
		["bInvisible"] = false,
		["iLevel"] = -1,
		["bFixed"] = 1,
		["sDescription"] = "Unregistered user",
		["tCmds"] = {
			["report"] = true,
			["history"] = true,
			["help"] = true,
			["myip"] = true,
			["regme"] = true,
			["hubinfo"] = true,
		},
	},
	["Reg"] = {
		["tRules"] = {
		},
		["bInvisible"] = false,
		["iLevel"] = 0,
		["bFixed"] = 1,
		["sDescription"] = "Registered user",
		["tCmds"] = {
			["report"] = true,
			["history"] = true,
			["help"] = true,
			["myip"] = true,
			["setmypass"] = true,
			["getmypass"] = true,
			["showtopic"] = true,
			["regme"] = true,
			["hubinfo"] = true,
		},
	},
	["Moderator"] = {
		["tRules"] = {
		},
		["tOverrides"] = {
			["all"] = true,
		},
		["bOperator"] = true,
		["bFixed"] = 1,
		["tCmds"] = {
			["unprotect"] = true,
			["warn"] = true,
			["resettimeout"] = true,
			["showprotected"] = true,
			["unhide"] = true,
			["list"] = true,
			["showipbans"] = true,
			["tempban"] = true,
			["privateroom"] = true,
			["revdns"] = true,
			["uninvite"] = true,
			["kick"] = true,
			["showrangebans"] = true,
			["protect"] = true,
			["lockhub"] = true,
			["tempbanip"] = true,
			["setmypass"] = true,
			["massprofile"] = true,
			["mass"] = true,
			["drop"] = true,
			["feed"] = true,
			["getmypass"] = true,
			["dns"] = true,
			["invite"] = true,
			["unban"] = true,
			["getpass"] = true,
			["unlockhub"] = true,
			["ban"] = true,
			["shownickbans"] = true,
			["silentban"] = true,
			["showsid"] = true,
			["stats"] = true,
			["kill"] = true,
			["showallbans"] = true,
			["opchat"] = true,
			["leave"] = true,
			["showregs"] = true,
			["mute"] = true,
			["regme"] = true,
			["showblocks"] = true,
			["report"] = true,
			["blockpm"] = true,
			["unmuppetize"] = true,
			["bannick"] = true,
			["topic"] = true,
			["unhideshare"] = true,
			["showtopic"] = true,
			["unlockmain"] = true,
			["addreg"] = true,
			["unblockpm"] = true,
			["hideshare"] = true,
			["hubinfo"] = true,
			["tempbanrange"] = true,
			["userinfo"] = true,
			["baninfo"] = true,
			["unmute"] = true,
			["unblockctm"] = true,
			["showwarns"] = true,
			["redirect"] = true,
			["history"] = true,
			["muppetize"] = true,
			["showstatus"] = true,
			["help"] = true,
			["unkenny"] = true,
			["whisper"] = true,
			["corestats"] = true,
			["banrange"] = true,
			["hide"] = true,
			["unwarn"] = true,
			["blockctm"] = true,
			["lockmain"] = true,
			["banip"] = true,
			["showprofiles"] = true,
			["showreg"] = true,
			["changereg"] = true,
			["kenny"] = true,
			["setpass"] = true,
			["showlogins"] = true,
			["ipinfo"] = true,
			["dropsid"] = true,
			["myip"] = true,
			["delreg"] = true,
			["tempbannick"] = true,
			["tempkill"] = true,
		},
		["bInvisible"] = false,
		["bHasKey"] = true,
		["sDescription"] = "HubModerator",
		["iLevel"] = 6,
	},
	["Hubowner"] = {
		["tRules"] = {
		},
		["tOverrides"] = {
			["all"] = true,
		},
		["sDescription"] = "Owner of the hub",
		["iLevel"] = 10,
		["bHasKey"] = true,
		["tCmds"] = {
			["all"] = true,
		},
	},
	["Operator"] = {
		["tRules"] = {
		},
		["tOverrides"] = {
			["all"] = true,
		},
		["bInvisible"] = false,
		["iLevel"] = 5,
		["sDescription"] = "HubOperator",
		["bHasKey"] = true,
		["bOperator"] = true,
		["tCmds"] = {
			["showsid"] = true,
			["stats"] = true,
			["kill"] = true,
			["warn"] = true,
			["userinfo"] = true,
			["unhideshare"] = true,
			["opchat"] = true,
			["leave"] = true,
			["showregs"] = true,
			["list"] = true,
			["regme"] = true,
			["tempban"] = true,
			["history"] = true,
			["banip"] = true,
			["privateroom"] = true,
			["delreg"] = true,
			["tempbannick"] = true,
			["protect"] = true,
			["tempkill"] = true,
			["bannick"] = true,
			["massprofile"] = true,
			["showreg"] = true,
			["hide"] = true,
			["uninvite"] = true,
			["kick"] = true,
			["showrangebans"] = true,
			["addreg"] = true,
			["hubinfo"] = true,
			["tempbanrange"] = true,
			["hideshare"] = true,
			["baninfo"] = true,
			["lockhub"] = true,
			["tempbanip"] = true,
			["showwarns"] = true,
			["redirect"] = true,
			["drop"] = true,
			["showprotected"] = true,
			["mass"] = true,
			["whisper"] = true,
			["topic"] = true,
			["showprofiles"] = true,
			["dns"] = true,
			["kenny"] = true,
			["unkenny"] = true,
			["banrange"] = true,
			["unwarn"] = true,
			["getmypass"] = true,
			["lockmain"] = true,
			["invite"] = true,
			["unban"] = true,
			["getpass"] = true,
			["help"] = true,
			["unlockhub"] = true,
			["showstatus"] = true,
			["ban"] = true,
			["ipinfo"] = true,
			["dropsid"] = true,
			["myip"] = true,
			["showtopic"] = true,
			["unhide"] = true,
			["unlockmain"] = true,
		},
	},
	["Pinger"] = {
		["tRules"] = {
		},
		["tOverrides"] = {
		},
		["sDescription"] = "Hublist Pinger",
		["iLevel"] = -1,
		["tCmds"] = {
		},
	},
	["HubBot"] = {
		["tRules"] = {
		},
		["iLevel"] = 10,
		["sDescription"] = "Main hubbot, can't be changed",
		["bFixed"] = 2,
	},
	["NetOwner"] = {
		["tRules"] = {
		},
		["tOverrides"] = {
			["all"] = true,
		},
		["sDescription"] = "NetOwner/NetFounder",
		["bFixed"] = 1,
		["tCmds"] = {
			["unprotect"] = true,
			["clearexpiringbans"] = true,
			["clearlastbans"] = true,
			["resettimeout"] = true,
			["showprotected"] = true,
			["unhide"] = true,
			["list"] = true,
			["showipbans"] = true,
			["tempban"] = true,
			["privateroom"] = true,
			["mc"] = true,
			["showconnects"] = true,
			["revdns"] = true,
			["uninvite"] = true,
			["kick"] = true,
			["showrangebans"] = true,
			["protect"] = true,
			["lockhub"] = true,
			["tempbanip"] = true,
			["setmypass"] = true,
			["massprofile"] = true,
			["mass"] = true,
			["drop"] = true,
			["feed"] = true,
			["bindip"] = true,
			["getmypass"] = true,
			["dns"] = true,
			["invite"] = true,
			["unban"] = true,
			["getpass"] = true,
			["setprofile"] = true,
			["unlockhub"] = true,
			["ban"] = true,
			["shownickbans"] = true,
			["silentban"] = true,
			["showports"] = true,
			["showsid"] = true,
			["stats"] = true,
			["kill"] = true,
			["showallbans"] = true,
			["opchat"] = true,
			["leave"] = true,
			["showregs"] = true,
			["mute"] = true,
			["regme"] = true,
			["showblocks"] = true,
			["report"] = true,
			["banrange"] = true,
			["hide"] = true,
			["blockpm"] = true,
			["unmuppetize"] = true,
			["delreg"] = true,
			["bannick"] = true,
			["unlockmain"] = true,
			["unmute"] = true,
			["ipinfo"] = true,
			["say"] = true,
			["unhideshare"] = true,
			["addreg"] = true,
			["hideshare"] = true,
			["hubinfo"] = true,
			["tempbanrange"] = true,
			["history"] = true,
			["baninfo"] = true,
			["setpass"] = true,
			["kenny"] = true,
			["showwarns"] = true,
			["redirect"] = true,
			["showdisconnects"] = true,
			["muppetize"] = true,
			["changereg"] = true,
			["whisper"] = true,
			["unkenny"] = true,
			["showreg"] = true,
			["corestats"] = true,
			["blockctm"] = true,
			["banip"] = true,
			["unwarn"] = true,
			["showprofiles"] = true,
			["lockmain"] = true,
			["showstatus"] = true,
			["help"] = true,
			["tempbannick"] = true,
			["tempkill"] = true,
			["topic"] = true,
			["unblockctm"] = true,
			["showlogins"] = true,
			["unblockpm"] = true,
			["dropsid"] = true,
			["myip"] = true,
			["showtopic"] = true,
			["userinfo"] = true,
			["warn"] = true,
		},
		["bInvisible"] = false,
		["bHasKey"] = true,
		["iLevel"] = 9,
		["bOperator"] = true,
	},
	["Master"] = {
		["tRules"] = {
		},
		["tOverrides"] = {
			["all"] = true,
		},
		["sDescription"] = "Hub Master",
		["bFixed"] = 1,
		["tCmds"] = {
			["unprotect"] = true,
			["warn"] = true,
			["clearlastbans"] = true,
			["unhideshare"] = true,
			["showprotected"] = true,
			["unhide"] = true,
			["unmute"] = true,
			["showipbans"] = true,
			["tempban"] = true,
			["privateroom"] = true,
			["mc"] = true,
			["showconnects"] = true,
			["revdns"] = true,
			["uninvite"] = true,
			["kick"] = true,
			["showrangebans"] = true,
			["protect"] = true,
			["lockhub"] = true,
			["tempbanip"] = true,
			["setmypass"] = true,
			["massprofile"] = true,
			["mass"] = true,
			["drop"] = true,
			["feed"] = true,
			["bindip"] = true,
			["getmypass"] = true,
			["dns"] = true,
			["invite"] = true,
			["unban"] = true,
			["getpass"] = true,
			["setprofile"] = true,
			["unlockhub"] = true,
			["ban"] = true,
			["shownickbans"] = true,
			["silentban"] = true,
			["showports"] = true,
			["showsid"] = true,
			["stats"] = true,
			["kill"] = true,
			["userinfo"] = true,
			["opchat"] = true,
			["leave"] = true,
			["showregs"] = true,
			["mute"] = true,
			["unlockmain"] = true,
			["showblocks"] = true,
			["report"] = true,
			["regme"] = true,
			["list"] = true,
			["blockpm"] = true,
			["unmuppetize"] = true,
			["showtopic"] = true,
			["bannick"] = true,
			["resettimeout"] = true,
			["showallbans"] = true,
			["unblockpm"] = true,
			["say"] = true,
			["hideshare"] = true,
			["clearexpiringbans"] = true,
			["addreg"] = true,
			["hubinfo"] = true,
			["tempbanrange"] = true,
			["topic"] = true,
			["baninfo"] = true,
			["tempkill"] = true,
			["tempbannick"] = true,
			["showwarns"] = true,
			["redirect"] = true,
			["help"] = true,
			["muppetize"] = true,
			["showstatus"] = true,
			["whisper"] = true,
			["unkenny"] = true,
			["corestats"] = true,
			["showprofiles"] = true,
			["unwarn"] = true,
			["banrange"] = true,
			["blockctm"] = true,
			["banip"] = true,
			["lockmain"] = true,
			["showreg"] = true,
			["changereg"] = true,
			["showdisconnects"] = true,
			["kenny"] = true,
			["setpass"] = true,
			["history"] = true,
			["showlogins"] = true,
			["ipinfo"] = true,
			["dropsid"] = true,
			["myip"] = true,
			["delreg"] = true,
			["unblockctm"] = true,
			["hide"] = true,
		},
		["bInvisible"] = false,
		["bHasKey"] = true,
		["iLevel"] = 8,
		["bOperator"] = true,
	},
	["Admin"] = {
		["tRules"] = {
		},
		["tOverrides"] = {
			["all"] = true,
		},
		["sDescription"] = "Hub Administrator",
		["bFixed"] = 1,
		["tCmds"] = {
			["unprotect"] = true,
			["warn"] = true,
			["unblockctm"] = true,
			["showprotected"] = true,
			["unhide"] = true,
			["unmute"] = true,
			["showipbans"] = true,
			["tempban"] = true,
			["privateroom"] = true,
			["mc"] = true,
			["showconnects"] = true,
			["revdns"] = true,
			["uninvite"] = true,
			["kick"] = true,
			["showrangebans"] = true,
			["protect"] = true,
			["lockhub"] = true,
			["tempbanip"] = true,
			["setmypass"] = true,
			["massprofile"] = true,
			["mass"] = true,
			["drop"] = true,
			["feed"] = true,
			["getmypass"] = true,
			["dns"] = true,
			["invite"] = true,
			["unban"] = true,
			["getpass"] = true,
			["setprofile"] = true,
			["unlockhub"] = true,
			["ban"] = true,
			["shownickbans"] = true,
			["silentban"] = true,
			["showsid"] = true,
			["stats"] = true,
			["kill"] = true,
			["showallbans"] = true,
			["opchat"] = true,
			["leave"] = true,
			["showregs"] = true,
			["mute"] = true,
			["unlockmain"] = true,
			["showblocks"] = true,
			["report"] = true,
			["blockpm"] = true,
			["unmuppetize"] = true,
			["bannick"] = true,
			["hide"] = true,
			["hideshare"] = true,
			["delreg"] = true,
			["history"] = true,
			["resettimeout"] = true,
			["ipinfo"] = true,
			["addreg"] = true,
			["hubinfo"] = true,
			["tempbanrange"] = true,
			["unhideshare"] = true,
			["baninfo"] = true,
			["userinfo"] = true,
			["setpass"] = true,
			["showwarns"] = true,
			["redirect"] = true,
			["kenny"] = true,
			["muppetize"] = true,
			["showdisconnects"] = true,
			["help"] = true,
			["unkenny"] = true,
			["showreg"] = true,
			["showprofiles"] = true,
			["banip"] = true,
			["banrange"] = true,
			["unwarn"] = true,
			["blockctm"] = true,
			["lockmain"] = true,
			["corestats"] = true,
			["whisper"] = true,
			["showstatus"] = true,
			["tempbannick"] = true,
			["tempkill"] = true,
			["topic"] = true,
			["showlogins"] = true,
			["unblockpm"] = true,
			["dropsid"] = true,
			["myip"] = true,
			["showtopic"] = true,
			["list"] = true,
			["regme"] = true,
		},
		["bInvisible"] = false,
		["bHasKey"] = true,
		["iLevel"] = 7,
		["bOperator"] = true,
	},
	["SuperUser"] = {
		["tRules"] = {
		},
		["tOverrides"] = {
		},
		["bInvisible"] = false,
		["iLevel"] = 4,
		["sDescription"] = "SU",
		["bHasKey"] = true,
		["bOperator"] = true,
		["tCmds"] = {
			["getmypass"] = true,
			["setmypass"] = true,
			["history"] = true,
			["help"] = true,
			["whisper"] = true,
			["myip"] = true,
			["showtopic"] = true,
			["hideshare"] = true,
			["hubinfo"] = true,
		},
	},
	["KVip"] = {
		["tRules"] = {
		},
		["bInvisible"] = false,
		["iLevel"] = 3,
		["sDescription"] = "SpecialVip",
		["bFixed"] = 1,
		["bHasFakeKey"] = true,
		["tCmds"] = {
			["report"] = true,
			["stats"] = true,
			["setmypass"] = true,
			["history"] = true,
			["help"] = true,
			["getmypass"] = true,
			["myip"] = true,
			["showtopic"] = true,
			["regme"] = true,
			["hubinfo"] = true,
		},
	},
	["Vip"] = {
		["tRules"] = {
		},
		["bInvisible"] = false,
		["iLevel"] = 2,
		["sDescription"] = "Very Important Person",
		["bHasFakeKey"] = false,
		["bFixed"] = 1,
		["tCmds"] = {
			["report"] = true,
			["stats"] = true,
			["setmypass"] = true,
			["history"] = true,
			["help"] = true,
			["getmypass"] = true,
			["myip"] = true,
			["showtopic"] = true,
			["regme"] = true,
			["hubinfo"] = true,
		},
	},
}

tProtects = { ["Nick"] = {}, ["Ip"] = {}, ["Profiles"] = {["HubBot"] = 2, ["Gui"] = 2, ["Reg"] = 1, ["User"] = 1}}
--tRedirects = { ["History"] = {}, ["LastClean"] = os.time(), ["tList"] = {} }
tRedirects = { ["History"] = {}, ["tList"] = {} }
tSecurity = {}
tSettings = {}  --// Default values below
tServer = { ["Port"] = {}, ["Main"] = {}, ["GuiSID"] = false }
tThreads = { ["Wait"] = {}, ["Listen"] = {}, ["Parse"] = {},  ["SSL"] = {}, ["Timers"] = {},}
tWebServer = { ["Clients"] = {}, ["Files"] = { ["worldmap.html"] = { ["Allowed"] = true, ["Content"] = false}, },}

tClient = {}
tClientWait = {}	--// Buffer containing all login users to be added to tClient by the Listen thread
tClientDelete = {} --// Buffer containing all login users to be deleted from tClient by the Listen thread
tClientWaitSSL = {}	--// Buffer containing all users waiting to be added to tClientSSL by the SSLHandshake thread
tClientSSL = {}	--// Buffer containing all users currently performing an SSL handshake
tClientLog = {}     -- move userdata from tClient[sid] to tClientLog[sid] when a user goes offline

tTimers = {}	-- moved to tTimerFuncs:Initialize() and run from Hub-Start.lua

tLogs = {
	["HubCommands"] = { ["History"] = {} },
	["Hublists"] = {
		["Registration"] = {
			["LastRun"] = 0,
			["LastOutput"] = {},
			["LastConnects"] = {},
			["Status"] = -1,		--// -1 = never ran, 0 = ran and finished, any other number is the current number of hublist it is connecting to
		},
	},
	["General"] = {},
	["Mainchat"] = {
		["Sids"] = {},
		["Dates"] = {},
		["Lines"] = {},
		["Nicks"] = {},
	},
	["ChatRooms"] = {},
	["IP"] = {},
	["Nick"] = {},
	["Redirects"] = {},
	["Disconnects"] = {},
	["Errors"] = { ["LoginTimeouts"] = 0, ["Socket"] = 0, ["Lua"] = 0, ["CreateSocket"] = 0, ["SSLWrap"] = 0, },
	["Counters"] = {
		["Ddos"] = {  ["Total"] = 0, ["Source"] = {}, ["LastAverageTime"] = 0,  ["Average"] = 0, ["Port"] = {} },
		["PeerNameFailed"] = 0,
		["ConnectionsAllowed"] = 0,
		["ConnectionsBlocked"] = 0,
		["Unknown"] = {
			["LoginsFailed"] = 0,
		},
		["HTML"] = {
			["LoginsFailed"] = 0,
		},
		["ADC"] = {
			["Logins"] = 0,
			["LoginsFailed"] = 0,
			["Redirects"] = 0,
			["LoginTimeouts"] = 0,
			["SocketErrors"] = 0, 
			["MainchatMessages"] = 0,
			["PrivateMessages"] = 0,
			["HubCommands"] = 0,
			["ActiveSearches"] = 0,
			["PassiveSearches"] = 0,
			["SearchReplies"] = 0,
			["FullMyINFOs"] = 0,
			["PartialMyINFOs"] = 0,
			["ConnectToMes"] = 0,
			["RevConnectToMes"] = 0,
		},
		["NMDC"] = {
			["Logins"] = 0,
			["LoginsFailed"] = 0,
			["Redirects"] = 0,
			["LoginTimeouts"] = 0,
			["SocketErrors"] = 0, 
			["MainchatMessages"] = 0,
			["PrivateMessages"] = 0,
			["HubCommands"] = 0,
			["ActiveSearches"] = 0,
			["PassiveSearches"] = 0,
			["SearchReplies"] = 0,
			["FullMyINFOs"] = 0,
			["PartialMyINFOs"] = 0,
			["ConnectToMes"] = 0,
			["RevConnectToMes"] = 0,
		},
	},
	["Traffic"] = {
		["ADC"] = {		--// OLU = Offline User
			["History"] = {
				["TotalSent"] = 0,		--// Total bytes sent (gets updated once a user quits)
				["TotalReceived"] = 0,		--// Total bytes receiveds (gets updated once a user quits)
				["LoginSent"] = 0,
				["LoginReceived"] = 0,

				["TotalTime"] = 0,		--// Online time in seconds
				["TotalUsers"] = 0,		--// Number of offline users, this keeps track of the number of logins
			},
			["TotalSent"] = 0,
			["TotalReceived"] = 0,
			["LoginSent"] = 0,
			["LoginReceived"] = 0,
		},
		["NMDC"] = {
			["History"] = {
				["TotalSent"] = 0,		--// Total bytes sent (gets updated once a user quits)
				["TotalReceived"] = 0,		--// Total bytes receiveds (gets updated once a user quits)
				["LoginSent"] = 0,
				["LoginReceived"] = 0,

				["TotalTime"] = 0,		--// Online time in seconds
				["TotalUsers"] = 0,		--// Number of offline users, this keeps track of the number of logins
			},
			["TotalSent"] = 0,
			["TotalReceived"] = 0,
			["LoginSent"] = 0,
			["LoginReceived"] = 0,
		},
	},
}

--// Statistics Storage
tStats = {
	["Counters"] = {
		["ADC"] = {},
		["NMDC"] = {},
		["HTTP"] = {},
		["HTML"] = {},
		["Unknown"] = {},
	},
	["Users"] = {
		["NMDC"] = 	{ ["OnlineTime"] = 0},
		["ADC"] =		{ ["OnlineTime"] = 0},
		["Unknown"] ={ ["OnlineTime"] = 0},
	},
	["Hub"] = {
		["Status"] = "Offline",      --// "Online", "Offline", "Locked"
		["Users"] = {
			["Total"] = 0,
			["TotalMax"] = 0,
			["NMDC"] = 0,
			["NMDCMax"] = 0,
			["ADC"] = 0,
			["ADCMax"] = 0,
		},
		["Share"] = 0,
		["AppStarted"] = os.time(),
		["Started"] = os.time(),
		["MaxMem"] = 0,
	},
	["Thread"]  = {
		["SSL"] = { ["Status"] = "Not running", ["Time"] = 0, ["User"] = "", ["Data"] = ""},
		["Listen"] = { ["Status"] = "Not running", ["Time"] = 0, ["User"] = "", ["Data"] = ""},
		["Port"] = {},	--// { [8000] = { ["Status"] = "waiting", ["Time"] = 0, ["Logins"] = 0, ["LastIP"] = ""}
		["Gui"] = { ["Status"] = "Running"},
	},
	["Tcp"] = {
		["SentMergedRaw"] = 0, 		--// Total data before compression
		["SentMerged"] = 0,			--// Total data after optional compression
		["SentMergedADC"] = 0,		--// Total data after optional compression
		["SentMergedNMDC"] = 0,		--// Total data after optional compression
		["SentRawNMDC"] = 0,			--// Data before compression evaluation
		["SentRawADC"] = 0,			--// Data before compression evaluation
		["SentZlibInputNMDC"] = 0,		--// Data before compressing
		["SentZlibInputADC"] = 0,		--// Data before compressing
		["SentZlibOutputNMDC"] = 0,		--// Data after compressing
		["SentZlibOutputADC"] = 0,		--// Data after compressing
		["SentUncompressedNMDC"] = 0,	--// Data not compressed, too short
		["SentUncompressedADC"] = 0,	--// Data not compressed, too short
		["SentNoZlibSupportNMDC"] = 0,	--// Data can't be compressed, client doesn't support it
		["SentNoZlibSupportADC"] = 0,	--// Data can't be compressed, client doesn't support it
		["Sent"] = 0,
		["SentSpeed"] = 0,
		["SentInterval"] = 0,
		["SentPeak"] = 0,
		["Received"] = 0,
		["ReceivedSpeed"] = 0,
		["ReceivedInterval"] = 0,
		["ReceivedPeak"] = 0,
		["Age"] = 0,
		["SendBufferFull"] = 0,
		["SocketErrors"] = 0,
		["Authorizing"] = 0,
		["Joined"] = 0,
		["Closed"] = 0,
		["LastShown"] = 0,
		["LastSpeedMeasure"] = 0,
	},
	["Timers"] = {
		["LastRun"] = 0,
		["Thread"] = 0,
		["ListenThread"] = 0,
		["ReadSockets"] = 0,
		["SendSockets"] = 0,
		["ParseCmds"] = 0,
		["ThreadMax"] = 0,
		["SendFunction"] = 0,
		["SendFunctionMax"] = 0,
		["ListenThreadMax"] = 0,
		["ReadSocketsMax"] = 0,
		["SendSocketsMax"] = 0,
		["ParseCmdsMax"] = 0,
		["ReadSingleSocketMax"] = 0,
		["SendSingleSocketMax"] = 0,
		["ParseSingleCmdMax"] = 0,
		["SendSingleMax"] = 0,
		["SendZlibMax"] = 0,
	},
	["Gui"] = {
		["StartTime"] = 0,
	},
	["Redirects"] = {
		["Addresses"] = {},	--// Address counters
		["List"] = {			--// Array address counters
			["failover"] = {["Number"] = 1, ["Counter"] = 0},
			["adc_disabled"] = {["Number"] = 1, ["Counter"] = 0},
			["nmdc_disabled"] = {["Number"] = 1, ["Counter"] = 0},
			["passive"] = {["Number"] = 1, ["Counter"] = 0},
			["maxhubs"] = {["Number"] = 1, ["Counter"] = 0},
			["minslots"] = {["Number"] = 1, ["Counter"] = 0},
			["maxslots"] = {["Number"] = 1, ["Counter"] = 0},
			["minshare"] = {["Number"] = 1, ["Counter"] = 0},
			["maxshare"] = {["Number"] = 1, ["Counter"] = 0},
			["flood"] = {["Number"] = 1, ["Counter"] = 0},
			["main"] = {["Number"] = 1, ["Counter"] = 0},
			["regonly"] = {["Number"] = 1, ["Counter"] = 0},
			["full"] = {["Number"] = 1, ["Counter"] = 0},
			["deadend"] = {["Number"] = 1, ["Counter"] = 0},
			["deadendfail"] = {["Number"] = 1, ["Counter"] = 0},
		},		
	},
	["Console"] = {
		["Status"] = "Initializing",
	}
}
