--[[

	FlexHub is a server-software for the Direct Connect P2P Network.

	Copyright (C) 2011 Daywalker and FlipFlop, dev@flexhub.org

    This file is part of FlexHub.

    FlexHub is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FlexHub is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with FlexHub.  If not, see <http://www.gnu.org/licenses/agpl.txt>.


]]--

function HTML_DataArrival(client,sid,msg)
	local wrong = "Malformed HTML message received."
	client.sStatus = "[RECV] "..msg

	tFuncs:Debug("[HTML_DataArrival] Executing GET: "..msg, "EI", 1)

	--// function execution
	local _,_,cmd = msg:find("^(%S*)")
	if HTML_Commands[cmd] then
		return HTML_Commands[cmd](client, sid, msg)
	else
		return HTML_Commands["Malformed"](client, sid, msg)
	end
	return client
end

HTML_Commands = {
	["Malformed"] = function(client, sid, msg)
		tUser:Disconnect(sid, "<BR>404 - Not found - Join <A HREF=\"adc://text.flexhub.org:8000\">this hub</A> and use !webhelp for available pages.\r\n.")
		return client
	end,
	["GET"] = function(client, sid, msg)
		--// Check if IP is logged in hub:
		local sids = tIp:GetSids(client.sIP)
		local ok, nicks = false, ""
		if sids then
			for num, vsid in ipairs(sids) do
				if tClient[vsid].iState == 7 then
					ok = true
					nicks = nicks..tClient[vsid].sNick.." / "
				end
			end
			if nicks ~= "" then nicks:sub(1,-3) end
		end
			
		if ok then
			local request = msg:match("^GET /(%S+)")
			client.iState = 2
			
			if tWebServer.Files[request] and tWebServer.Files[request].Allowed then
				if tWebServer.Files[request].Content then
					tSend:Raw(sid, tWebServer.Files[request].Content)
					tUser:Disconnect(sid, nil, "Disconnected after sending page.", "EI", 2)
					tFuncs:Debug(tUser:GetDataLine(sid).."[WEB Login] User ("..nicks..") requesting: "..request.." / Reply sent.")
				else
					tUser:Disconnect(sid, "HTTP/1.1 404 Data not available - Join adc://text.flexhub.org:8000 and use !webhelp for available pages.", "[WEB] Data not available: "..request, "EI", 2)
					tFuncs:Debug(tUser:GetDataLine(sid).."[WEB Login] User ("..nicks..") requesting: "..request.." / Output empty")
				end
			else	
				tUser:Disconnect(sid, "HTTP/1.1 404 Not found - Join adc://text.flexhub.org:8000 and use !webhelp for available pages.", "[WEB] 404 Not found: "..request, "EI", 2)
				tFuncs:Debug(tUser:GetDataLine(sid).."[WEB Login] User ("..nicks..") requesting: "..request.." / Ignored")

--~ 							if not tFuncs:IsProtected(client.sIP) then
--~ 								tBans.autoban[client.sIP] = os.time() + 7200	--// Add a timeout for this IP of 2 hours
--~ 								--// don't remove the IP from log yet, to be able to get info on the IP
--~ 								tLogs.IP[client.sIP] = nil	--// Remove this IP from log to prevent table overflow with a lot of IP's connecting, NOTE: this might give errors if IP is in hub with normal status
--~ 							end		
--~ 								tFuncs:Debug(tUser:GetDataLine(sid).."[Invalid Connection] Message: "..parsetxt)
--~ 								tSend:IntervalMessage("[Invalid Connection] [%t] IP: "..client.sIP.." Message: %s", 300, "FR", "AAAA", nil, parsetxt)
--~ 								parsetxt = nil
--~ 								client.iActive = 0
			end
			
		else
--~ 			tSend:Raw(sid, "<html><BR>To be able to view this page you'll need to be connected to <A HREF=\"adc://text.flexhub.org:8000\">this hub</A> first.</html>")
			tUser:Disconnect(sid, "HTTP/1.1 401 To be able to view this page you'll need to be connected to adc://text.flexhub.org:8000 first.", "[WEB] Unauthorized access")

			tSend:IntervalMessage("[WEB Login] [%t] IP: "..client.sIP.." tried to access webpage without a connected client in the hub, access denied", 300, "FR", "AAAA", nil, parsetxt)
			client.iActive = 0			
		end
		return client
	end,
}
