--[[

	FlexHub is a server-software for the Direct Connect P2P Network.

	Copyright (C) 2011 Daywalker and FlipFlop, dev@flexhub.org

    This file is part of FlexHub.

    FlexHub is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FlexHub is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with FlexHub.  If not, see <http://www.gnu.org/licenses/agpl.txt>.


]]--

SecureSocket = function(client, sid)
	local pref = "[TLS] SID: "..sid.." IP: "..client.sIP.." <> "
	local err = ""

	client.xSocket, err = ssl.wrap(client.xSocket, tGlobals.SecureSocketContext)
	if client.xSocket then
		--// Perform TLS handshake
		client.xSocket:settimeout((tSettings.TcpSocketSendTimeout or 0), (tSettings.TcpSocketSendTimeoutMode or "t"))
		return true, client
	else
		tLogs.Errors.SSLWrap = tLogs.Errors.SSLWrap + 1
		tFuncs:Debug(pref.."SSL Wrapping failed: "..tostring(err) .." : Please report this error to the FlexHub Devs!", nil, -1)
		return false, client
	end
end

	-- // try and init this once instead of reloading it each time
SecureSocketInit = function()
	local params = {
		mode = "server",
		protocol = "sslv23",
--		protocol = "tls1",
		key = "./certificates/key.pem",
		certificate = "./certificates/cert.pem",
--		cafile = "./certificates/cert.pem",
--		verify = {"none"},
		options = {"all"},
	}

	local err = ""
	tGlobals.SecureSocketContext, err = ssl.newcontext(params)
	if not tGlobals.SecureSocketContext then
		tFuncs:Debug("Error creating secure socket context: "..err, nil, -1)
		return false, err
	else
		return true
	end
end
