--[[

	FlexHub is a server-software for the Direct Connect P2P Network.

	Copyright (C) 2011 Daywalker and FlipFlop, dev@flexhub.org

    This file is part of FlexHub.

    FlexHub is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FlexHub is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with FlexHub.  If not, see <http://www.gnu.org/licenses/agpl.txt>.


]]--

-----------------------------------------------------------------------------
-- simple listen script by Daywalker
-----------------------------------------------------------------------------

-- settings
Inf = {
Bot = "$Inform",
OpNick = "Daywalker",
}

OnStartup = function()
	OnError("OSU: script started|")
end

OnExit = function()					-- Is called on script exit.
	OnError("OE: script stopped|")
end

OnTimer = function(nTimerId)				-- Default function called by timer on given interval.
end

UserConnected = function(user)				-- Is called when user finish login sequence.
	OnError("UC: "..user.sNick)
end

UserDisconnected = function(user)				-- Is called when user disconnect or was disconnected.
	OnError("UDC: "..user.sNick)
end

RegConnected = function(user)				-- Is called when reg finish login sequence.
	OnError("RC: "..user.sNick)
end

RegDisconnected = function(user)				-- Is called when reg disconnect or was disconnected.
	OnError("RDC: "..user.sNick)
end

OpConnected = function(user)				-- Is called when operator finish login sequence.
	OnError("OC: "..user.sNick)
end

OpDisconnected = function(user)				-- Is called when operator disconnect or was disconnected.
	OnError("ODC: "..user.sNick)
end

OnError = function(sErrorMsg)				-- Is called when error was found in script.
	--Core.SendToNick(Inf.OpNick,"<"..Inf.Bot.."> "..sErrorMsg)
	Core.SendToAll("<"..Inf.Bot.."> "..sErrorMsg)
end

SupportsArrival = function(user, data)			-- Incoming supports from user.
	OnError("Sup: "..user.sNick.." - "..data)
end

ChatArrival = function(user, data)			-- Incoming chat message from user. If script return true hub don't process data.
	OnError("CA: "..user.sNick.." - "..data)
end

KeyArrival = function(user, data)			-- Incoming key from user.
	OnError("Key: "..user.sNick.." - "..data)
end

ValidateNickArrival = function(user, data)		-- Incoming validate nick from user.
	OnError("Val: "..user.sNick.." - "..data)
end

PasswordArrival = function(user, data)			-- Incoming password from user.
	OnError("Pas: "..user.sNick.." - "..data)
end

VersionArrival = function(user, data)			-- Incoming version from user.
	OnError("Ver: "..user.sNick.." - "..data)
end

GetNickListArrival = function(user, data)		-- Incoming get nick list request from user. If script return true hub don't process data.
	OnError("GNL: "..user.sNick.." - "..data)
end

MyINFOArrival = function(user, data)			-- Incoming user myinfo.
	OnError("MIA: "..user.sNick.." - "..data)
end

GetINFOArrival = function(user, data)			-- Incoming get info request from user. If script return true hub don't process data.
	OnError("GIA: "..user.sNick.." - "..data)
end

SearchArrival = function(user, data)			-- Incoming search request from user. If script return true hub don't process data.
    if not user then user = {["sNick"] = "No user found"} end
    if not data then data = "No data found" end
    print("Executing external script", getfenv(0))
    print("SearchArrival: "..user.sNick.." - "..data)
end

MultiSearchArrival = function(user, data)		-- Incoming multi search request from user. If script return true hub don't process data.
	OnError("MSA: "..user.sNick.." - "..data)
end

ToArrival = function(user, data)				-- Incoming private message from user. If script return true hub don't process data.
    if not user then user = {["sNick"] = "No user found"} end
    if not data then data = "No data found" end
    print("Executing external script", getfenv(0))
    print("ToArrival: "..user.sNick.." - "..data)
end

ConnectToMeArrival = function(user, data)		-- Incoming active connection request from user. If script return true hub don't process data.
	OnError("CTM: "..user.sNick.." - "..data)
end

MultiConnectToMeArrival = function(user, data)		-- Incoming multi connection request from user. If script return true hub don't process data.
	OnError("MCTM: "..user.sNick.." - "..data)
end

RevConnectToMeArrival = function(user, data)		-- Incoming pasive connection request from user. If script return true hub don't process data.
	OnError("RevCTM: "..user.sNick.." - "..data)
end

SRArrival = function(user, data)				-- Incoming search reply from user. If script return true hub don't process data.
	OnError("SRA: "..user.sNick.." - "..data)
end

UDPSRArrival = function(user, data)			-- Incoming search reply from user. If script return true hub don't process data.
	OnError("UDPA: "..user.sNick.." - "..data)
end

KickArrival = function(user, data)			-- Incoming kick command from user. If script return true hub don't process data.
	OnError("KA: "..user.sNick.." - "..data)
end

OpForceMoveArrival = function(user, data)		-- Incoming redirect command from user. If script return true hub don't process data.
	OnError("OFA: "..user.sNick.." - "..data)
end

UnknownArrival = function(user, data)			-- Incoming unknown command from user. If script return true hub don't process data (don't disconnect user).
	OnError("UKA: "..user.sNick.." - "..data)
end

BotINFOArrival = function(user, data)			-- Incoming hublist pinger request from user. If script return true hub don't process data.
	OnError("BIA: "..user.sNick.." - "..data)
end

CloseArrival = function(user, data)	
	OnError("CA: "..user.sNick.." - "..data)
end

